--- code for the editor ---

ex, ey = 0, 0
local eWidth, eHeight = 1, 1
local eGeoType, eTile = 1, 2
local eEditObjects = false
function handle_editor()
    djui_hud_set_color(255, 255, 255, 100)

    local m = gMarioStates[0]
    local smb0 = gSMBStates[0]
    local cameraBlockX = (smb0.cameraX // PX)
    local cameraBlockY = (smb0.cameraY // PX)
    local width = 17
    local height = 13

    if m.controller.buttonPressed & Y_BUTTON ~= 0 then
        eEditObjects = not eEditObjects
        eWidth, eHeight = 1, (eEditObjects and 0) or 1
        eGeoType, eTile = (eEditObjects and 0) or 1, (eEditObjects and 0) or 2
    end

    if not eEditObjects then
        local temp_level_geo = loaded_tile_data
        loaded_tile_data = {theme = temp_level_geo.theme, width = temp_level_geo.width, palette = temp_level_geo.palette}
        if m.controller.buttonDown & L_TRIG == 0 and m.controller.buttonDown & R_TRIG == 0 then
            if m.controller.buttonPressed & R_CBUTTONS ~= 0 then
                ex = (ex + 1) % width
            elseif m.controller.buttonPressed & L_CBUTTONS ~= 0 then
                ex = (ex - 1) % width
            elseif m.controller.buttonPressed & U_CBUTTONS ~= 0 then
                ey = (ey + 1) % height
            elseif m.controller.buttonPressed & D_CBUTTONS ~= 0 then
                ey = (ey - 1) % height
            end
        elseif m.controller.buttonDown & L_TRIG ~= 0 then
            if m.controller.buttonPressed & R_CBUTTONS ~= 0 then
                eWidth = eWidth + 1
            elseif m.controller.buttonPressed & L_CBUTTONS ~= 0 then
                eWidth = eWidth - 1
            elseif m.controller.buttonPressed & U_CBUTTONS ~= 0 then
                eHeight = eHeight - 1
            elseif m.controller.buttonPressed & D_CBUTTONS ~= 0 then
                eHeight = eHeight + 1
            end
            if eWidth < 0 then eWidth = 0 end
            if eHeight < 0 then eHeight = 0 end
        else
            local change = 1
            if m.controller.buttonDown & X_BUTTON ~= 0 then
                change = 16
            end
            if m.controller.buttonPressed & R_CBUTTONS ~= 0 then
                eTile = eTile + change
            elseif m.controller.buttonPressed & L_CBUTTONS ~= 0 then
                eTile = eTile - change
            elseif m.controller.buttonPressed & U_CBUTTONS ~= 0 then
                eGeoType = (eGeoType - change) % (#geo_cmd_funcs_g + 1)     
            elseif m.controller.buttonPressed & D_CBUTTONS ~= 0 then
                eGeoType = (eGeoType + change) % (#geo_cmd_funcs_g + 1)
            end
        end

        local x, y = ex + cameraBlockX, ey + cameraBlockY

        -- run once if width or height are 0 (these commands don't actually use these as width/height)
        local geo_command = {eGeoType, eTile, eWidth, eHeight}
        if geo_command[3] == 0 or geo_command[4] == 0 then
            geo_cmd_funcs_g[geo_command[1]](x, y, x, y, geo_command)
        else
            for x2 = x, x + geo_command[3] - 1 do
                local breakX = false
                for y2 = y, y - geo_command[4] + 1, -1 do
                    if geo_cmd_funcs_g[geo_command[1]](x, y, x2, y2, geo_command) then
                        breakX = true
                        break
                    end
                end
                if breakX then break end
            end
        end
        
        if eGeoType == 0 then
            print_text_nes(tostring(eWidth), x * PX, NES_HEIGHT - (y + 1) * PX, 1)
            print_text_nes(tostring(eHeight), (x+0.5) * PX, NES_HEIGHT - (y + 1) * PX, 1)
            local frame = get_tile_frame(eTile)
            if (not frame) or frame == -1 then
                print_text_nes(hexString(tile), x * PX, NES_HEIGHT - (y + 1) * PX, 2)
            else
                render_texture_nes_collection("smb_tileset", x * PX, NES_HEIGHT - (y + 1) * PX, 1, 1, frame)
            end
        elseif eGeoType == 5 then
            local width = math.max(eWidth, 1)
            for tx=x,x+width-1 do
                local ty = y
                print_text_nes("@", tx * PX, NES_HEIGHT - (ty + 1) * PX, 2)
            end
        else
            local width = math.max(eWidth, 1)
            local height = math.max(eHeight, 1)
            for tx=x,x+width-1 do
                for ty=y,y-height+1,-1 do
                    --djui_chat_message_create(tostring(x)..", "..tostring(y))
                    local tile = get_tile_at_block(tx, ty, true)
                    --djui_chat_message_create(tostring(tile))
                    if tile ~= 0 then
                        local frame = get_tile_frame(tile)
        
                        if (not frame) or frame == -1 then
                            print_text_nes(hexString(tile), tx * PX, NES_HEIGHT - (ty + 1) * PX, 1)
                        else
                            render_texture_nes_collection("smb_tileset", tx * PX, NES_HEIGHT - (ty + 1) * PX, 1, 1, frame)
                            print_text_nes(hexString(tile), tx * PX, NES_HEIGHT - (ty + 1) * PX, 1)
                        end
                    end
                end
            end
        end

        loaded_tile_data = temp_level_geo
        if m.controller.buttonPressed & Z_TRIG ~= 0 then
            local level, area = gNetworkPlayers[0].currActNum, gNetworkPlayers[0].currAreaIndex
            local geo_data = geometry_data_g[level] and geometry_data_g[level][area]
            if geo_data == nil then
                level, area = 26, 2
                geo_data = geometry_data_g[level] and geometry_data_g[level][area]
            end
            if m.controller.buttonDown & L_TRIG ~= 0 then
                add_to_2d_table(geo_data, x, y, nil)
            else
                add_to_2d_table(geo_data, x, y, geo_command)
            end
            process_geometry_data(level, area)
        end
    else
        local curr_obj_table = obj_data_g[gNetworkPlayers[0].currActNum] and obj_data_g[gNetworkPlayers[0].currActNum][gNetworkPlayers[0].currAreaIndex]
        if not curr_obj_table then
            curr_obj_table = obj_data_g[26][2]
        end
        if m.controller.buttonDown & L_TRIG == 0 and m.controller.buttonDown & R_TRIG == 0 then
            if m.controller.buttonPressed & R_CBUTTONS ~= 0 then
                ex = (ex + 1) % width
            elseif m.controller.buttonPressed & L_CBUTTONS ~= 0 then
                ex = (ex - 1) % width
            elseif m.controller.buttonPressed & U_CBUTTONS ~= 0 then
                ey = (ey + 1) % height
            elseif m.controller.buttonPressed & D_CBUTTONS ~= 0 then
                ey = (ey - 1) % height
            end
        elseif m.controller.buttonDown & L_TRIG ~= 0 then
            if m.controller.buttonPressed & R_CBUTTONS ~= 0 then
                eWidth = eWidth + 1
            elseif m.controller.buttonPressed & L_CBUTTONS ~= 0 then
                eWidth = eWidth - 1
            elseif m.controller.buttonPressed & U_CBUTTONS ~= 0 then
                eTile = eTile - 1
            elseif m.controller.buttonPressed & D_CBUTTONS ~= 0 then
                eTile = eTile + 1
            end
            if eWidth < 0 then eWidth = 0 end
            if eTile < 0 then eTile = 0 end
        else
            local change = 1
            if m.controller.buttonDown & X_BUTTON ~= 0 then
                change = 256
            end

            if m.controller.buttonPressed & R_CBUTTONS ~= 0 then
                eHeight = eHeight + change
            elseif m.controller.buttonPressed & L_CBUTTONS ~= 0 then
                eHeight = eHeight - change
            elseif m.controller.buttonPressed & U_CBUTTONS ~= 0 then
                eGeoType = eGeoType + change
            elseif m.controller.buttonPressed & D_CBUTTONS ~= 0 then
                eGeoType = eGeoType - change
            end

            if eHeight < 0 then eHeight = 0 end
            if eGeoType < 0 then eGeoType = 0 end
        end

        local params = (eGeoType << 16) + eHeight
        local x, y = ex + cameraBlockX, ey + cameraBlockY
        local o_id, spriteInfo
        local i = 0
        for thisId, thisSpriteInfo in pairs(OBJECT_SPRITE_INFO) do
            if eTile == i then
                o_id, spriteInfo = thisId, thisSpriteInfo
                break
            end
            i = i + 1
        end
        
        if o_id then
            local xOffset = spriteInfo[7] or 0
            local yOffset = spriteInfo[8] or 0
            xOffset = xOffset * PX
            yOffset = yOffset * PX

            if params ~= 0 then
                print_text_nes(string.format("%08x", params), x * PX + xOffset // PX, NES_HEIGHT - (y + 1) * PX, 1)
            end
            if eWidth <= 1 then
                render_fake_smb_object((x + 0.5) * BLOCK + xOffset, y * BLOCK + yOffset, spriteInfo)
            else -- object group
                local x2 = x
                for i=1,eWidth do
                    render_fake_smb_object((x2 + 0.5) * BLOCK + xOffset, y * BLOCK + yOffset, spriteInfo)
                    
                    x2 = x2 + 1.5
                end
            end
            print_text_nes(get_behavior_name_from_id(o_id):sub(7), x * PX + xOffset // PX, NES_HEIGHT - (y + 1.25) * PX, 0.5)
        end
        
        for tx=cameraBlockX,cameraBlockX+width-1 do
            for ty=0,height do
                local this_obj_data = curr_obj_table[tx] and curr_obj_table[tx][ty]
                local o_id = this_obj_data and this_obj_data[1]
                if o_id then
                    local spriteInfo = OBJECT_SPRITE_INFO[o_id]
                    local xOffset = spriteInfo[7] or 0
                    local yOffset = spriteInfo[8] or 0
                    xOffset = xOffset * PX
                    yOffset = yOffset * PX
                    
                    if this_obj_data[3] and this_obj_data[3] ~= 0 then
                        print_text_nes(string.format("%08x", this_obj_data[3]), tx * PX + xOffset // PX, NES_HEIGHT - (ty + 1) * PX, 1)
                    end
                    
                    if this_obj_data[2] <= 1 then
                        render_fake_smb_object((tx + 0.5) * BLOCK + xOffset, ty * BLOCK + yOffset, spriteInfo)
                    else -- object group (used for goombas and buzzy beetles)
                        local tx2 = tx
                        for i=1,this_obj_data[2] do
                            render_fake_smb_object((tx2 + 0.5) * BLOCK + xOffset, ty * BLOCK + yOffset, spriteInfo)
                            
                            tx2 = tx2 + 1.5
                        end
                    end

                    if this_obj_data[4] then
                        print_text_nes("H", (tx + 0.5) * PX + xOffset // PX, NES_HEIGHT - ty * PX - 7, 1)
                    end
                    print_text_nes(get_behavior_name_from_id(o_id):sub(7), tx * PX + xOffset // PX, NES_HEIGHT - (ty + 1.25) * PX, 0.5)
                end
            end
        end

        if m.controller.buttonPressed & Z_TRIG ~= 0 then
            if m.controller.buttonDown & L_TRIG ~= 0 then
                add_to_2d_table(curr_obj_table, x, y, nil)
            else
                local hardMode = (m.controller.buttonDown & R_TRIG ~= 0)
                add_to_2d_table(curr_obj_table, x, y, {o_id, eWidth, params, hardMode})
            end
        end
    end
end