-- name: So Retro!
-- incompatible: romhack
-- category: romhack
-- description: Get ready for a nostalgia overload! This 10 star hack contains inspiration from Super Mario Bros. for the NES!\n\\#ff5\\Mod by \\#f8f\\EmilyEmmi\n\n\\#f55\\NOTE: This mod doesn't work well with movesets, game modes, character select, and many other mods.\n\n\\#ff5\\Super Mario Bros. SFX rips:\n\\#ffffff\\https://themushroomkingdom.net \n\\#ff5\\SMB music rips:\n\\#ffffff\\KH Insider\n\\#ff5\\Sprite Rips:\n\\#ffffff\\SuperJustinBros (SMB1)\nRandomTalkingBush (SMM2)\n\\#ff5\\Custom Sprites (Mario Fan Games Galaxy):\n\\#ffffff\\KrystalPhantasm (Luigi)\nC. Pariah (Wario and Waluigi)
-- pauseable: true


-- Hi there! If you haven't loaded this mod yet, you should do that real quick. Looking at this code will spoil the surprise!
-- If you have, feel free to explore! This mod is very complex, as you probably expect.
-- SCROLL DOWN FOR THE CODE


























-- Alright, here's the code.

-- basic romhack stuff
LEVEL_SMB = LEVEL_BOB
gLevelValues.exitCastleLevel = LEVEL_CASTLE_GROUNDS
gLevelValues.exitCastleWarpNode = 0x0A
smlua_text_utils_dialog_replace(DIALOG_001, 0, 6, 0, 200,
    "Hey! It's me, Toad!\n"..
    "I have this weird sickness\n"..
    "that makes me sound like\n"..
    "a Bob-Omb, sorry.\n\n"..
    "We need your help!\n"..
    "Bowser has stolen the\n"..
    "64 Bit Rod and turned\n"..
    "everyone 8-bit!\n"..
    "You need to go through\n"..
    "this nostalgia overload\n"..
    "to stop him!\n"..
    "Before you go, here's\n"..
    "some helpful tips:\n\n"..
    "Be sure to turn off\n"..
    "anti-aliasing to prevent\n"..
    "rendering issues.\n"..
    "Also turn on\n"..
    "\'Alt star effect\' in\n"..
    "the mod menu if you are\n"..
    "sensitive to flashing\n"..
    "lights (Pause, and then\n"
    .."Press R).\n"..
    "Good luck! This quest\n"..
    "will be so retro!"
)
smlua_text_utils_course_name_replace(COURSE_BOB, "So Retro!")

-- options
gGlobalSyncTable.allowBackwards = false
gGlobalSyncTable.modernPowerStyle = false
gGlobalSyncTable.allowWorldSelect = false
gGlobalSyncTable.hardMode = false
gGlobalSyncTable.disableTimer = false
gGlobalSyncTable.altSpinyEggBehavior = false
localOptionTable = {}
localOptionTable.nonFlashStar = false
localOptionTable.debugColliders = false
localOptionTable.debugHitboxes = false
localOptionTable.debugFrameByFrame = false
localOptionTable.debugHalfSpeed = false
localOptionTable.debugEditor = false
localOptionTable.debugBubble = false

gGlobalSyncTable.coins = 0
gGlobalSyncTable.topWorld = 0

-- values which are synced
local sync_smb_fields = {
    "initialJumpXVel",
    "gravity",
    "holdAGravity",
    "isBig",
    "powerup",
    "crouch",
    "fireBallTimer",
    "cameraX",
    -- "cameraY",
    "paused",
    "starTimer",
    "tempScrollStop",
    "frenzyDisabled",
    "loopScreenRight",
    "loopScreenLeft",
}

-- custom values
gSMBStates = {}
for i=0,MAX_PLAYERS-1 do
    gSMBStates[i] = {}
    local smb = gSMBStates[i]
    smb.initialJumpXVel = 0
    smb.gravity = 0
    smb.holdAGravity = 0
    smb.isBig = false
    smb.powerup = 0
    smb.starTimer = 0
    smb.crouch = false
    smb.walkCycleFrame = 0
    smb.fireBallTimer = 0
    smb.cameraX = 0
    smb.cameraY = 0
    smb.points = 0
    smb.combo = 0
    smb.paused = false
    smb.timer = 0
    smb.timerInterval = 0
    smb.platform = nil
    smb.fadeTimer = 0
    smb.tempScrollStop = 0
    smb.prevAnimFrame = 0
    smb.frenzyDisabled = false
    smb.inWhirlpool = false
    smb.airBubbleTimer = 0
    smb.loopScreenRight = 0
    smb.loopScreenLeft = 0
    if network_is_server() or i == 0 then
        local sMario = gPlayerSyncTable[i]
        for a,field in ipairs(sync_smb_fields) do
            sMario[field] = smb[field]
        end
    end
end

-- local values
pipeEntranceScreen = 0
pipeEntranceArea = 0
entranceType = 0
bonusExitScreen = 0
doBonusExit = false
doUpwardPipe = false
respawnArea = 1
checkpointScreen = 0
lastAct = -1
pauseDelayTimer = 0
frameByFrameActiveTimer = 2
timeStopEnabled = false
startWorld = 1
localPressStart = false
dontRenderTime = 0
topScore = math.floor(mod_storage_load_number("topScore"))
timeUpDeath = false
warpZoneActive = false
warpZoneData = {36, 5, 36} -- default
checkFirstHereStatus = -1
recentlyLoaded = {}
waitForLoop = false
smbMenuOption = 0
local justDidReset = false

-- texture files used for each character
PLAYER_TEX = {
    {get_texture_info("mario_0"), get_texture_info("mario_1")},
    {get_texture_info("luigi_0"), get_texture_info("luigi_1")},
    {get_texture_info("toad_0"), get_texture_info("toad_1")},
    {get_texture_info("waluigi_0"), get_texture_info("waluigi_1")},
    {get_texture_info("wario_0"), get_texture_info("wario_1")},
}
TEX_BUBBLE = get_texture_info("bubble")

-- other palettes during star (ported from smb)
STAR_PALETTES = {
    {{r = 0xFF, g = 0xFE, b = 0xFF}, {r = 0xEA, g = 0x9E, b = 0x22}, {r = 0x0C, g = 0x93, b = 0x00}},
    {{r = 0xFF, g = 0xFE, b = 0xFF}, {r = 0xEA, g = 0x9E, b = 0x22}, {r = 0xB5, g = 0x31, b = 0x20}},
    {{r = 0xFE, g = 0xCC, b = 0xC5}, {r = 0x99, g = 0x4E, b = 0x00}, {r = 0x00, g = 0x00, b = 0x00}},
}

FONT_SMB = get_texture_info("smb_font")
TITLE_TEX = get_texture_info("title")

-- render the game
setup_game_size()
function render_game()
    local np = gNetworkPlayers[0]
    if np.currLevelNum ~= LEVEL_SMB then return end
    djui_hud_set_resolution(RESOLUTION_N64)
    hud_hide()
    
    setup_game_size()

    if dontRenderTime ~= 0 then
        dontRenderTime = dontRenderTime - 1
        djui_hud_set_color(0, 0, 0, 255)
        djui_hud_render_rect(0, 0, screenWidth, screenHeight)
        if dontRenderTime <= 5 then
            if dontRenderTime == 5 then
                play_smb_sound_stream(gMarioStates[0].pos, "jumpSmall", true)
            elseif dontRenderTime == 0 then
                play_smb_sound_stream(gMarioStates[0].pos, "bump", true)
                audio_sample_stop(SMB_SOUNDS["jumpSmall"])
            end
            djui_hud_set_color(0, 100, 0, 255) -- dark green near end
            djui_hud_render_rect(leftEdge, topEdge, gameWidth, gameHeight)
        end
        return
    end

    -- override with status screen
    local m0 = gMarioStates[0]
    if m0.action == ACT_SMB_LOADING then
        djui_hud_set_color(0, 0, 0, 255)
        djui_hud_render_rect(0, 0, screenWidth, screenHeight)

        djui_hud_set_color(255, 255, 255, 255)

        if timeUpDeath then
            print_text_nes("Time Up", 0x60, 0x80, 1, true)
            return
        elseif m0.actionArg == 1 then
            print_text_nes("Game Over", 0x58, 0x80, 1, true)
            return
        end

        local world = tostring((np.currActNum-1) // 4 + 1)
        local level = (np.currActNum - 1) % 4 + 1
        if world == "36" then world = " " end
        print_text_nes("World "..world.."-"..level, 0x58, 0x50, 1, true)

        render_smb_player(m0, true)
        djui_hud_set_color(255, 255, 255, 255)
        local livesString = tostring(m0.numLives)
        if m0.numLives < 10 then
            livesString = " " .. livesString
        elseif m0.numLives < 20 then
            livesString = "*"..tostring(m0.numLives - 10)
        end
        print_text_nes("@ "..livesString, 0x78, 0x70, 1, true)

        -- render hud in status screen
        render_game_hud()
        return
    end

    -- sky
    if loaded_tile_data and loaded_tile_data.theme then
        if loaded_tile_data.theme == 0 or loaded_tile_data.theme == 3 or loaded_tile_data.theme == 4 then
            djui_hud_set_color(0x92, 0x90, 0xFF, 255)
        else
            djui_hud_set_color(0, 0, 0, 255)
        end
        if loaded_tile_data.bg == 4 then
            -- render sky and water (water surface tiles are placed by z_levels.lua)
            djui_hud_render_rect(leftEdge, topEdge, gameWidth, PX * 2 * 5 * gameScaleY)
            djui_hud_set_color(0x42, 0x42, 0xff, 255)
            djui_hud_render_rect(leftEdge, topEdge + PX * 2.5 * gameScaleY, gameWidth, gameHeight - PX * 2.5 * gameScaleY)
        else
            djui_hud_render_rect(leftEdge, topEdge, gameWidth, gameHeight)
        end
    end

    -- render sprites that are behind tiles
    local laterRenderObj = {}
    djui_hud_set_color(255, 255, 255, 255)
    for i,objList in ipairs(VALID_OBJ_LISTS) do
        local o = obj_get_first(objList)
        while o do
            local o_id = get_id_from_behavior(o.behavior)
            local spriteInfo = OBJECT_SPRITE_INFO[o_id]
            if spriteInfo and spriteInfo[1] and obj_is_hidden(o) == 0 then
                -- store for later if this object is set to render in front
                -- otherwise, render now
                if o.oRenderBehindFloor == nil or o.oRenderBehindFloor == 0 then
                    table.insert(laterRenderObj, o)
                else
                    render_smb_object(o)
                end
            end
            o = obj_get_next(o)
        end
    end

    -- render players that are behind tiles (in reverse so that lower indices are on top)
    local laterRenderPlayer = {}
    for i=MAX_PLAYERS-1,0,-1 do
        local m = gMarioStates[i]
        if is_player_active_and_synced(m) ~= 0 then
            -- store for later if this the player isn't in a pipe action
            -- otherwise, render now
            if m.action ~= ACT_SMB_IN_PIPE and (m.action ~= ACT_SMB_ENTER_SIDE_PIPE or m.actionArg == 0) and (m.action ~= ACT_SMB_WALK_CUTSCENE or m.actionArg ~= 0 or m.actionState ~= 1) then
                table.insert(laterRenderPlayer, m)
            else
                render_smb_player(m)
            end
        else
            gSMBStates[i].fadeTimer = 20
        end
    end

    -- Render tiles
    djui_hud_set_color(255, 255, 255, 255)
    local smb0 = gSMBStates[0]
    local cameraBlockX = (smb0.cameraX // PX)
    local cameraBlockY = (smb0.cameraY // PX)
    local width = 17
    local height = 13
    for x=cameraBlockX,cameraBlockX+width do
        -- rendering trickery; if beyond loop point, render back some screens
        local rx = x
        if smb0.loopScreenRight ~= 0 then
            if rx >= smb0.loopScreenRight * 16 then
                rx = rx - (smb0.loopScreenRight - smb0.loopScreenLeft) * 16
            elseif rx < smb0.loopScreenLeft * 16 then
                rx = rx + (smb0.loopScreenRight - smb0.loopScreenLeft) * 16
            end
        end
        for y=cameraBlockY,cameraBlockY+height do
            local tile = get_tile_at_block(rx, y, true)
            if tile ~= 0 then
                local frame = get_tile_frame(tile)

                if not frame then
                    print_text_nes(hexString(tile), x * PX, NES_HEIGHT - (y + 1) * PX, 1)
                elseif frame ~= -1 then
                    render_texture_nes_collection("smb_tileset", x * PX, NES_HEIGHT - (y + 1) * PX, 1, 1, frame)
                end
            end
            if localOptionTable.debugEditor and x % 16 == 0 and y == cameraBlockY+height then
                djui_hud_set_color(0, 0, 255, 100)
                render_rect_nes(x * PX, 2 * PX, 8, height * PX)
                djui_hud_set_color(255, 255, 255, 255)
            end
        end
    end

    -- the hud renders *BEHIND* sprites in smb1
    render_game_hud()

    -- render sprites that are in front of tiles
    djui_hud_set_color(255, 255, 255, 255)
    for i,o in ipairs(laterRenderObj) do
        render_smb_object(o)
    end

    -- render players that are behind tiles (in reverse so that lower indices are on top)
    local doNametagsFor = {}
    for i,m in ipairs(laterRenderPlayer) do
        if render_smb_player(m) and (m.action ~= ACT_SMB_WALK_CUTSCENE or m.actionState == 0) then
            table.insert(doNametagsFor, 1, m)
        end
    end

    if gMarioStates[0].action == ACT_SMB_BUBBLED then
        local m = gMarioStates[0]
        local x, y = m.pos.x // PX, (m.pos.y // PX) + 32
        local text = tostring(m0.numLives)
        if m0.numLives < 10 then
            text = " " .. text
        elseif m0.numLives < 20 then
            text = "*"..tostring(m0.numLives - 10)
        end
        text = ">@" .. text
        local scale = 1
        local width = #text * 8 * scale
        x = x - width / 2
        djui_hud_set_color(255, 255, 255, 255)
        print_text_nes(text, x, NES_HEIGHT - y, scale)
    end
    -- nametags
    if gServerSettings.nametags ~= 0 then
        for i,m in ipairs(doNametagsFor) do
            if m.playerIndex ~= 0 or gNametagsSettings.showSelfTag then
                local smb = gSMBStates[m.playerIndex]
                local x, y = m.pos.x // PX, (m.pos.y // PX) + 24
                if smb.isBig and m.action ~= ACT_SMB_DEAD then
                    y = y + 16
                end
                local name = get_uncolored_string(gNetworkPlayers[m.playerIndex].name)
                local scale = 1
                djui_hud_set_font(FONT_SPECIAL)
                local width = djui_hud_measure_text(name) * scale / 4
                x = x - width / 2
                local colorString = network_get_player_text_color_string(m.playerIndex)
                local r = tonumber("0x"..colorString:sub(3, 4)) or 255
                local g = tonumber("0x"..colorString:sub(5, 6)) or 255
                local b = tonumber("0x"..colorString:sub(7, 8)) or 255
                djui_hud_set_color(r, g, b, 255)
                print_text_nes(name, x, NES_HEIGHT - y, scale, false, true)
                -- render tags in loop
                if smb0.loopScreenRight ~= 0 then
                    print_text_nes(name, x + (smb0.loopScreenRight - smb0.loopScreenLeft) * 16 * PX, NES_HEIGHT - y, scale, false, true)
                    print_text_nes(name, x - (smb0.loopScreenRight - smb0.loopScreenLeft) * 16 * PX, NES_HEIGHT - y, scale, false, true)
                end
            end
        end
    end

    -- black borders
    djui_hud_set_color(0, 0, 0, 255)
    if leftEdge ~= 0 then
        djui_hud_render_rect(0, 0, leftEdge, screenHeight + 10)
        djui_hud_render_rect(rightEdge, 0, screenWidth, screenHeight)
    elseif topEdge ~= 0 then
        djui_hud_render_rect(0, 0, screenWidth, topEdge)
        djui_hud_render_rect(0, bottomEdge, screenWidth, screenHeight)
    end

    -- editor
    if localOptionTable.debugEditor then
        handle_editor()
    end

    -- pause menu
    if smb0.paused then
        djui_hud_set_color(0, 0, 0, 100)
        djui_hud_render_rect(leftEdge, topEdge, gameWidth, gameHeight)
        djui_hud_set_color(255, 255, 255, 255)
        print_text_nes("Paused", 0x68, 0x60, 1, true)
        local space = 0x10
        local menuOptions = {
            "Continue",
            "Lose 1 Life",
            "Return To Title",
        }
        for i,text in ipairs(menuOptions) do
            if smbMenuOption == i - 1 then
                text = "> " .. text
            else
                text = "  " .. text
            end
            print_text_nes(text, 0x50, 0x78+(space*(i-1)), 1, true)
        end
    end
end
hook_event(HOOK_ON_HUD_RENDER_BEHIND, render_game)

function render_game_hud()
    local np = gNetworkPlayers[0]
    if np.currLevelNum ~= LEVEL_SMB or dontRenderTime ~= 0 then return end
    djui_hud_set_resolution(RESOLUTION_N64)
    local m = gMarioStates[0]
    local smb = gSMBStates[0]

    -- title screen stuff
    if np.currActNum == 0 then
        djui_hud_set_color(255, 255, 255, 255)
        render_texture_nes(TITLE_TEX, 0x28, 0x20, 1, 1)
        djui_hud_set_color(0xFF, 0xCE, 0xC5, 255)
        print_text_nes(":1985 Nintendo", 0x68, 0x78, 1)
        print_text_nes("2025 EmilyEmmi", 0x68, 0x80, 1)
        djui_hud_set_color(255, 255, 255, 255)
        local space = 0x10
        local menuOptions = {
            "New Game",
            "Exit",
        }
        if gGlobalSyncTable.topWorld > 1 then
            table.insert(menuOptions, 1, "Continue")
            space = 0x08
        end
        for i,text in ipairs(menuOptions) do
            if smbMenuOption == i - 1 then
                text = "> " .. text
            else
                text = "  " .. text
            end
            print_text_nes(text, 0x48, 0x98+(space*(i-1)), 1)
        end
        local scoreString = string.format("%06d",topScore)
        if #scoreString < 7 then
            scoreString = " " .. scoreString
        end
        print_text_nes("Top-"..scoreString, 0x60, 0xC0, 1)
    end

    -- HUD
    djui_hud_set_color(255, 255, 255, 255)
    local nameX = 0x18
    local name = m.character.name
    if #name > 6 then
        nameX = nameX - 0x8
    end
    print_text_nes(name, nameX, 0x10, 1, true)
    local scoreString = string.format("%06d",smb.points)
    if #scoreString < 7 then
        scoreString = " " .. scoreString
    end
    print_text_nes(scoreString, 0x10, 0x18, 1, true)
    print_text_nes(string.format("$@%02d", gGlobalSyncTable.coins % 100), 0x58, 0x18, 1, true)
    print_text_nes("World", 0x90, 0x10, 1, true)
    local world = tostring((np.currActNum-1) // 4 + 1)
    local level = (np.currActNum - 1) % 4 + 1
    if np.currActNum == 0 then
        if smbMenuOption ~= 0 or gGlobalSyncTable.topWorld <= 1 then
            world = tostring(startWorld)
        else
            world = tostring(gGlobalSyncTable.topWorld)
        end
        level = 1
    end
    if world == "36" then
        world = " "
    end
    print_text_nes(world.."-"..level, 0x98, 0x18, 1, true)
    print_text_nes("Time", 0xC8, 0x10, 1, true)
    if (not gGlobalSyncTable.disableTimer) and m.action ~= ACT_SMB_LOADING and (m.action ~= ACT_SMB_IN_PIPE or m.actionArg ~= 1) and loaded_tile_data.timer ~= 0 then
        print_text_nes(string.format("%03d", smb.timer), 0xD0, 0x18, 1, true)
    end

    -- warp zone text
    if warpZoneActive then
        djui_hud_set_color(255, 255, 255, 255)
        -- render at the last screen
        local sx = (loaded_tile_data.scrollStop - 15) * PX
        print_text_nes("Welcome to Warp Zone!", sx + 0x20, 0x60, 1)
        local worldX = sx + 0x28
        for i=1,3 do
            local world = tostring(warpZoneData[i])
            if world ~= "36" then
                print_text_nes(world, worldX, 0x88, 1)
            end
            worldX = worldX + 0x40
        end
    end

    -- castle text
    if m.action == ACT_SMB_WALK_CUTSCENE and m.actionArg ~= 0 and m.actionState > 1 then
        djui_hud_set_color(255, 255, 255, 255)
        -- render at the last screen
        local sx = (loaded_tile_data.scrollStop - 15) * PX
        local text = "Thank you "..m.character.name.."!"
        -- force this to be an even number
        if #text % 2 ~= 0 then
            text = text .. " "
        end
        -- center based on character name
        print_text_nes(text, sx + 0x80 - (#text * 4), 0x50, 1)
        if np.currActNum > 28 then
            if m.actionState >= 4 then
                local endingText = {
                    {"Your quest is over.", 0x38, 0x70},
                    {"We present you a new quest.", 0x18, 0x80},
                    {"Enable Second Quest", 0x38, 0x98},
                    {"in Mod Menu", 0x50, 0xA8},
                    --{"Push button B", 0x50, 0x98},
                    --{"To select a world", 0x40, 0xA8},
                }
                for i=1,m.actionState-3 do
                    print_text_nes(endingText[i][1], sx + endingText[i][2], endingText[i][3], 1)
                end
            end
        elseif m.actionState == 3 then
            print_text_nes("But our princess is in", sx + 0x28, 0x70, 1)
            print_text_nes("another castle!", sx + 0x28, 0x80, 1)
        end
    end
end

local isCoopNetOrHost
local prevLastReceivedTable = {}
local prevButtonOverride = {}
function before_mario_update(m, pauseMenu)
    if gNetworkPlayers[0].currLevelNum ~= LEVEL_SMB then return end

    if prevButtonOverride[m.playerIndex] == nil then
        prevButtonOverride[m.playerIndex] = 0
    end

    -- syncing
    local smb = gSMBStates[m.playerIndex]
    local sMario = gPlayerSyncTable[m.playerIndex]
    if m.playerIndex ~= 0 then
        if is_player_active_and_synced(m) ~= 0 then
            local lastReceived = gNetworkPlayers[m.playerIndex].lastReceived
            local prevLastReceived = prevLastReceivedTable[m.playerIndex]

            -- check this only once
            if isCoopNetOrHost == nil then
                isCoopNetOrHost = (network_is_server() or get_coopnet_id(0) ~= "-1")
            end
            
            -- bizzarely, lastReceived does not update properly in direct connection for
            -- non-host players. What.
            if (not isCoopNetOrHost) or prevLastReceived ~= lastReceived then
                prevLastReceivedTable[m.playerIndex] = lastReceived
                for a,field in ipairs(sync_smb_fields) do
                    if sMario[field] ~= nil then
                        smb[field] = sMario[field]
                    end
                end
            end
        end
    else
        for a,field in ipairs(sync_smb_fields) do
            sMario[field] = smb[field]
        end
    end

    -- joystick to d-pad (vertical directions are more sensitive)
    if m.controller.stickX > 32 then
        if prevButtonOverride[m.playerIndex] & R_JPAD == 0 then
            m.controller.buttonPressed = m.controller.buttonPressed | R_JPAD
        end
        m.controller.buttonDown = m.controller.buttonDown | R_JPAD
    elseif m.controller.stickX < -32 then
        if prevButtonOverride[m.playerIndex] & L_JPAD == 0 then
            m.controller.buttonPressed = m.controller.buttonPressed | L_JPAD
        end
        m.controller.buttonDown = m.controller.buttonDown | L_JPAD
    end
    if m.controller.stickY > 48 then
        if prevButtonOverride[m.playerIndex] & U_JPAD == 0 then
            m.controller.buttonPressed = m.controller.buttonPressed | U_JPAD
        end
        m.controller.buttonDown = m.controller.buttonDown | U_JPAD
    elseif m.controller.stickY < -48 then
        if prevButtonOverride[m.playerIndex] & D_JPAD == 0 then
            m.controller.buttonPressed = m.controller.buttonPressed | D_JPAD
        end
        m.controller.buttonDown = m.controller.buttonDown | D_JPAD
    end

    -- ignore left and right if on ground and pressing down
    if m.controller.buttonDown & D_JPAD ~= 0 and m.action & ACT_FLAG_AIR == 0 then
        m.controller.buttonDown = m.controller.buttonDown & ~(L_JPAD | R_JPAD)
    end

    -- prevent left + right and up + down
    if m.controller.buttonDown & (L_JPAD | R_JPAD) == L_JPAD | R_JPAD then
        m.controller.buttonPressed = m.controller.buttonPressed & ~(L_JPAD | R_JPAD)
        m.controller.buttonDown = m.controller.buttonDown & ~(L_JPAD | R_JPAD)
    end
    if m.controller.buttonDown & (U_JPAD | D_JPAD) == U_JPAD | D_JPAD then
        m.controller.buttonPressed = m.controller.buttonPressed & ~(U_JPAD | D_JPAD)
        m.controller.buttonDown = m.controller.buttonDown & ~(U_JPAD | D_JPAD)
    end

    -- X to B
    if m.controller.buttonDown & X_BUTTON ~= 0 then
        m.controller.buttonDown = m.controller.buttonDown | B_BUTTON
    end
    if m.controller.buttonPressed & X_BUTTON ~= 0 then
        m.controller.buttonPressed = m.controller.buttonPressed | B_BUTTON
    end

    if m.playerIndex == 0 then
        localPressStart = false
    end
    if m.playerIndex == 0 and (not smb.paused) and m.controller.buttonPressed & START_BUTTON ~= 0 then
        if pauseDelayTimer == 0 and m.action ~= ACT_SMB_TITLE_SCREEN and m.action ~= ACT_SMB_LOADING and (m.action ~= ACT_SMB_WALK_CUTSCENE or m.actionState < 4) then
            play_smb_sound_stream(m.pos, "pause", true)
            smb.paused = true
            smbMenuOption = 0
            pauseDelayTimer = 20
        end
        localPressStart = true
        m.controller.buttonPressed = m.controller.buttonPressed & ~START_BUTTON
    end

    if (m.playerIndex == 0 and smb.paused) then
        smb_pause_menu(m)
    elseif smb.paused or (m.freeze and m.freeze ~= 0) then
        m.controller.buttonPressed = 0
        m.controller.buttonDown = 0
    end

    prevButtonOverride[m.playerIndex] = m.controller.buttonDown

    -- as it turns out, SM64 actually runs SLOWER than SMB1. Go figure!
    -- so, do mario's actions twice!
    if not (localOptionTable.debugHalfSpeed or pauseMenu) then
        execute_mario_action(m.marioObj)
        mario_update(m, true)
    end
end
hook_event(HOOK_BEFORE_MARIO_UPDATE, before_mario_update)

function mario_update(m, oddFrame)
    local smb = gSMBStates[m.playerIndex]
    local np = gNetworkPlayers[m.playerIndex]
    if np.currLevelNum ~= LEVEL_SMB then
        network_player_set_override_location(np, "")
        return
    end
    if not oddFrame then
        if np.currActNum ~= 0 then
            local worldNum = (np.currActNum-1) // 4 + 1
            local world = tostring(worldNum)
            local level = (np.currActNum - 1) % 4 + 1
            if world == "36" then world = " " end
            network_player_set_override_location(np, "W" .. world .. "-" .. level)
            -- set latest world
            if network_is_server() and (not justDidReset) and worldNum <= 8 and worldNum > gGlobalSyncTable.topWorld then
                gGlobalSyncTable.topWorld = worldNum
                mod_storage_save_number("topWorld", gGlobalSyncTable.topWorld)
            end
        else
            network_player_set_override_location(np, "Title Screen")
        end
    end
    if smb.starTimer ~= 0 then
        smb.starTimer = smb.starTimer - 1
    end

    -- loop point handling
    if smb.loopScreenRight ~= 0 then
        local diff = 0
        if m.pos.x > smb.loopScreenRight * 16 * BLOCK then
            diff = (smb.loopScreenLeft - smb.loopScreenRight) * 16
        elseif m.pos.x <= smb.loopScreenLeft * 16 * BLOCK then
            diff = (smb.loopScreenRight - smb.loopScreenLeft) * 16
        end
        if diff ~= 0 then
            m.pos.x = m.pos.x + diff * BLOCK
            smb.cameraX = smb.cameraX + diff * PX
            if m.playerIndex == 0 then
                waitForLoop = (diff > 0)
            end
        end
    end

    -- update lakitu's position for sound
    if m.playerIndex == 0 then
        camera_freeze()
        vec3f_copy(gLakituState.pos, m.pos)
        vec3f_copy(gLakituState.curPos, m.pos)
        vec3f_copy(gLakituState.goalPos, m.pos)
        vec3f_copy(m.area.camera.pos, m.pos)
        gLakituState.yaw = 0x4000
    end

    -- move mario's visual position for sync objects, because they use that instead of the struct position for some reason...
    vec3f_copy(m.marioObj.header.gfx.pos, m.pos)
    
    m.health = 0x880 -- no health
    m.slideVelX = m.vel.x -- for information display
    m.peakHeight = m.pos.y
    smb.inWhirlpool = false

    if (not smb.crouch) and smb.powerup >= 2 and smb.fireBallTimer ~= 7 and m.controller.buttonPressed & B_BUTTON ~= 0 and m.action & (ACT_FLAG_INTANGIBLE | ACT_FLAG_ON_POLE) == 0 then
        local count = 0
        local fireball = obj_get_first_with_behavior_id(id_bhvSmbFireball)
        while fireball do
            if fireball.globalPlayerIndex == np.globalIndex then
                count = count + 1
            end
            fireball = obj_get_next_with_same_behavior_id(fireball)
        end

        if count < 2 then
            if m.playerIndex == 0 then
                spawn_object_no_rotate(id_bhvSmbFireball, E_MODEL_NONE, m.pos.x + sign(m.faceAngle.y) * 8 * PX, m.pos.y + BLOCK, 0, true, function(o)
                    o.globalPlayerIndex = network_global_index_from_local(0)
                    o.oMoveAngleYaw = m.faceAngle.y
                end)
            end
            smb.fireBallTimer = 8
        end
    end
    if smb.fireBallTimer ~= 0 then
        smb.fireBallTimer = smb.fireBallTimer - 1
    end

    -- spawn bubbles in water
    if m.action & ACT_FLAG_SWIMMING ~= 0 then
        smb.airBubbleTimer = smb.airBubbleTimer - 1
        if smb.airBubbleTimer <= 0 then
            if m.pos.y < NES_HEIGHT * PX - 3 * BLOCK then
                spawn_object_no_rotate(id_bhvSmbAirBubble, E_MODEL_NONE, m.pos.x + sign(m.faceAngle.y) * 4 * PX, m.pos.y + BLOCK, 0, false, nil)
            end
            smb.airBubbleTimer = 0x20 * math.random(1, 2)
        end
    else
        smb.airBubbleTimer = 0x40
    end

    -- pit death
    if m.playerIndex == 0 and m.pos.y < -16 * PX and m.action & ACT_FLAG_INTANGIBLE == 0 then
        if loaded_tile_data.bonusArea then
            -- go back to main stage when jumping out of coin heaven
            set_mario_action(m, ACT_SMB_BONUS_TRANSITION, 0)
        else
            hurt_mario(m, true)
        end
    end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)

function update()
    local np = gNetworkPlayers[0]
    if network_is_server() then
        -- reset coins if everyone is at title or not in-game
        if (np.currLevelNum ~= LEVEL_SMB or np.currActNum == 0) and (gGlobalSyncTable.coins ~= 0 or justDidReset) then
            local someoneIsInGame = false
            for i=0,MAX_PLAYERS-1 do
                local np2 = gNetworkPlayers[i]
                if np2.connected and np2.currLevelNum == LEVEL_SMB and np.currActNum ~= 0 then
                    someoneIsInGame = true
                    break
                end
            end
            if not someoneIsInGame then
                gGlobalSyncTable.coins = 0
                justDidReset = false
            end
        end

        -- reset recently loaded table if the loading is complete
        if #recentlyLoaded ~= 0 then
            local i = 1
            while i <= #recentlyLoaded do
                local data = recentlyLoaded[i]
                local remove = false
                local np2 = gNetworkPlayers[data.index]
                if not np2.connected then
                    remove = true
                    --log_to_console(tostring(np2.globalIndex).." left! Sending emergency load packet...")
                    -- OH NO! The player we assigned to load the sync objects left!
                    -- We must send a packet to whoever is in the level to load the objects
                    for a=0,MAX_PLAYERS-1 do
                        local np3 = gNetworkPlayers[a]
                        if np3.connected and np3.currAreaSyncValid and np3.currLevelSyncValid and np3.currLevelNum == LEVEL_SMB and np3.currActNum == data.levelNum and np3.currAreaIndex == data.area then
                            if a == 0 then
                                on_packet_emergency_load()
                            else
                                network_send_to(a, true, { id = PACKET_EMERGENCY_LOAD })
                            end
                            --log_to_console("Sent emergency load packet to "..tostring(np3.globalIndex))
                            break
                        end
                    end
                elseif np2.currAreaSyncValid and np2.currLevelSyncValid and np2.currLevelNum == LEVEL_SMB and np2.currActNum == data.levelNum and np2.currAreaIndex == data.area then
                    remove = true
                    --log_to_console(tostring(np2.globalIndex).." loaded successfully")
                end

                if remove then
                    table.remove(recentlyLoaded, i)
                else
                    i = i + 1
                end
            end
        end
    end

    if np.currLevelNum ~= LEVEL_SMB then return end

    if pauseDelayTimer ~= 0 then pauseDelayTimer = pauseDelayTimer - 1 end
    if timeStopEnabled then return end

    local smb0 = gSMBStates[0]
    if smb0.points > topScore then
        topScore = smb0.points
        mod_storage_save_number("topScore", topScore)
    end
    if loaded_tile_data.timer ~= 0 and gMarioStates[0].action & ACT_FLAG_INTANGIBLE == 0 and (not gGlobalSyncTable.disableTimer) then
        smb0.timerInterval = smb0.timerInterval + 1
        if smb0.timerInterval >= 12 then
            smb0.timerInterval = 0
            if smb0.timer == 0 then
                timeUpDeath = true
                local m = gMarioStates[0]
                m.numLives = m.numLives - 1
                if mario_can_bubble_smb(m) then
                    smb0.powerup = 0
                    smb0.isBig = false
                    smb0.timer = loaded_tile_data.timer or 400
                    set_music_to_theme()
                    set_mario_action(m, ACT_SMB_BUBBLED, 0)
                else
                    set_mario_action(m, ACT_SMB_DEAD, 0)
                end
            else
                smb0.timer = smb0.timer - 1
                if smb0.timer == 99 then
                    play_smb_sound_stream(gMarioStates[0].pos, "warning", true)
                    playWarningTimer = 3 * 30
                end
            end
        end
    end

    -- lower time for coin brick timers
    for blockX, time in pairs(coin_brick_timer) do
        time = time - ((localOptionTable.debugHalfSpeed and 1) or 2)
        coin_brick_timer[blockX] = time
        if time < 0 then
            coin_brick_timer[blockX] = 0
        end
    end

    -- checkpoint detection
    if loaded_tile_data.checkpoint ~= 0 and checkpointScreen == 0 then
        local m = gMarioStates[0]
        if m.pos.x >= loaded_tile_data.checkpoint * BLOCK * 16 then
            checkpointScreen = loaded_tile_data.checkpoint
        end
    end

    -- "coin toss": interactions are only every other frame
    local oddFrame = false
    if localOptionTable.debugHalfSpeed then
        oddFrame = (get_global_timer() % 2 ~= 0)
    end
    if not oddFrame then
        for i=0,MAX_PLAYERS-1 do
            smb_mario_object_interactions(gMarioStates[i])
        end
    end

    -- object collision
    local validForCollision = {}
    for i,list in ipairs(VALID_OBJ_LISTS_COL) do
        local o = obj_get_first(list)
        while o do
            local o_id = get_id_from_behavior(o.behavior)
            if OBJECT_SPRITE_INFO[o_id] and o.oIntangibleTimer == 0 and o.oSkipObjectInteraction ~= 1 then
                table.insert(validForCollision, o)
            end
            o = obj_get_next(o)
        end
    end

    -- interate through all possible pairs
    if #validForCollision > 1 then
        for a=1,#validForCollision-1 do
            local o1 = validForCollision[a]
            for b=a+1,#validForCollision do
                local o2 = validForCollision[b]
                if obj_check_hitbox_overlap(o1, o2) then
                    local hurt1 = (o1.oHurtsEnemies == 1)
                    local hurt2 = (o2.oHurtsEnemies == 1)
                    local valid = true

                    if hurt1 and hurt2 then
                        local isFireball1 = get_id_from_behavior(o1.behavior) == id_bhvSmbFireball
                        local isFireball2 = get_id_from_behavior(o2.behavior) == id_bhvSmbFireball

                        if isFireball1 and isFireball2 then
                            valid = (gServerSettings.playerInteractions == PLAYER_INTERACTIONS_PVP) and (o1.globalPlayerIndex ~= o2.globalPlayerIndex)
                        end
                    end

                    if valid then
                        if hurt1 then
                            local attacker = o1
                            local victim = o2
                            local isAttackerFireball = get_id_from_behavior(attacker.behavior) == id_bhvSmbFireball
                            local isVictimFireball = get_id_from_behavior(victim.behavior) == id_bhvSmbFireball

                            attacker.oInteractStatus = attacker.oInteractStatus | INT_STATUS_INTERACTED

                            if (not isAttackerFireball) or victim.oImmuneToFire == 0 then
                                victim.oInteractStatus = victim.oInteractStatus | (INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | ATTACK_FAST_ATTACK)
                                attacker.oShellCombo = attacker.oShellCombo + 1
                                local index = network_local_index_from_global(attacker.globalPlayerIndex)
                                if (victim.oHealth == 2048 or victim.oHealth <= 1) and index ~= 255 and (not isVictimFireball) then
                                    local m = gMarioStates[index]
                                    local points = attacker.oShellCombo + 3
                                    if victim.oFireballOverridePoints == 1 and isAttackerFireball then
                                        points = victim.oDamageOrCoinValue
                                    end
                                    award_points(m, points, true, victim.oPosX, victim.oPosY)
                                end
                            end
                        end
                        if hurt2 then
                            local attacker = o2
                            local victim = o1
                            local isAttackerFireball = get_id_from_behavior(attacker.behavior) == id_bhvSmbFireball
                            local isVictimFireball = get_id_from_behavior(victim.behavior) == id_bhvSmbFireball

                            attacker.oInteractStatus = attacker.oInteractStatus | INT_STATUS_INTERACTED

                            if (not isAttackerFireball) or victim.oImmuneToFire == 0 then
                                victim.oInteractStatus = victim.oInteractStatus | (INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | ATTACK_FAST_ATTACK)
                                attacker.oShellCombo = attacker.oShellCombo + 1
                                local index = network_local_index_from_global(attacker.globalPlayerIndex)
                                if (victim.oHealth == 2048 or victim.oHealth <= 1) and index ~= 255 and (not isVictimFireball) then
                                    local m = gMarioStates[index]
                                    local points = attacker.oShellCombo + 3
                                    if victim.oFireballOverridePoints == 1 and isAttackerFireball then
                                        points = victim.oDamageOrCoinValue
                                    end
                                    award_points(m, points, true, victim.oPosX, victim.oPosY)
                                end
                            end
                        end

                        if not (hurt1 or hurt2) then
                            local doTurn1 = (o1.oTurnTowardsOnHit == 1)
                            local doTurn2 = (o2.oTurnTowardsOnHit == 1)
                            if doTurn1 then
                                local tSign = sign(o1.oPosX - o2.oPosX)
                                o1.oMoveAngleYaw = tSign * 0x4000
                                o1.oVelX = math.abs(o1.oVelX) * tSign
                            end
                            if doTurn2 then
                                local tSign = sign(o2.oPosX - o1.oPosX)
                                o2.oMoveAngleYaw = tSign * 0x4000
                                o2.oVelX = math.abs(o2.oVelX) * tSign
                            end
                        end
                    end
                end
            end
        end
    end
end
hook_event(HOOK_UPDATE, update)

-- disable default object/pvp interactions so we can handle them on ourselves
function no_allow()
    if gNetworkPlayers[0].currLevelNum ~= LEVEL_SMB then return end
    return false
end
hook_event(HOOK_ALLOW_INTERACT, no_allow)
hook_event(HOOK_ALLOW_PVP_ATTACK, no_allow)

-- don't update geometry inputs
function skip_geometry_inputs(m)
    if gNetworkPlayers[0].currLevelNum ~= LEVEL_SMB then return end

    m.input = m.input & ~INPUT_IN_WATER
    return false
end
hook_event(HOOK_MARIO_OVERRIDE_GEOMETRY_INPUTS, skip_geometry_inputs)

-- set some fields on level entry
function on_warp()
    if gNetworkPlayers[0].currLevelNum ~= LEVEL_SMB then
        hud_show()
        camera_unfreeze()
        return
    end

    local m = gMarioStates[0]
    local smb = gSMBStates[0]
    local np = gNetworkPlayers[0]
    smb.initialJumpXVel = 0
    smb.gravity = ENTRY_GRAVITY
    smb.combo = 0
    smb.starTimer = 0
    smb.timerInterval = 12 -- original game subtracts 1 from timer every time we change areas
    smb.crouch = false
    smb.paused = false
    smb.tempScrollStop = 0
    smb.frenzyDisabled = false
    smb.loopScreenLeft = 0
    smb.loopScreenRight = 0
    waitForLoop = false
    timeStopEnabled = false
    warpZoneActive = false
    timeUpDeath = false
    warpZoneData = {36, 5, 36} -- default

    -- reset some fields on title/death
    local showStatusScreen = false
    if lastAct == -1 or lastAct == 0 or np.currActNum == 0 then
        smb.isBig = false
        smb.powerup = 0
        -- reset some fields on title screen
        if np.currActNum == 0 then
            m.numLives = 3
            smb.points = 0
            entranceType = 0
            checkpointScreen = 0
            startWorld = 1
            smbMenuOption = 0
        end
    end
    -- reset fields between levels
    if lastAct ~= np.currActNum then
        if lastAct ~= -1 then
            checkpointScreen = 0
        end
        showStatusScreen = true
        lastAct = np.currActNum
        interacted_blocks = {}
        interacted_blocks_local = {}
        coin_brick_timer = {}
    end
    
    process_geometry_data(np.currActNum, np.currAreaIndex)

    local sx = 0
    local sy = 0
    if entranceType == 0 then
        sx = checkpointScreen * 16
        if checkpointScreen ~= 0 or (network_player_connected_count() > 1) then
            m.invincTimer = 8 * 21
        end
    elseif pipeEntranceArea ~= 0 then
        sx = pipeEntranceScreen * 16
        pipeEntranceArea = 0
    elseif doBonusExit then
        sx = bonusExitScreen * 16
        doBonusExit = false
    end

    if entranceType == 0 then
        m.pos.x = (sx + 3) * BLOCK
        m.pos.y = (sy + 2) * BLOCK
        while get_tile_at_coordinate_pos(m.pos.x - 0.5 * BLOCK, m.pos.y) ~= 0 do
            sy = sy + 1
            m.pos.y = (sy + 2) * BLOCK
        end
        if loaded_tile_data.pipeCutscene then
            set_mario_action(m, ACT_SMB_ENTER_SIDE_PIPE, 0)
        else
            set_mario_action(m, ACT_SMB_IDLE, 0)
        end
    elseif entranceType == 1 then
        m.freeze = 15
        m.pos.x = (sx + 2) * BLOCK
        if (respawnArea == np.currAreaIndex) then
            m.pos.x = m.pos.x + BLOCK
        end
        m.pos.y = BLOCK * 12 -- fall from above
        set_mario_action(m, ACT_SMB_FALL, 0)
    elseif entranceType == 2 then
        m.pos.x = (sx + 4) * BLOCK
        m.pos.y = BLOCK * 4 - 1000
        set_mario_action(m, ACT_SMB_IN_PIPE, 1)
    elseif entranceType == 3 then -- vine
        m.pos.x = (sx + 4.5) * BLOCK
        m.pos.y = -2 * BLOCK
        set_mario_action(m, ACT_SMB_VINE_CUTSCENE, 0)
        -- spawn non-sync vine
        m.usedObj = spawn_object_no_rotate(id_bhvSmbVine, E_MODEL_NONE, m.pos.x, m.pos.y + BLOCK, 0, false, function(o)
            o.oBehParams = 1
        end)
    end
    m.pos.z = 0
    m.spawnInfo.startPos.x = m.pos.x
    m.spawnInfo.startPos.y = m.pos.y
    m.faceAngle.y = 0x4000

    -- set camera start
    smb.cameraX = sx * PX
    smb.cameraY = 0
    prevMPosForScroll = (m.pos.x * SSPX - 8) - smb.cameraX
    spawn_non_sync_object(id_bhvPauseController, E_MODEL_NONE, 0, 0, 0, nil)
    
    if np.currActNum == 0 then
        set_current_music()
        m.invincTimer = 0
        set_mario_action(m, ACT_SMB_TITLE_SCREEN, 0)
    elseif showStatusScreen then -- if this is a new level
        respawnArea = 1
        if np.currAreaIndex ~= 1 then -- always respawn in initial area
            respawnArea = np.currAreaIndex
        elseif loaded_tile_data.pipeCutscene then -- if this is a pipe cutscene area, respawn in area 2 instead
            respawnArea = 2
        end

        smb.timer = loaded_tile_data.timer or 400
        set_current_music()
        set_mario_action(m, ACT_SMB_LOADING, 0)
    else
        set_music_to_theme()
    end

    -- ask server if we're the first player here
    checkFirstHereStatus = -1
    network_send_to_host(true, {
        id = PACKET_CHECK_IF_FIRST,
        from = np.globalIndex,
        levelNum = np.currActNum,
        area = np.currAreaIndex,
    })
end
hook_event(HOOK_ON_WARP, on_warp)

-- load objects
function on_sync_valid()
    local np0 = gNetworkPlayers[0]
    if np0.currLevelNum ~= LEVEL_SMB then return end

    -- block interaction packet request
    for i=1,MAX_PLAYERS-1 do
        local np = gNetworkPlayers[i]
        if np.connected and (np.currLevelNum == np0.currLevelNum and np.currActNum == np0.currActNum) and np.currLevelSyncValid then
            network_send_to(i, true, {
                id = PACKET_BLOCKS_REQUEST,
                area = np0.currAreaIndex,
                from = network_global_index_from_local(0),
            })
            break
        end
    end

    -- load our own interactions
    if interacted_blocks_local[np0.currAreaIndex] then
        interacted_blocks_local[np0.currAreaIndex].load = true
        on_packet_blocks_request(interacted_blocks_local[np0.currAreaIndex], true)
    end

    if checkFirstHereStatus ~= -1 then
        initial_object_load(checkFirstHereStatus == 1)
    end
end
hook_event(HOOK_ON_SYNC_VALID, on_sync_valid)

-- handle coins
function on_coins_changed(tag, oldVal, newVal)
    if not (oldVal and newVal) then return end
    if oldVal >= newVal or gNetworkPlayers[0].currLevelNum ~= LEVEL_SMB or gNetworkPlayers[0].currActNum == 0 then return end
    local old100s = oldVal // 100
    local new100s = newVal // 100
    -- grant 1up, otherwise play normal coin sound
    local m = gMarioStates[0]
    if old100s ~= new100s then
        m.numLives = m.numLives + 1
        play_smb_sound_stream(m.pos, "1up")
    else
        play_smb_sound_stream(m.pos, "coin")
    end
end
hook_on_sync_table_change(gGlobalSyncTable, "coins", "coinChange", on_coins_changed)

-- disable transitions in smb
local disableNextTransiton = false
function on_transition(type)
    if disableNextTransiton then
        disableNextTransiton = false
        return false
    end
    if gNetworkPlayers[0].currLevelNum ~= LEVEL_SMB then return end
    return false
end
hook_event(HOOK_ON_SCREEN_TRANSITION, on_transition)

-- disable act select, and also disable transition into SMB
function disable_act_select(level)
    if level == LEVEL_SMB then
        disableNextTransiton = true

        -- shorten fake out if we've seen it already
        if mod_storage_load_bool("didFakeOut") then
            dontRenderTime = 15
        else
            dontRenderTime = 150
            mod_storage_save_bool("didFakeOut", true)
        end
        
        return false
    end
end
hook_event(HOOK_USE_ACT_SELECT, disable_act_select)

-- smb pause menu
local menuPressed = 0
local menuDown = 0
function smb_pause_menu(m)
    custom_handle_time_stop(true)

    if localOptionTable.debugFrameByFrame and m.controller.buttonDown & L_TRIG ~= 0 then
        if frameByFrameActiveTimer == 0 then
            clear_time_stop_flags(TIME_STOP_ENABLED | TIME_STOP_MARIO_AND_DOORS)
            timeStopEnabled = false
        end
        frameByFrameActiveTimer = 2
    elseif frameByFrameActiveTimer ~= 0 then
        frameByFrameActiveTimer = frameByFrameActiveTimer - 1
    end

    menuPressed = m.controller.buttonDown & ~menuDown
    menuDown = m.controller.buttonDown
    m.controller.buttonDown, m.controller.buttonPressed = 0,0

    if menuPressed & U_JPAD ~= 0 or menuPressed & D_JPAD ~= 0 then
        local totalOptions = 3
        local change = 1
        if menuPressed & U_JPAD ~= 0 then
            change = -1
        end
        smbMenuOption = (smbMenuOption + change) % totalOptions
    end

    if menuPressed & START_BUTTON ~= 0 or menuPressed & A_BUTTON ~= 0 then
        if smbMenuOption == 0 then
            if pauseDelayTimer == 0 then
                play_smb_sound_stream(m.pos, "pause", true)
                clear_time_stop_flags(TIME_STOP_ENABLED | TIME_STOP_MARIO_AND_DOORS)
                timeStopEnabled = false
                m.controller.buttonDown = menuDown
                gSMBStates[0].paused = false
                pauseDelayTimer = 20
            end
        elseif smbMenuOption == 1 then
            clear_time_stop_flags(TIME_STOP_ENABLED | TIME_STOP_MARIO_AND_DOORS)
            timeStopEnabled = false
            m.controller.buttonDown = menuDown
            gSMBStates[0].paused = false
            if m.action ~= ACT_SMB_DEAD and m.action ~= ACT_SMB_BUBBLED then
                m.numLives = m.numLives - 1
                if mario_can_bubble_smb(m) then
                    gSMBStates[0].powerup = 0
                    gSMBStates[0].isBig = false
                    set_mario_action(m, ACT_SMB_BUBBLED, 0)
                else
                    set_mario_action(m, ACT_SMB_DEAD, 0)
                end
            end
        elseif smbMenuOption == 2 then
            m.controller.buttonDown = menuDown
            warp_to_level(LEVEL_SMB, 1, 0)
        end
    elseif menuPressed & R_TRIG ~= 0 then
        djui_open_pause_menu()
    end
end

-- mod menu
if network_is_server() then
    add_smb_menu_option("(HOST) Allow going backwards", "allowBackwards", gGlobalSyncTable)
    add_smb_menu_option("(HOST) Modern powerup style", "modernPowerStyle", gGlobalSyncTable)
    add_smb_menu_option("(HOST) Select world with B", "allowWorldSelect", gGlobalSyncTable)
    add_smb_menu_option("(HOST) Second Quest", "hardMode", gGlobalSyncTable)
    add_smb_menu_option("(HOST) Disable timer", "disableTimer", gGlobalSyncTable)
    add_smb_menu_option("(HOST) Alt Spiny egg behavior", "altSpinyEggBehavior", gGlobalSyncTable)
    gGlobalSyncTable.topWorld = math.floor(mod_storage_load_number("topWorld"))
end
add_smb_menu_option("Alt star effect", "nonFlashStar", localOptionTable)
if _G.cheatsApi then
    add_smb_menu_option("(DEBUG) Editor", "debugEditor", localOptionTable)
    add_smb_menu_option("(DEBUG) Show Mario colliders", "debugColliders", localOptionTable)
    add_smb_menu_option("(DEBUG) Show hitboxes", "debugHitboxes", localOptionTable)
    add_smb_menu_option("(DEBUG) \"Frame by frame\" with L", "debugFrameByFrame", localOptionTable)
    add_smb_menu_option("(DEBUG) Half game speed", "debugHalfSpeed", localOptionTable)
    add_smb_menu_option("(DEBUG) Always bubble", "debugBubble", localOptionTable)
end

local lastButtonIndex = 0
local lastButtonTime = 0
if network_is_server() then
    hook_mod_menu_button("(HOST) Reset game progress", function(index)
        local timeSincePress = get_time() - lastButtonTime
        if lastButtonIndex == index and timeSincePress < 5 then
            gGlobalSyncTable.topWorld = 0
            mod_storage_remove("topWorld")
            lastButtonIndex = 0
            justDidReset = true
            network_send_include_self(true, {
                id = PACKET_GAME_RESET,
            })
            djui_popup_create("\\#ff5050\\Game progress has been reset.", 2)
        else
            djui_popup_create("\\#ff5050\\Are you sure?\nPress again to continue.", 2)
            lastButtonIndex = index
            lastButtonTime = get_time()
        end
    end)
end
hook_mod_menu_button("Reset top score", function(index)
    local timeSincePress = get_time() - lastButtonTime
    if lastButtonIndex == index and timeSincePress < 5 then
        topScore = 0
        mod_storage_remove("topScore")
        lastButtonIndex = 0
        djui_popup_create("\\#ff5050\\Your top score has been reset.", 2)
    else
        djui_popup_create("\\#ff5050\\Are you sure?\nPress again to continue.", 2)
        lastButtonIndex = index
        lastButtonTime = get_time()
    end
end)