-- level data. This is VERY different from how smb does things

--- tile constants ---
TILE_GROUND = 1
TILE_HARD = 2
TILE_BRICK = 3
TILE_QUESTION_COIN = 4
TILE_QUESTION_ITEM = 5
TILE_HIT_BLOCK = 6
TILE_BRICK_COINS = 7
TILE_BRICK_STAR = 8
TILE_BRICK_1UP = 9
TILE_HIDDEN_COIN = 10
TILE_HIDDEN_1UP = 11
TILE_COIN = 12
TILE_PIPE_TOP_LEFT = 13
TILE_PIPE_TOP_RIGHT = 14
TILE_PIPE_SIDE_LEFT = 15
TILE_PIPE_SIDE_RIGHT = 16
TILE_PIPE_SIDEWAYS_TL = 17
TILE_PIPE_SIDEWAYS_BL = 18
TILE_PIPE_SIDEWAYS_T = 19
TILE_PIPE_SIDEWAYS_B = 20
TILE_PIPE_SIDEWAYS_CT = 21
TILE_PIPE_SIDEWAYS_CB = 22
TILE_PIPE_ENTER_LEFT = 23
TILE_PIPE_ENTER_RIGHT = 24
TILE_INVISIBLE_BLOCK = 25
TILE_BRICK_VINE = 26
TILE_BRICK_ITEM = 27
TILE_CASTLE_SOLID = 28
TILE_PIPE_WARP_LEFT = 29
TILE_PIPE_WARP_RIGHT = 30
TILE_TREE_L = 31
TILE_TREE_M = 32
TILE_TREE_R = 33
TILE_SHROOM_L = 34
TILE_SHROOM_M = 35
TILE_SHROOM_R = 36
TILE_CASTLE_BRIDGE = 37
TILE_HIT_BRICK = 38 -- I only realized that hit bricks and hit ? blocks look different until partway through developing 1-4
TILE_CLOUD = 39
TILE_CORAL = 40
TILE_BRIDGE = 41
TILE_CANNON_TOP = 42
TILE_CANNON_SKULL = 43
TILE_CANNON = 44

-- background tiles
TILE_BUSH_LEFT = -1
TILE_BUSH_MIDDLE = -2
TILE_BUSH_RIGHT = -3
TILE_HILL_SLOPE_LEFT = -4
TILE_HILL_CENTER_SR = -5 -- black thing on right
TILE_HILL_CENTER = -6
TILE_HILL_CENTER_SL = -7 -- black thing on left
TILE_HILL_SLOPE_RIGHT = -8
TILE_HILL_TOP = -9
TILE_CLOUD_TL = -10
TILE_CLOUD_TM = -11
TILE_CLOUD_TR = -12
TILE_CLOUD_BL = -13
TILE_CLOUD_BM = -14
TILE_CLOUD_BR = -15
TILE_CASTLE_TOP = -16
TILE_CASTLE_WINDOW_LEFT = -17
TILE_CASTLE_WALL = -18
TILE_CASTLE_WINDOW_RIGHT = -19
TILE_CASTLE_LOWER_TOP = -20
TILE_CASTLE_DOOR_T = -21
TILE_CASTLE_DOOR_B = -22
TILE_FLAG_TOP = -23
TILE_FLAG_POLE = -24
TILE_TREE_BG = -25
TILE_SHROOM_STEM_T = -26
TILE_SHROOM_STEM = -27
TILE_LIQUID_SURFACE = -28
TILE_LIQUID = -29
TILE_BRIDGE_CHAIN = -30
TILE_PLANT_STEM = -31
TILE_PLANT_SHORT_TOP = -32
TILE_PLANT_TOP = -33
TILE_PLANT_BOTTOM = -34
TILE_FENCE = -35
TILE_BRIDGE_RAIL = -36
TILE_ROPE_V = -37
TILE_ROPE_H = -38
TILE_ROPE_PULLEY_L = -39
TILE_ROPE_PULLEY_R = -40
TILE_ROPE_V_HALF = -41
TILE_EMPTY_BG = -42

--- tile render data ---

local all_quest_data = {{81, 82, 83}} -- animated tile
local all_brick_data = {1, 2, 2, 2}
local TILE_RENDER_DATA = {
    [TILE_GROUND] = {0, 0, 96, 64}, -- pick tile based on theme
    [TILE_HARD] = 32,
    [TILE_HIT_BLOCK] = 70,
    [TILE_HIT_BRICK] = 3,
    [TILE_COIN] = {{113, 114, 115}}, -- animated tile

    [TILE_QUESTION_COIN] = all_quest_data,
    [TILE_QUESTION_ITEM] = all_quest_data,
    
    [TILE_BRICK] = all_brick_data,
    [TILE_BRICK_COINS] = all_brick_data,
    [TILE_BRICK_STAR] = all_brick_data,
    [TILE_BRICK_1UP] = all_brick_data,
    [TILE_BRICK_VINE] = all_brick_data,
    [TILE_BRICK_ITEM] = all_brick_data,

    [TILE_PIPE_TOP_LEFT] = 15,
    [TILE_PIPE_TOP_RIGHT] = 16,
    [TILE_PIPE_SIDE_LEFT] = 47,
    [TILE_PIPE_SIDE_RIGHT] = 48,
    [TILE_PIPE_ENTER_LEFT] = 15,
    [TILE_PIPE_ENTER_RIGHT] = 16,
    [TILE_PIPE_SIDEWAYS_TL] = {77, 77, 77, 69},
    [TILE_PIPE_SIDEWAYS_BL] = {109, 109, 109, 101},
    [TILE_PIPE_SIDEWAYS_T] = 78,
    [TILE_PIPE_SIDEWAYS_B] = 110,
    [TILE_PIPE_SIDEWAYS_CT] = 79,
    [TILE_PIPE_SIDEWAYS_CB] = 111,
    [TILE_PIPE_WARP_LEFT] = 15,
    [TILE_PIPE_WARP_RIGHT] = 16,

    [TILE_HIDDEN_COIN] = -1,
    [TILE_HIDDEN_1UP] = -1,
    [TILE_INVISIBLE_BLOCK] = -1,

    [TILE_FLAG_TOP] = 80,
    [TILE_FLAG_POLE] = 112,

    [TILE_CASTLE_TOP] = 4,
    [TILE_CASTLE_WINDOW_LEFT] = 35,
    [TILE_CASTLE_WALL] = 36,
    [TILE_CASTLE_SOLID] = 36,
    [TILE_CASTLE_WINDOW_RIGHT] = 37,
    [TILE_CASTLE_LOWER_TOP] = 5,
    [TILE_CASTLE_DOOR_T] = 6,
    [TILE_CASTLE_DOOR_B] = 38,

    [TILE_TREE_L] = 8,
    [TILE_TREE_M] = 9,
    [TILE_TREE_R] = 10,
    [TILE_TREE_BG] = 33,
    [TILE_SHROOM_L] = 11,
    [TILE_SHROOM_M] = 12,
    [TILE_SHROOM_R] = 13,
    [TILE_SHROOM_STEM_T] = 68,
    [TILE_SHROOM_STEM] = 100,

    [TILE_LIQUID_SURFACE] = 20,
    [TILE_LIQUID] = 52,

    [TILE_CASTLE_BRIDGE] = 53,
    [TILE_BRIDGE_CHAIN] = 73,

    [TILE_CLOUD] = 21,
    [TILE_CORAL] = 43,
    [TILE_BRIDGE] = 34,
    [TILE_BRIDGE_RAIL] = 72,
    [TILE_EMPTY_BG] = -1,

    [TILE_CANNON_TOP] = 7,
    [TILE_CANNON_SKULL] = 39,
    [TILE_CANNON] = 71,

    [TILE_ROPE_V] = 99,
    [TILE_ROPE_H] = 66,
    [TILE_ROPE_PULLEY_L] = 65,
    [TILE_ROPE_PULLEY_R] = 67,
    [TILE_ROPE_V_HALF] = 103,

    [TILE_BUSH_LEFT] = 40,
    [TILE_BUSH_MIDDLE] = 41,
    [TILE_BUSH_RIGHT] = 42,
    [TILE_HILL_SLOPE_LEFT] = 104,
    [TILE_HILL_CENTER_SR] = 105, -- black thing on right
    [TILE_HILL_CENTER] = 106,
    [TILE_HILL_CENTER_SL] = 107, -- black thing on left
    [TILE_HILL_SLOPE_RIGHT] = 108,
    [TILE_HILL_TOP] = 74,
    [TILE_CLOUD_TL] = 17,
    [TILE_CLOUD_TM] = 18,
    [TILE_CLOUD_TR] = 19,
    [TILE_CLOUD_BL] = 49,
    [TILE_CLOUD_BM] = 50,
    [TILE_CLOUD_BR] = 51,
    [TILE_PLANT_STEM] = 97,
    [TILE_PLANT_SHORT_TOP] = 45,
    [TILE_PLANT_TOP] = 14,
    [TILE_PLANT_BOTTOM] = 46,
    [TILE_FENCE] = 98,
}

--- level generation utils ---

loaded_tile_data = {}              -- loaded tile data is stored here
loaded_obj_data = {}               -- loaded object data is tored here
local geometry_data = {}           -- geometry objects, which are processed at the start of the level
local obj_data = {}                -- object data, which is simply copied to loaded_obj_data at the start of the level
local curr_ground_height = 2       -- current ground height in level generation
local curr_ceil_height = 0         -- current ceil height in level generation
local curr_ceil_tile = TILE_GROUND -- current ceiling tile in level generation (ground is always TILE_GROUND)
local curr_pit_blocks = 0          -- how many tiles of a pit to generate; disables ground generation temporarily

-- geometry commands, used to generate every level
-- x and y are the object location, x2 and y2 are the location where the block is being placed, and geo_command is the parameters
-- there are 3 parameters, typically being (tile, width, height) although there are exceptions
local GEOMETRY_GROUND_HEIGHT = 0
local GEOMETRY_BLOCK_RECT = 1
local GEOMETRY_PIPE = 2
local GEOMETRY_STAIRS = 3
local GEOMETRY_PIPE_SIDE = 4
local GEOMETRY_PIT = 5
local GEOMETRY_STAIRS_R = 6
local GEOMETRY_FLAG_POLE = 7
local GEOMETRY_CASTLE = 8
local GEOMETRY_CASTLE_WALL = 9
local GEOMETRY_TREE_OR_SHROOM = 10
local GEOMETRY_LIQUID = 11
local GEOMETRY_BRIDGE = 12
local GEOMETRY_PULLEY = 13
local GEOMETRY_CANNON = 14
local geo_cmd_funcs = {
    [GEOMETRY_GROUND_HEIGHT] = function(x, y, x2, y2, geo_command)
        curr_ceil_tile = geo_command[2] or TILE_GROUND
        curr_ground_height = geo_command[3] or 2
        curr_ceil_height = geo_command[4] or 0
        return true
    end,
    [GEOMETRY_BLOCK_RECT] = function(x, y, x2, y2, geo_command)
        add_to_2d_table(loaded_tile_data, x2, y2, geo_command[2])
    end,
    [GEOMETRY_PIPE] = function(x, y, x2, y2, geo_command)
        -- don't overwrite pipe connectors
        local existingTile = (loaded_tile_data[x2] and get_tile_at_block(x2, y2)) or 0
        if existingTile == TILE_PIPE_SIDEWAYS_CB or existingTile == TILE_PIPE_SIDEWAYS_CT then return end
        
        local tile = TILE_PIPE_SIDE_LEFT
        if y2 == y then
            tile = geo_command[2]
        end
        if x2 > x then
            tile = tile + 1     -- right side
        end
        -- add piranha plant if this is not 1-1, this isn't a side pipe tile, and this isn't the pipe cutscene
        if x2 == x and y2 == y and tile ~= TILE_PIPE_SIDE_LEFT and gNetworkPlayers[0].currActNum > 1 and not loaded_tile_data.pipeCutscene then
            add_to_2d_table(loaded_obj_data, x, y-1, {id_bhvSmbPiranhaPlant, 1})
        end
        add_to_2d_table(loaded_tile_data, x2, y2, tile)
    end,
    [GEOMETRY_STAIRS] = function(x, y, x2, y2, geo_command)
        if x2 - x >= (y2 - y + geo_command[4] - 1) then
            add_to_2d_table(loaded_tile_data, x2, y2, geo_command[2])
        end
    end,
    [GEOMETRY_PIPE_SIDE] = function(x, y, x2, y2, geo_command)
        local tile = TILE_PIPE_SIDEWAYS_T
        if x2 == x then
            tile = TILE_PIPE_SIDEWAYS_TL
        elseif x2 == x + geo_command[3] - 1 then
            tile = TILE_PIPE_SIDEWAYS_CT
        end

        if y2 < y then
            tile = tile + 1 -- bottom side
        end
        add_to_2d_table(loaded_tile_data, x2, y2, tile)
    end,
    [GEOMETRY_PIT] = function(x, y, x2, y2, geo_command)
        curr_pit_blocks = geo_command[3] or 0
        -- auto-place whirlpools in water
        if loaded_tile_data.theme == 3 then
            add_to_2d_table(loaded_obj_data, x + geo_command[3] // 2, 0, {id_bhvSmbWhirlpool, 1, geo_command[3]})
        end
        return true
    end,
    [GEOMETRY_STAIRS_R] = function(x, y, x2, y2, geo_command)
        if geo_command[3] - x2 + x > (y2 - y + geo_command[4] - 1) then
            add_to_2d_table(loaded_tile_data, x2, y2, geo_command[2])
        end
    end,
    [GEOMETRY_FLAG_POLE] = function(x, y, x2, y2, geo_command)
        local tile = TILE_FLAG_POLE
        if y2 == y then
            tile = TILE_FLAG_TOP
            add_to_2d_table(loaded_obj_data, x2, (y2-1), {id_bhvSmbFlag, 1})
        elseif y2 == y - geo_command[4] + 1 then
            tile = TILE_HARD
        end
        add_to_2d_table(loaded_tile_data, x2, y2, tile)
    end,
    [GEOMETRY_CASTLE] = function(x, y, x2, y2, geo_command)
        local tile = TILE_CASTLE_WALL
        local startTopCastle = (geo_command[3] // 2 - 2)
        local distFromCenter = math.abs(geo_command[3] // 2 - x2 + x)
        if y2 == y then -- upper castle top
            tile = TILE_CASTLE_TOP
            if distFromCenter >= 2 then return end
        elseif y2 == y - 1 then -- upper castle windows
            tile = TILE_CASTLE_WINDOW_LEFT - (x2 - x - startTopCastle) + 1
            if distFromCenter >= 2 then return end
        elseif y2 == y - 2 then -- upper castle middle
            if distFromCenter > 2 then
                return
            elseif distFromCenter ~= 2 then
                tile = TILE_CASTLE_LOWER_TOP
            else
                tile = TILE_CASTLE_TOP
            end
        elseif y - y2 < 5 and distFromCenter > 2 then -- cut off upper castle walls
            return
        elseif y - y2 == 5 then -- lower castle top
            if distFromCenter < 3 then
                tile = TILE_CASTLE_LOWER_TOP
            else
                tile = TILE_CASTLE_TOP
            end
        elseif distFromCenter <= (y - y2) // 3 and (y - y2) % 3 == 0 and distFromCenter % 2 ~= (y - y2) % 2 then -- castle door tops (both castles)
            tile = TILE_CASTLE_DOOR_T
        elseif distFromCenter <= (y - y2 - 1) // 3 and (y - y2 - 1) % 3 == 0 and distFromCenter % 2 ~= (y - y2 - 1) % 2 then -- castle door bottoms (both castles)
            tile = TILE_CASTLE_DOOR_B
        elseif x2 == (x + 3) and y2 == y - geo_command[4] + 1 then -- solid block for flag sequence
            tile = geo_command[2]
            add_to_2d_table(loaded_obj_data, (x+startTopCastle+2), (y2+3), {id_bhvSmbCastleFlag, 1})
        end
        add_to_2d_table(loaded_tile_data, x2, y2, tile)
    end,
    [GEOMETRY_CASTLE_WALL] = function(x, y, x2, y2, geo_command)
        -- don't overwrite other blocks
        local existingTile = (loaded_tile_data[x2] and get_tile_at_block(x2, y2)) or 0
        if existingTile ~= 0 then return end
        
        local tile = TILE_CASTLE_WALL
        if y2 == y then
            tile = TILE_CASTLE_TOP
        end
        add_to_2d_table(loaded_tile_data, x2, y2, tile)
    end,
    [GEOMETRY_TREE_OR_SHROOM] = function(x, y, x2, y2, geo_command)
        -- don't overwrite other blocks
        local existingTile = (loaded_tile_data[x2] and get_tile_at_block(x2, y2)) or 0
        if existingTile ~= 0 then return end
        
        local distFromCenter = math.abs(geo_command[3] // 2 - x2 + x)
        local tile = geo_command[2]
        if y2 == y then
            if x2 == x + geo_command[3] - 1 then
                tile = tile + 2
            elseif x2 ~= x then
                tile = tile + 1
            end
        elseif tile == TILE_SHROOM_L then -- generate mushroom stem
            if distFromCenter ~= 0 then return end
            tile = TILE_SHROOM_STEM
            if y2 == y - 1 then
                tile = TILE_SHROOM_STEM_T
            end
        else -- generate tree bg
            -- add 1 to center on right so this is symmetric
            if x2 - x >= geo_command[3] // 2 and geo_command[3] % 2 == 0 then
                distFromCenter = distFromCenter + 1
            end

            if distFromCenter >= (geo_command[3] // 2) then return end
            tile = TILE_TREE_BG
        end
        add_to_2d_table(loaded_tile_data, x2, y2, tile)
    end,
    [GEOMETRY_LIQUID] = function(x, y, x2, y2, geo_command)
        -- don't overwrite other blocks
        local existingTile = (loaded_tile_data[x2] and get_tile_at_block(x2, y2, true)) or 0
        if existingTile ~= 0 then return end

        local tile = TILE_LIQUID_SURFACE
        if y2 ~= y then
            tile = TILE_LIQUID
        end
        add_to_2d_table(loaded_tile_data, x2, y2, tile)
    end,
    [GEOMETRY_BRIDGE] = function(x, y, x2, y2, geo_command)
        local tile = TILE_BRIDGE
        if y2 == y then
            tile = TILE_BRIDGE_RAIL
        end
        add_to_2d_table(loaded_tile_data, x2, y2, tile)
    end,
    [GEOMETRY_PULLEY] = function(x, y, x2, y2, geo_command)
        -- note this doesn't place the platforms themselves or the vertical ropes
        local tile = TILE_ROPE_H
        if x2 == x + geo_command[3] - 1 then
            tile = TILE_ROPE_PULLEY_R
        elseif x2 == x then
            tile = TILE_ROPE_PULLEY_L
        end
        add_to_2d_table(loaded_tile_data, x2, y2, tile)
    end,
    [GEOMETRY_CANNON] = function(x, y, x2, y2, geo_command)
        local tile = TILE_CANNON
        if y2 == y then
            tile = TILE_CANNON_TOP
            add_to_2d_table(loaded_obj_data, x, y, {id_bhvSmbBillBlaster, 1})
        elseif y2 == y - 1 then
            tile = TILE_CANNON_SKULL
        end
        add_to_2d_table(loaded_tile_data, x2, y2, tile)
    end,
}

local BG_CLOUD = 0
local BG_HILL = 1
local BG_BUSH = 2
local BG_PLANT = 3
local BG_FENCE = 4
local bg_generate_sub_funcs = {
    [BG_CLOUD] = function(x, y, x2, y2, width, height)
        local distX = (x2 - x)
        local tile = 0
        if y == y2 then
            tile = TILE_CLOUD_TM
            if distX == 0 then
                tile = TILE_CLOUD_TL
            elseif distX == width then
                tile = TILE_CLOUD_TR
            end
        else
            tile = TILE_CLOUD_BM
            if x2 == x then
                tile = TILE_CLOUD_BL
            elseif distX == width then
                tile = TILE_CLOUD_BR
            end
        end
        if tile ~= 0 then
            add_to_2d_table(loaded_tile_data, x2, y2, tile)
        end
    end,
    [BG_HILL] = function(x, y, x2, y2, width, height)
        local distX = (x2 - x)
        local distY = (y - y2)
        local tile = 0
        if distY == 2 then
            tile = (TILE_HILL_SLOPE_LEFT - distX)
        elseif distY == 1 then
            if distX < 1 or distX > 3 then return end
            tile = (TILE_HILL_SLOPE_LEFT - distX + 1)
            if distX == 3 then tile = TILE_HILL_SLOPE_RIGHT end
        elseif distX == 2 then
            tile = TILE_HILL_TOP
        end
        if tile ~= 0 then
            add_to_2d_table(loaded_tile_data, x2, y2, tile)
        end
    end,
    [BG_BUSH] = function(x, y, x2, y2, width, height)
        local distX = (x2 - x)
        local tile = TILE_BUSH_MIDDLE
        if distX == 0 then
            tile = TILE_BUSH_LEFT
        elseif distX == width then
            tile = TILE_BUSH_RIGHT
        end
        if tile ~= 0 then
            add_to_2d_table(loaded_tile_data, x2, y2, tile)
        end
    end,
    [BG_PLANT] = function(x, y, x2, y2, width, height)
        local tile = TILE_PLANT_STEM
        if y - y2 ~= height then
            if height == 1 then
                tile = TILE_PLANT_SHORT_TOP
            elseif y2 == y then
                tile = TILE_PLANT_TOP
            else
                tile = TILE_PLANT_BOTTOM
            end
        end
        if tile ~= 0 then
            add_to_2d_table(loaded_tile_data, x2, y2, tile)
        end
    end,
    [BG_FENCE] = function(x, y, x2, y2, width, height)
        local tile = TILE_FENCE
        if tile ~= 0 then
            add_to_2d_table(loaded_tile_data, x2, y2, tile)
        end
    end,
}
local bg_generate_funcs = {
    -- hills, clouds, and bushes (ex: 1-1, 4-1)
    function(screenX, offset)
        local sx = screenX * 16
        if (screenX + offset) % 3 == 0 then
            generate_bg_element(BG_HILL, sx, 4, 5, 3, true) -- large hill
            generate_bg_element(BG_CLOUD, sx+8, 11, 3, 2) -- small cloud
            generate_bg_element(BG_BUSH, sx+11, 2, 5, 1, true) -- large bush
        elseif (screenX + offset) % 3 == 1 then
            generate_bg_element(BG_HILL, sx-1, 3, 4, 2, true) -- small hill
            generate_bg_element(BG_CLOUD, sx+3, 12, 3, 2) -- small cloud
            generate_bg_element(BG_BUSH, sx+7, 2, 3, 1, true) -- small bush
            generate_bg_element(BG_CLOUD, sx+11, 11, 5, 2) -- large cloud
        else
            generate_bg_element(BG_CLOUD, sx+4, 12, 4, 2) -- medium cloud
            generate_bg_element(BG_BUSH, sx+9, 2, 4, 1, true) -- medium bush
        end
    end,
    -- just clouds (ex: 1-3)
    function(screenX, offset)
        local sx = screenX * 16
        if (screenX + offset) % 3 == 0 then
            generate_bg_element(BG_CLOUD, sx+3, 11, 4, 2) -- medium cloud
            generate_bg_element(BG_CLOUD, sx+9, 7, 3, 2) -- small cloud
        elseif (screenX + offset) % 3 == 1 then
            generate_bg_element(BG_CLOUD, sx+2, 12, 4, 2) -- medium cloud
            generate_bg_element(BG_CLOUD, sx+12, 3, 3, 2) -- small cloud
        else
            generate_bg_element(BG_CLOUD, sx+3, 7, 3, 2) -- small cloud
            generate_bg_element(BG_CLOUD, sx+6, 8, 3, 2) -- small cloud
            generate_bg_element(BG_CLOUD, sx+14, 3, 3, 2) -- small cloud (goes onto next screen)
        end
    end,
    -- plants, fences, and clouds (ex: 2-1)
    function(screenX, offset)
        local sx = screenX * 16
        if (screenX + offset) % 3 == 0 then
            generate_bg_element(BG_CLOUD, sx, 11, 4, 2) -- medium cloud
            generate_bg_element(BG_PLANT, sx+11, 3, 1, 2, true) -- short plant
            generate_bg_element(BG_PLANT, sx+13, 4, 1, 3, true) -- tall plant
            generate_bg_element(BG_FENCE, sx+14, 2, 4, 1, true) -- fence (goes on to next screen)
        elseif (screenX + offset) % 3 == 1 then
            generate_bg_element(BG_CLOUD, sx+2, 11, 3, 2) -- small cloud
            generate_bg_element(BG_PLANT, sx+5, 4, 1, 3, true) -- tall plant
            generate_bg_element(BG_PLANT, sx+7, 3, 1, 2, true) -- short plant
            generate_bg_element(BG_PLANT, sx+8, 3, 1, 2, true) -- short plant
            generate_bg_element(BG_CLOUD, sx+11, 12, 3, 2) -- small cloud
            generate_bg_element(BG_CLOUD, sx+14, 11, 4, 2) -- medium cloud (goes on to next screen)
        else
            generate_bg_element(BG_FENCE, sx+6, 2, 2, 1, true) -- fence (it's split into two for the plant in the middle)
            generate_bg_element(BG_PLANT, sx+8, 3, 1, 2, true) -- short plant
            generate_bg_element(BG_FENCE, sx+9, 2, 1, 1, true) -- fence (cont)
            generate_bg_element(BG_PLANT, sx+11, 4, 1, 3, true) -- tall plant
            generate_bg_element(BG_CLOUD, sx+13, 12, 3, 2) -- small cloud
        end
    end,
    -- water surface (2-2 and all other water stages)
    function(screenX, offset)
        local sx = screenX * 16
        for x=0,15 do
            local tile = get_tile_at_block(sx+x, 12, true)
            if tile == 0 then
                add_to_2d_table(loaded_tile_data, sx+x, 12, TILE_LIQUID_SURFACE)
            end
        end
    end,
}

-- loads a background element using bg_generate_sub_funcs
function generate_bg_element(element, x, y, width, height, checkGround)
    local thisFunc = bg_generate_sub_funcs[element]
    if not thisFunc then return end
    for x2=x,x+width-1 do
        if x2 >= loaded_tile_data.width then break end

        local valid = true
        if checkGround then
            local groundTile = get_tile_at_block(x2, 1)
            valid = (groundTile ~= 0)
        end

        if valid then
            for y2=y,y-height+1,-1 do
                local oldTile = get_tile_at_block(x2, y2, true)
                if oldTile == 0 then
                    thisFunc(x, y, x2, y2, width - 1, height - 1)
                end
            end
        end
    end
end

-- loads tiles based on the geometry for this area
function process_geometry_data(level, area)
    loaded_tile_data = {}
    local geo_data = geometry_data[level] and geometry_data[level][area]
    if not geo_data then
        log_to_console("INVALID AREA: " .. tostring(level) .. ", " .. tostring(area))
        -- load 7-2 by default (minus world)
        level, area = 26, 2
        geo_data = geometry_data[level][area]
    end
    loaded_obj_data = deep_copy(obj_data[level][area])

    loaded_tile_data.width = geo_data.width
    loaded_tile_data.theme = geo_data.theme
    loaded_tile_data.palette = geo_data.palette
    loaded_tile_data.bg = geo_data.bg
    loaded_tile_data.timer = geo_data.timer or 400
    loaded_tile_data.scrollStop = geo_data.scrollStop or 0
    loaded_tile_data.checkpoint = geo_data.checkpoint or 0
    loaded_tile_data.pipeCutscene = geo_data.pipeCutscene
    loaded_tile_data.bonusArea = geo_data.bonusArea

    local width = geo_data.width
    local height = 13
    curr_ground_height = 2
    curr_ceil_height = 0
    curr_ceil_tile = TILE_GROUND
    curr_pit_blocks = 0
    for x = 0, width - 1 do
        if not loaded_tile_data[x] then loaded_tile_data[x] = {} end
        for y = 0, height - 1 do
            if not loaded_tile_data[x][y] then loaded_tile_data[x][y] = 0 end
            local geo_command = geo_data[x] and geo_data[x][y]
            if geo_command and geo_command[1] and geo_cmd_funcs[geo_command[1]] then
                -- run once if width or height are 0 (these commands don't actually use these as width/height)
                if geo_command[3] == 0 or geo_command[4] == 0 then
                    geo_cmd_funcs[geo_command[1]](x, y, x, y, geo_command)
                else
                    for x2 = x, x + geo_command[3] - 1 do
                        local breakX = false
                        for y2 = y, y - geo_command[4] + 1, -1 do
                            if geo_cmd_funcs[geo_command[1]](x, y, x2, y2, geo_command) then
                                breakX = true
                                break
                            end
                        end
                        if breakX then break end
                    end
                end
            end

            if y < curr_ground_height and curr_pit_blocks == 0 and get_tile_at_block(x, y) == 0 then
                loaded_tile_data[x][y] = TILE_GROUND
            elseif y >= height - curr_ceil_height and get_tile_at_block(x, y) == 0 then
                loaded_tile_data[x][y] = curr_ceil_tile
            end
        end
        if curr_pit_blocks ~= 0 then curr_pit_blocks = curr_pit_blocks - 1 end
    end

    -- bg generation
    if geo_data.bg ~= 0 and bg_generate_funcs[geo_data.bg] then
        local screens = geo_data.width // 16
        for screenX=0,screens do
            bg_generate_funcs[geo_data.bg](screenX,(geo_data.bgOffset or 0))
        end
    end
end

-- adds to table at [x][y]
function add_to_2d_table(addTo, x, y, data)
    if addTo[x] == nil then addTo[x] = {} end
    addTo[x][y] = data
end

-- gets frame from the tileset to render based on the give tile
function get_tile_frame(tile)
    local frame = TILE_RENDER_DATA[tile]
    if frame and type(frame) == "table" then
        frame = (frame[loaded_tile_data.theme+1] or frame[1])
        if type(frame) == "table" then
            local timer = get_global_timer() % 24
            if #frame < 3 or timer < 12 then
                frame = frame[1]
            elseif timer >= 16 and timer < 20 then
                frame = frame[3]
            else
                frame = frame[2]
            end
        end
    end

    -- override for world 8 underwater
    local world = ((gNetworkPlayers[0].currActNum-1) // 4) + 1
    if frame == 64 and world == 8 then
        frame = 96
    end

    if frame and frame ~= -1 then
        local palette = loaded_tile_data.palette or loaded_tile_data.theme
        if palette < 4 then
            frame = frame + 128 * palette
        elseif frame % 32 > 7 and frame % 32 < 17 then
            frame = frame + 14 + 128 * (palette - 4)
        end
    end
    return frame
end

--- editor things ---
function print_level_data_command()
    local geo_data = geometry_data[gNetworkPlayers[0].currActNum][gNetworkPlayers[0].currAreaIndex]
    for x=0, geo_data.width do
        for y=0, 13 do
            local geo_command = geo_data[x] and geo_data[x][y]
            if geo_command then
                print("add_to_2d_table(this_geometry, "..x..", "..y..", { "..geo_command[1]..", "..geo_command[2]..", "..geo_command[3]..", "..geo_command[4].." })")
            end
        end
    end
    local curr_obj_table = obj_data[gNetworkPlayers[0].currActNum][gNetworkPlayers[0].currAreaIndex]
    for x=0, geo_data.width do
        for y=0, 13 do
            local this_obj_data = curr_obj_table[x] and curr_obj_table[x][y]
            if this_obj_data then
                local id_name, count, paramsExtra, hardModeExtra = "", 1, "", ""
                local o_id = this_obj_data[1]
                if o_id then
                    id_name = "id_"..get_behavior_name_from_id(o_id)
                end
                count = this_obj_data[2] or 1
                if this_obj_data[4] then
                    paramsExtra = string.format(", 0x%08x", (this_obj_data[3] or 0))
                    hardModeExtra = ", true"
                elseif this_obj_data[3] and this_obj_data[3] ~= 0 then
                    paramsExtra = string.format(", 0x%08x", this_obj_data[3])
                end
                print("add_to_2d_table(this_obj, "..x..", "..y..", { "..id_name..", "..count..paramsExtra..hardModeExtra.." })")
            end
        end
    end
    return true
end

if localOptionTable.debugEditor or _G.cheatsApi then
    geo_cmd_funcs_g = geo_cmd_funcs
    geometry_data_g = geometry_data
    obj_data_g = obj_data
    hook_chat_command("print_level", "- Prints geo and obj data for this level", print_level_data_command)
end

--- collision utils ---

-- gets the tile at this block (unlike SMB, (0,0) is the bottom left as opposed to the top left)
function get_tile_at_block(blockX_, blockY_, includeBG)
    local blockX, blockY = blockX_, blockY_
    if blockX < 0 then
        blockX = 0
    elseif not loaded_tile_data[blockX] then
        blockX = #loaded_tile_data
    end
    if blockY < 0 then
        blockY = 0
    end

    if loaded_tile_data[blockX] and loaded_tile_data[blockX][blockY] then
        local tile = loaded_tile_data[blockX][blockY]
        if tile >= 0 or (includeBG and blockX == blockX_) then
            return tile
        end
    end
    return 0
end

-- gets the tile at this coordinate point, also returns the pixel of the block
function get_tile_at_coordinate_pos(x, y, includeBG)
    x = math.floor(x)
    y = math.floor(y)
    local px = (y % BLOCK) // PX
    local blockX, blockY = (x // BLOCK), (y // BLOCK)
    return get_tile_at_block(blockX, blockY, includeBG), px
end

-- gets the tile based on the collider and mario's position
function get_tile_at_mario_collider(m, collider)
    -- clear platform
    if collider.type == COLLIDER_LEFT_FOOT or collider.type == COLLIDER_RIGHT_FOOT then
        gSMBStates[m.playerIndex].platform = nil
    end

    local blockX, blockY, px = get_block_coords_for_mario_collider(m, collider)
    local tile = get_tile_at_block(blockX, blockY)
    if tile == 0 and m.action & ACT_FLAG_INTANGIBLE == 0 then
        -- platform check
        local o = obj_get_first(OBJ_LIST_SURFACE)
        while o do
            local x = m.pos.x + collider.x * PX
            local y = m.pos.y + collider.y * PX
            x = math.floor(x)
            y = math.floor(y)
            if o.header.gfx.node.flags & GRAPH_RENDER_INVISIBLE == 0 and object_rect_hitbox_overlap(o, x, y, 0, 0) then
                tile = TILE_GROUND -- default
                px = ((y - (o.oPosY - o.hitboxDownOffset)) % BLOCK) // PX
                if px >= 10 and (collider.type == COLLIDER_LEFT_FOOT or collider.type == COLLIDER_RIGHT_FOOT) then
                    gSMBStates[m.playerIndex].platform = o
                end
                --djui_chat_message_create(tostring(px))
                break
            end
            o = obj_get_next(o)
        end
    end
    return tile, px
end

-- gets the block x and y values for the collider's point (and pixel of block)
function get_block_coords_for_mario_collider(m, collider)
    local smb = gSMBStates[m.playerIndex]
    local x = m.pos.x + collider.x * PX
    local y = m.pos.y + collider.y * PX
    x = math.floor(x)
    y = math.floor(y)
    -- if this collider is beyond the loop point, handle from left loop point
    if smb.loopScreenRight ~= 0 then
        local diff = 0
        if x > smb.loopScreenRight * 16 * BLOCK then
            diff = (smb.loopScreenLeft - smb.loopScreenRight) * 16
        elseif x <= smb.loopScreenLeft * 16 * BLOCK then
            diff = (smb.loopScreenRight - smb.loopScreenLeft) * 16
        end
        x = x + diff * BLOCK
    end
    local px = (y % BLOCK) // PX
    local blockX, blockY = (x // BLOCK), (y // BLOCK)
    return blockX, blockY, px
end

-- gets if the tile is solid or not
local NONSOLID_TILES = {
    [TILE_COIN] = 1,
    [TILE_HIDDEN_1UP] = 1,
    [TILE_HIDDEN_COIN] = 1,
}
function is_tile_solid(tile)
    local isBlock = is_tile_block(tile)
    return tile > 0 and ((isBlock and isBlock ~= 0) or (NONSOLID_TILES[tile] == nil))
end

-- gets if the tile is a block or not (in this table, 0 indicates a hidden block, used with is_tile_solid)
local BLOCK_TILES = {
    [TILE_BRICK] = 1,
    [TILE_QUESTION_COIN] = 1,
    [TILE_QUESTION_ITEM] = 1,
    [TILE_BRICK_COINS] = 1,
    [TILE_BRICK_1UP] = 1,
    [TILE_BRICK_STAR] = 1,
    [TILE_BRICK_ITEM] = 1,
    [TILE_BRICK_VINE] = 1,
    [TILE_HIDDEN_1UP] = 0,
    [TILE_HIDDEN_COIN] = 0,
}
function is_tile_block(tile)
    return BLOCK_TILES[tile]
end

--- level information ---
geometry_data[0] = {}
obj_data[0] = {}
--- title ---
geometry_data[0][1] = { width = 16, theme = 0, bg = 1, scrollStop = 15, timer = 0 }
obj_data[0][1] = {}
local this_geometry = geometry_data[0][1]
local this_obj = obj_data[0][1]

--- 1-1 ---
geometry_data[1] = {}
obj_data[1] = {}
-- area 1
geometry_data[1][1] = { width = 14 * 16, theme = 0, bg = 1, checkpoint = 5 }
obj_data[1][1] = {}
this_geometry = geometry_data[1][1]
this_obj = obj_data[1][1]
add_to_2d_table(this_geometry, 16, 5, { GEOMETRY_BLOCK_RECT, TILE_QUESTION_COIN, 1, 1 })
add_to_2d_table(this_geometry, 20, 5, { GEOMETRY_BLOCK_RECT, TILE_BRICK, 5, 1 })
add_to_2d_table(this_geometry, 21, 5, { GEOMETRY_BLOCK_RECT, TILE_QUESTION_ITEM, 1, 1 })
add_to_2d_table(this_geometry, 22, 9, { GEOMETRY_BLOCK_RECT, TILE_QUESTION_COIN, 1, 1 })
add_to_2d_table(this_geometry, 23, 5, { GEOMETRY_BLOCK_RECT, TILE_QUESTION_COIN, 1, 1 })
add_to_2d_table(this_geometry, 28, 3, { GEOMETRY_PIPE, TILE_PIPE_TOP_LEFT, 2, 2 })
add_to_2d_table(this_geometry, 38, 4, { GEOMETRY_PIPE, TILE_PIPE_TOP_LEFT, 2, 3 })
add_to_2d_table(this_geometry, 46, 5, { GEOMETRY_PIPE, TILE_PIPE_TOP_LEFT, 2, 4 })
add_to_2d_table(this_geometry, 57, 5, { GEOMETRY_PIPE, TILE_PIPE_ENTER_LEFT, 2, 4 })
add_to_2d_table(this_geometry, 64, 6, { GEOMETRY_BLOCK_RECT, TILE_HIDDEN_1UP, 1, 1 })
add_to_2d_table(this_geometry, 69, 0, { GEOMETRY_PIT, 0, 2, 0 })
add_to_2d_table(this_geometry, 77, 5, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 78, 5, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 80, 9, { 1, 3, 8, 1 })
add_to_2d_table(this_geometry, 86, 0, { 5, 3, 3, 2 })
add_to_2d_table(this_geometry, 91, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 94, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 94, 9, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 100, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 101, 5, { 1, 8, 1, 1 })
add_to_2d_table(this_geometry, 106, 5, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 109, 5, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 109, 9, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 112, 5, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 118, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 121, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 128, 9, { 1, 3, 4, 1 })
add_to_2d_table(this_geometry, 129, 5, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 129, 9, { 1, 4, 2, 1 })
add_to_2d_table(this_geometry, 134, 5, { 3, 2, 4, 4 })
add_to_2d_table(this_geometry, 140, 5, { 6, 2, 4, 4 })
add_to_2d_table(this_geometry, 148, 5, { 3, 2, 5, 4 })
add_to_2d_table(this_geometry, 153, 0, { 5, 2, 2, 4 })
add_to_2d_table(this_geometry, 155, 5, { 6, 2, 4, 4 })
add_to_2d_table(this_geometry, 163, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 168, 5, { 1, 3, 4, 1 })
add_to_2d_table(this_geometry, 170, 5, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 179, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 181, 9, { 3, 2, 9, 8 })
add_to_2d_table(this_geometry, 198, 12, { GEOMETRY_FLAG_POLE, 0, 1, 11 })
add_to_2d_table(this_geometry, 202, 6, { GEOMETRY_CASTLE, TILE_CASTLE_SOLID, 5, 5 })
add_to_2d_table(this_obj, 22, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 40, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 51, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 57, 0, { id_bhvSmbExitController, 1, 0x0002000a })
add_to_2d_table(this_obj, 80, 10, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 82, 10, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 97, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 107, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 114, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 124, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 128, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 174, 2, { id_bhvSmbGoomba, 2 })

-- area 2 (the classic bonus area)
geometry_data[1][2] = { width = 17, theme = 1, bg = 0, scrollStop = 15 }
obj_data[1][2] = {}
this_geometry = geometry_data[1][2]
this_obj = obj_data[1][2]
add_to_2d_table(this_geometry, 0, 12, { GEOMETRY_BLOCK_RECT, TILE_BRICK, 1, 11 })
add_to_2d_table(this_geometry, 4, 12, { GEOMETRY_BLOCK_RECT, TILE_BRICK, 7, 1 })
add_to_2d_table(this_geometry, 4, 4, { GEOMETRY_BLOCK_RECT, TILE_BRICK, 7, 3 })
add_to_2d_table(this_geometry, 4, 5, { GEOMETRY_BLOCK_RECT, TILE_COIN, 7, 1 })
add_to_2d_table(this_geometry, 4, 7, { GEOMETRY_BLOCK_RECT, TILE_COIN, 7, 1 })
add_to_2d_table(this_geometry, 5, 9, { GEOMETRY_BLOCK_RECT, TILE_COIN, 5, 1 })
add_to_2d_table(this_geometry, 13, 3, { GEOMETRY_PIPE_SIDE, TILE_PIPE_SIDEWAYS_TL, 3, 2 })
add_to_2d_table(this_geometry, 15, 12, { GEOMETRY_PIPE, TILE_PIPE_SIDE_LEFT, 2, 11 })

--- 1-2 ---
geometry_data[2] = {}
obj_data[2] = {}
-- area 1
geometry_data[2][1] = { width = 16, theme = 0, bg = 2, scrollStop = 15, pipeCutscene = true }
obj_data[2][1] = {}
this_geometry = geometry_data[2][1]
this_obj = obj_data[2][1]
add_to_2d_table(this_geometry, 0, 6, { 8, TILE_CASTLE_WALL, 5, 5 })
add_to_2d_table(this_geometry, 10, 3, { 4, 2, 3, 2 })
add_to_2d_table(this_geometry, 12, 5, { 2, 23, 2, 4 })
add_to_2d_table(this_obj, 12, 0, { id_bhvSmbExitController, 1, 0x00020000 })

-- area 2
geometry_data[2][2] = { width = 12 * 16 + 1, theme = 1, bg = 0, scrollStop = 12 * 16 - 1, checkpoint = 6 }
obj_data[2][2] = {}
this_geometry = geometry_data[2][2]
this_obj = obj_data[2][2]
add_to_2d_table(this_geometry, 0, 12, { 1, 3, 1, 11 })
add_to_2d_table(this_geometry, 6, 0, { 0, 3, 2, 1 })
add_to_2d_table(this_geometry, 10, 5, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 11, 5, { 1, 4, 4, 1 })
add_to_2d_table(this_geometry, 17, 2, { 1, 2, 1, 1 })
add_to_2d_table(this_geometry, 19, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 21, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 23, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 25, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 27, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 29, 6, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 31, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 33, 2, { 1, 2, 1, 1 })
add_to_2d_table(this_geometry, 33, 3, { 1, 2, 1, 1 })
add_to_2d_table(this_geometry, 39, 7, { 1, 3, 1, 3 })
add_to_2d_table(this_geometry, 40, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 40, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 41, 7, { 1, 3, 1, 3 })
add_to_2d_table(this_geometry, 41, 9, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 42, 7, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 44, 7, { 1, 3, 1, 3 })
add_to_2d_table(this_geometry, 45, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 45, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 46, 6, { 1, 3, 1, 2 })
add_to_2d_table(this_geometry, 46, 7, { 1, 8, 1, 1 })
add_to_2d_table(this_geometry, 52, 9, { 1, 3, 2, 5 })
add_to_2d_table(this_geometry, 54, 5, { 1, 3, 2, 3 })
add_to_2d_table(this_geometry, 54, 11, { 1, 3, 2, 2 })
add_to_2d_table(this_geometry, 58, 5, { 1, 3, 4, 1 })
add_to_2d_table(this_geometry, 58, 6, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 58, 11, { 1, 3, 4, 2 })
add_to_2d_table(this_geometry, 62, 11, { 1, 3, 2, 7 })
add_to_2d_table(this_geometry, 66, 11, { 1, 3, 4, 2 })
add_to_2d_table(this_geometry, 67, 9, { 1, 3, 1, 5 })
add_to_2d_table(this_geometry, 68, 5, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 68, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 69, 6, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 72, 9, { 1, 3, 2, 5 })
add_to_2d_table(this_geometry, 73, 6, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 76, 5, { 1, 3, 4, 1 })
add_to_2d_table(this_geometry, 76, 11, { 1, 3, 4, 2 })
add_to_2d_table(this_geometry, 80, 0, { 5, 3, 3, 1 })
add_to_2d_table(this_geometry, 84, 7, { 1, 3, 6, 2 })
add_to_2d_table(this_geometry, 84, 9, { 1, 12, 6, 1 })
add_to_2d_table(this_geometry, 89, 12, { 1, 9, 1, 1 })
add_to_2d_table(this_geometry, 103, 4, { 2, 23, 2, 3 })
add_to_2d_table(this_geometry, 109, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 115, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 120, 0, { 5, 3, 2, 1 })
add_to_2d_table(this_geometry, 122, 4, { 1, 3, 2, 3 })
add_to_2d_table(this_geometry, 124, 0, { 5, 3, 2, 1 })
add_to_2d_table(this_geometry, 133, 5, { 3, 2, 5, 4 })
add_to_2d_table(this_geometry, 138, 0, { 0, 3, 0, 0 })
add_to_2d_table(this_geometry, 145, 0, { 0, 3, 2, 0 })
add_to_2d_table(this_geometry, 145, 6, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 150, 6, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 153, 0, { 0, 3, 0, 0 })
add_to_2d_table(this_geometry, 160, 0, { 0, 3, 2, 0 })
add_to_2d_table(this_geometry, 160, 4, { 1, 3, 10, 3 })
add_to_2d_table(this_geometry, 161, 0, { 0, 3, 2, 1 })
add_to_2d_table(this_geometry, 166, 6, { 4, 2, 3, 2 })
add_to_2d_table(this_geometry, 168, 12, { 2, 15, 2, 8 })
add_to_2d_table(this_geometry, 170, 11, { 1, 3, 7, 10 })
add_to_2d_table(this_geometry, 178, 4, { 2, 29, 2, 3 })
add_to_2d_table(this_geometry, 182, 4, { 2, 29, 2, 3 })
add_to_2d_table(this_geometry, 186, 4, { 2, 29, 2, 3 })
add_to_2d_table(this_geometry, 187, 0, { 0, 3, 2, 0 })
add_to_2d_table(this_geometry, 190, 12, { 1, 3, 2, 11 })
add_to_2d_table(this_obj, 16, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 17, 3, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 29, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 44, 2, { id_bhvSmbKoopa, 2 })
add_to_2d_table(this_obj, 59, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 62, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 64, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 73, 10, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 76, 6, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 97, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 103, 0, { id_bhvSmbExitController, 1, 0x00030007 })
add_to_2d_table(this_obj, 113, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 135, 6, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 140, 1, { id_bhvSmbLoopingPlatform, 1 })
add_to_2d_table(this_obj, 140, 7, { id_bhvSmbLoopingPlatform, 1 })
add_to_2d_table(this_obj, 146, 2, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 155, 5, { id_bhvSmbLoopingPlatform, 1, 0x00000001 })
add_to_2d_table(this_obj, 155, 12, { id_bhvSmbLoopingPlatform, 1, 0x00000001 })
add_to_2d_table(this_obj, 166, 0, { id_bhvSmbExitController, 1, 0x00040000 })
add_to_2d_table(this_obj, 192, 0, { id_bhvSmbWarpZoneController, 1, 0x00040302 })

-- area 3 (coin row bonus area)
geometry_data[2][3] = { width = 17, theme = 1, bg = 0, scrollStop = 15 }
obj_data[2][3] = {}
this_geometry = geometry_data[2][3]
this_obj = obj_data[2][3]
add_to_2d_table(this_geometry, 0, 12, { 1, 3, 1, 11 })
add_to_2d_table(this_geometry, 3, 0, { 0, 3, 2, 4 })
add_to_2d_table(this_geometry, 3, 2, { 1, 12, 9, 1 })
add_to_2d_table(this_geometry, 3, 5, { 1, 3, 9, 1 })
add_to_2d_table(this_geometry, 4, 6, { 1, 12, 8, 1 })
add_to_2d_table(this_geometry, 12, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 13, 3, { 4, 17, 3, 2 })
add_to_2d_table(this_geometry, 13, 8, { 1, 3, 2, 5 })
add_to_2d_table(this_geometry, 15, 0, { 0, 3, 2, 0 })
add_to_2d_table(this_geometry, 15, 12, { 2, 15, 2, 11 })

-- area 4 (ending area)
geometry_data[2][4] = { width = 3 * 16, theme = 0, bg = 1, bgOffset = 2 }
obj_data[2][4] = {}
this_geometry = geometry_data[2][4]
this_obj = obj_data[2][4]
add_to_2d_table(this_geometry, 3, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 5, 9, { 3, 2, 9, 8 })
add_to_2d_table(this_geometry, 22, 12, { GEOMETRY_FLAG_POLE, 0, 1, 11 })
add_to_2d_table(this_geometry, 26, 6, { GEOMETRY_CASTLE, TILE_CASTLE_SOLID, 5, 5 })

--- 1-3 ---
geometry_data[3] = {}
obj_data[3] = {}
-- area 1
geometry_data[3][1] = { width = 11 * 16, theme = 0, bg = 2, checkpoint = 4, timer = 300 }
obj_data[3][1] = {}
this_geometry = geometry_data[3][1]
this_obj = obj_data[3][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 })
add_to_2d_table(this_geometry, 16, 0, { 0, 2, 0, 0 })
add_to_2d_table(this_geometry, 17, 2, { 10, 31, 4, 3 })
add_to_2d_table(this_geometry, 23, 5, { 10, 31, 9, 6 })
add_to_2d_table(this_geometry, 26, 9, { 10, 31, 5, 4 })
add_to_2d_table(this_geometry, 27, 10, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 32, 2, { 10, 31, 3, 3 })
add_to_2d_table(this_geometry, 33, 3, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 35, 6, { 10, 31, 5, 7 })
add_to_2d_table(this_geometry, 37, 12, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 40, 10, { 10, 31, 7, 11 })
add_to_2d_table(this_geometry, 50, 1, { 10, 31, 4, 2 })
add_to_2d_table(this_geometry, 50, 8, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 59, 1, { 10, 31, 5, 2 })
add_to_2d_table(this_geometry, 59, 4, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 60, 9, { 10, 31, 4, 8 })
add_to_2d_table(this_geometry, 60, 10, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 65, 1, { 10, 31, 5, 2 })
add_to_2d_table(this_geometry, 70, 5, { 10, 31, 3, 6 })
add_to_2d_table(this_geometry, 76, 8, { 10, 31, 6, 9 })
add_to_2d_table(this_geometry, 77, 10, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 85, 9, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 93, 10, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 97, 10, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 98, 3, { 10, 31, 4, 4 })
add_to_2d_table(this_geometry, 104, 7, { 10, 31, 8, 8 })
add_to_2d_table(this_geometry, 113, 1, { 10, 31, 3, 2 })
add_to_2d_table(this_geometry, 113, 2, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 116, 5, { 10, 31, 4, 6 })
add_to_2d_table(this_geometry, 120, 9, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 122, 5, { 10, 31, 4, 6 })
add_to_2d_table(this_geometry, 129, 0, { 0, 2, 2, 0 })
add_to_2d_table(this_geometry, 138, 5, { 1, 2, 2, 4 })
add_to_2d_table(this_geometry, 140, 7, { 1, 2, 2, 6 })
add_to_2d_table(this_geometry, 142, 9, { 1, 2, 2, 8 })
add_to_2d_table(this_geometry, 152, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 155, 12, { 8, 28, 9, 11 })
add_to_2d_table(this_geometry, 164, 7, { 9, 28, 12, 6 })
add_to_2d_table(this_obj, 17, 3, { id_bhvSmbBulletBillFrenzy, 1, 0x00000000, true })
add_to_2d_table(this_obj, 30, 10, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 44, 11, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 46, 11, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 56, 8, { id_bhvSmbMovingPlatform, 0, 0x00000001 })
add_to_2d_table(this_obj, 74, 10, { id_bhvSmbFlyingParatroopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 80, 10, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 87, 6, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 95, 5, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 110, 8, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 114, 9, { id_bhvSmbFlyingParatroopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 132, 8, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 133, 2, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 141, 0, { id_bhvSmbStopFrenzy, 1 })

--- 1-4 ---
geometry_data[4] = {}
obj_data[4] = {}
-- area 1
geometry_data[4][1] = { width = 10 * 16, scrollStop = 10 * 16 - 1, theme = 2, bg = 0, timer = 300 }
obj_data[4][1] = {}
this_geometry = geometry_data[4][1]
this_obj = obj_data[4][1]
add_to_2d_table(this_geometry, 0, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 0, 7, { 6, 1, 5, 3 })
add_to_2d_table(this_geometry, 13, 0, { 5, 1, 2, 1 })
add_to_2d_table(this_geometry, 13, 2, { 11, -28, 2, 3 })
add_to_2d_table(this_geometry, 23, 8, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 23, 9, { 1, 1, 1, 1 })
add_to_2d_table(this_geometry, 24, 0, { 0, 1, 5, 1 })
add_to_2d_table(this_geometry, 26, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 26, 1, { 11, -28, 3, 2 })
add_to_2d_table(this_geometry, 29, 4, { 1, 1, 3, 5 })
add_to_2d_table(this_geometry, 30, 4, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 30, 8, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 32, 1, { 11, -28, 3, 2 })
add_to_2d_table(this_geometry, 35, 0, { 0, 1, 6, 1 })
add_to_2d_table(this_geometry, 37, 0, { 0, 1, 6, 4 })
add_to_2d_table(this_geometry, 37, 8, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 49, 8, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 60, 8, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 67, 8, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 72, 0, { 0, 1, 5, 1 })
add_to_2d_table(this_geometry, 76, 5, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 80, 10, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 80, 11, { 1, 1, 1, 1 })
add_to_2d_table(this_geometry, 84, 5, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 88, 10, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 88, 11, { 1, 1, 1, 1 })
add_to_2d_table(this_geometry, 92, 5, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 97, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 104, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 106, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 107, 9, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 109, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 110, 9, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 112, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 113, 9, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 116, 4, { 1, 1, 4, 3 })
add_to_2d_table(this_geometry, 123, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 128, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 128, 1, { GEOMETRY_LIQUID, TILE_LIQUID_SURFACE, 13, 2 })
add_to_2d_table(this_geometry, 128, 4, { 1, TILE_CASTLE_BRIDGE, 13, 1 })
add_to_2d_table(this_geometry, 140, 5, { 1, TILE_BRIDGE_CHAIN, 1, 1 })
add_to_2d_table(this_geometry, 141, 0, { 0, 1, 6, 1 })
add_to_2d_table(this_geometry, 142, 0, { 0, 1, 6, 3 })
add_to_2d_table(this_geometry, 144, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_obj, 23, 8, { id_bhvSmbFireBarBase, 1, 0x00000001, true })
add_to_2d_table(this_obj, 27, 2, { id_bhvSmbPodoboo, 1, 0x00000000, true })
add_to_2d_table(this_obj, 30, 4, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 33, 2, { id_bhvSmbPodoboo, 1, 0x00000000, true })
add_to_2d_table(this_obj, 37, 8, { id_bhvSmbFireBarBase, 1, 0x00000001, true })
add_to_2d_table(this_obj, 49, 8, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 60, 8, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 67, 8, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 76, 5, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 80, 10, { id_bhvSmbFireBarBase, 1, 0x00000000, true })
add_to_2d_table(this_obj, 84, 5, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 88, 10, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 92, 5, { id_bhvSmbFireBarBase, 1, 0x00000001, true })
add_to_2d_table(this_obj, 104, 6, { id_bhvSmbBowserFlameFrenzy, 1 })
add_to_2d_table(this_obj, 135, 5, { id_bhvSmbBowser, 1 })
add_to_2d_table(this_obj, 139, 8, { id_bhvSmbMovingPlatform, 1, 0x00040000 })
add_to_2d_table(this_obj, 141, 6, { id_bhvSmbAxe, 1 })
add_to_2d_table(this_obj, 153, 2, { id_bhvSmbMessenger, 1 })

--- 2-1 ---
geometry_data[5] = {}
obj_data[5] = {}
-- area 1
geometry_data[5][1] = { width = 14 * 16, theme = 0, bg = 3, checkpoint = 6 }
obj_data[5][1] = {}
this_geometry = geometry_data[5][1]
this_obj = obj_data[5][1]
add_to_2d_table(this_geometry, 0, 11, { 1, -42, 1, 1 })
add_to_2d_table(this_geometry, 0, 12, { 8, -18, 5, 11 })
add_to_2d_table(this_geometry, 5, 7, { 9, -18, 2, 6 })
add_to_2d_table(this_geometry, 15, 5, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 16, 5, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 20, 6, { 3, 2, 5, 5 })
add_to_2d_table(this_geometry, 28, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 28, 9, { 1, 11, 1, 1 })
add_to_2d_table(this_geometry, 29, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 34, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 35, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 46, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 53, 5, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 53, 9, { 1, 4, 5, 1 })
add_to_2d_table(this_geometry, 54, 5, { 1, 4, 4, 1 })
add_to_2d_table(this_geometry, 68, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 69, 9, { 1, 8, 1, 1 })
add_to_2d_table(this_geometry, 70, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 74, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 79, 5, { 1, 4, 4, 1 })
add_to_2d_table(this_geometry, 81, 9, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 83, 9, { 1, 26, 1, 1 })
add_to_2d_table(this_geometry, 85, 5, { 1, 4, 3, 1 })
add_to_2d_table(this_geometry, 92, 0, { 5, 3, 4, 1 })
add_to_2d_table(this_geometry, 92, 9, { 1, 3, 4, 1 })
add_to_2d_table(this_geometry, 103, 5, { 2, 23, 2, 4 })
add_to_2d_table(this_geometry, 106, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 115, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 122, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 125, 9, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 126, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 126, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 130, 6, { 2, 13, 2, 5 })
add_to_2d_table(this_geometry, 139, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 152, 0, { 5, 18, 2, 1 })
add_to_2d_table(this_geometry, 154, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 161, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 164, 9, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 170, 5, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 172, 9, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 176, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 185, 5, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 186, 9, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 188, 2, { 1, TILE_INVISIBLE_BLOCK, 1, 1 }) -- inside of the springboard so it has side collision
add_to_2d_table(this_geometry, 190, 11, { 1, 2, 2, 10 })
add_to_2d_table(this_geometry, 200, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 204, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 24, 8, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 32, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 33, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 42, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 55, 6, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 59, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 66, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 83, 0, { id_bhvSmbExitController, 1, 0x0002000a })
add_to_2d_table(this_obj, 85, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 103, 0, { id_bhvSmbExitController, 1, 0x00030007 })
add_to_2d_table(this_obj, 103, 6, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 116, 4, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 120, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 137, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 151, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 162, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 169, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 171, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 185, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 188, 2, { id_bhvSmbSpringboard, 1 })

-- area 2 (cloud bonus area)
geometry_data[5][2] = { width = 5 * 16, scrollStop = 5 * 16 - 1, theme = 0, bg = 0, bonusArea = true }
obj_data[5][2] = {}
this_geometry = geometry_data[5][2]
this_obj = obj_data[5][2]
add_to_2d_table(this_geometry, 0, 0, { 0, 2, 0, 0 })
add_to_2d_table(this_geometry, 0, 1, { 1, 39, 4, 1 })
add_to_2d_table(this_geometry, 5, 1, { 1, 39, 57, 1 })
add_to_2d_table(this_geometry, 15, 8, { 1, 12, 16, 1 })
add_to_2d_table(this_geometry, 32, 10, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 36, 9, { 1, 12, 16, 1 })
add_to_2d_table(this_geometry, 53, 10, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 69, 2, { 1, 12, 3, 1 })
add_to_2d_table(this_obj, 17, 4, { id_bhvSmbCloudPlatform, 1 })

-- area 3 (copy of 1-1's bonus area)
geometry_data[5][3] = geometry_data[1][2]
obj_data[5][3] = obj_data[1][2]

--- 2-2 ---
geometry_data[6] = {}
obj_data[6] = {}
-- area 1 (pipe entrance, copied from 1-2)
geometry_data[6][1] = geometry_data[2][1]
obj_data[6][1] = obj_data[2][1]

-- area 2
geometry_data[6][2] = { width = 12 * 16 + 1, scrollStop = 12 * 16 - 1, theme = 3, bg = 4, checkpoint = 5 }
obj_data[6][2] = {}
this_geometry = geometry_data[6][2]
this_obj = obj_data[6][2]
add_to_2d_table(this_geometry, 11, 4, { 1, 40, 1, 3 })
add_to_2d_table(this_geometry, 14, 2, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 18, 5, { 1, 1, 3, 1 })
add_to_2d_table(this_geometry, 27, 9, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 33, 6, { 1, 40, 1, 5 })
add_to_2d_table(this_geometry, 36, 2, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 41, 5, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 41, 7, { 1, 40, 1, 2 })
add_to_2d_table(this_geometry, 50, 5, { 1, 40, 1, 4 })
add_to_2d_table(this_geometry, 64, 4, { 1, 1, 1, 3 })
add_to_2d_table(this_geometry, 65, 6, { 1, 1, 1, 5 })
add_to_2d_table(this_geometry, 66, 0, { 5, 2, 5, 1 })
add_to_2d_table(this_geometry, 67, 4, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 71, 6, { 1, 1, 1, 5 })
add_to_2d_table(this_geometry, 72, 4, { 1, 1, 1, 3 })
add_to_2d_table(this_geometry, 78, 4, { 1, 1, 2, 3 })
add_to_2d_table(this_geometry, 78, 12, { 1, 1, 2, 3 })
add_to_2d_table(this_geometry, 82, 9, { 1, 1, 3, 1 })
add_to_2d_table(this_geometry, 83, 11, { 1, 40, 1, 2 })
add_to_2d_table(this_geometry, 89, 4, { 1, 40, 1, 3 })
add_to_2d_table(this_geometry, 101, 3, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 102, 5, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 102, 9, { 1, 40, 1, 4 })
add_to_2d_table(this_geometry, 113, 8, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 115, 6, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 120, 5, { 1, 40, 1, 4 })
add_to_2d_table(this_geometry, 129, 5, { 1, 1, 1, 4 })
add_to_2d_table(this_geometry, 130, 3, { 1, 1, 1, 2 })
add_to_2d_table(this_geometry, 131, 0, { 5, 2, 9, 1 })
add_to_2d_table(this_geometry, 131, 12, { 1, 1, 1, 3 })
add_to_2d_table(this_geometry, 132, 10, { 1, 1, 8, 1 })
add_to_2d_table(this_geometry, 133, 3, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 134, 2, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 137, 3, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 140, 3, { 1, 1, 1, 2 })
add_to_2d_table(this_geometry, 141, 5, { 1, 1, 1, 4 })
add_to_2d_table(this_geometry, 147, 3, { 1, 40, 1, 2 })
add_to_2d_table(this_geometry, 149, 4, { 1, 40, 1, 3 })
add_to_2d_table(this_geometry, 156, 8, { 1, 1, 1, 7 })
add_to_2d_table(this_geometry, 156, 9, { 1, 1, 3, 1 })
add_to_2d_table(this_geometry, 157, 0, { 5, 9, 7, 1 })
add_to_2d_table(this_geometry, 159, 2, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 159, 5, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 162, 9, { 1, 1, 3, 1 })
add_to_2d_table(this_geometry, 164, 8, { 1, 1, 1, 7 })
add_to_2d_table(this_geometry, 172, 5, { 1, 1, 5, 1 })
add_to_2d_table(this_geometry, 172, 9, { 1, 1, 5, 1 })
add_to_2d_table(this_geometry, 173, 11, { 1, 40, 1, 2 })
add_to_2d_table(this_geometry, 180, 5, { 1, 1, 4, 1 })
add_to_2d_table(this_geometry, 180, 9, { 1, 1, 4, 1 })
add_to_2d_table(this_geometry, 185, 5, { 3, 1, 5, 4 })
add_to_2d_table(this_geometry, 188, 12, { 1, 1, 2, 4 })
add_to_2d_table(this_geometry, 189, 7, { 4, 2, 1, 2 })
add_to_2d_table(this_geometry, 190, 12, { 1, 1, 2, 11 })
add_to_2d_table(this_obj, 22, 2, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 25, 6, { id_bhvSmbBlooper, 1, 0x00000000, true })
add_to_2d_table(this_obj, 46, 4, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 52, 6, { id_bhvSmbBlooper, 1, 0x00000000, true })
add_to_2d_table(this_obj, 55, 3, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 71, 5, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 77, 7, { id_bhvSmbBlooper, 1, 0x00000000, true })
add_to_2d_table(this_obj, 80, 0, { id_bhvSmbUwFishFrenzy, 1 })
add_to_2d_table(this_obj, 83, 5, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 90, 2, { id_bhvSmbBlooper, 1, 0x00000000, true })
add_to_2d_table(this_obj, 94, 10, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 105, 2, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 150, 5, { id_bhvSmbBlooper, 1, 0x00000000, true })
add_to_2d_table(this_obj, 173, 2, { id_bhvSmbBlooper, 1, 0x00000000, true })
add_to_2d_table(this_obj, 179, 2, { id_bhvSmbBlooper, 1, 0x00000000, true })
add_to_2d_table(this_obj, 189, 0, { id_bhvSmbExitController, 1, 0x00030000 })
add_to_2d_table(this_obj, 192, 0, { id_bhvSmbStopFrenzy, 1 })

-- area 3 (ending area also copied from 1-2)
geometry_data[6][3] = geometry_data[2][4]
obj_data[6][3] = obj_data[2][4]

--- 2-3 ---
geometry_data[7] = {}
obj_data[7] = {}
-- area 1
geometry_data[7][1] = { width = 16 * 16, theme = 0, bg = 2, checkpoint = 7, timer = 300 }
obj_data[7][1] = {}
this_geometry = geometry_data[7][1]
this_obj = obj_data[7][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 })
add_to_2d_table(this_geometry, 7, 0, { 0, 2, 0, 0 })
add_to_2d_table(this_geometry, 8, 1, { 10, 31, 8, 2 })
add_to_2d_table(this_geometry, 10, 4, { 3, 2, 5, 3 })
add_to_2d_table(this_geometry, 15, 5, { 12, 2, 16, 2 })
add_to_2d_table(this_geometry, 31, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 32, 5, { 12, 0, 15, 2 })
add_to_2d_table(this_geometry, 36, 9, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 47, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 48, 5, { 12, 2, 16, 2 })
add_to_2d_table(this_geometry, 55, 9, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 56, 8, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 57, 9, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 58, 8, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 59, 9, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 63, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 68, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 69, 5, { 12, 2, 10, 2 })
add_to_2d_table(this_geometry, 72, 9, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 73, 10, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 75, 9, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 79, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 84, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 85, 5, { 12, 2, 10, 2 })
add_to_2d_table(this_geometry, 95, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 97, 9, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 99, 5, { 1, 2, 1, 6 })
add_to_2d_table(this_geometry, 100, 6, { 12, 2, 5, 2 })
add_to_2d_table(this_geometry, 102, 9, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 105, 5, { 1, 2, 1, 6 })
add_to_2d_table(this_geometry, 108, 9, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 112, 1, { 10, 31, 8, 2 })
add_to_2d_table(this_geometry, 122, 5, { 12, 2, 3, 2 })
add_to_2d_table(this_geometry, 127, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 128, 5, { 12, 2, 15, 2 })
add_to_2d_table(this_geometry, 133, 9, { 1, 12, 6, 1 })
add_to_2d_table(this_geometry, 143, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 146, 2, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 147, 3, { 12, 2, 8, 2 })
add_to_2d_table(this_geometry, 149, 6, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 155, 2, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 159, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 160, 5, { 12, 2, 8, 2 })
add_to_2d_table(this_geometry, 168, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 171, 5, { 12, 2, 2, 2 })
add_to_2d_table(this_geometry, 173, 8, { 1, 12, 6, 1 })
add_to_2d_table(this_geometry, 175, 5, { 12, 2, 2, 2 })
add_to_2d_table(this_geometry, 179, 5, { 12, 2, 2, 2 })
add_to_2d_table(this_geometry, 183, 4, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 184, 5, { 12, 2, 9, 2 })
add_to_2d_table(this_geometry, 192, 1, { 10, 31, 13, 2 })
add_to_2d_table(this_geometry, 193, 4, { 6, 2, 4, 3 })
add_to_2d_table(this_geometry, 207, 0, { 0, 1, 2, 0 })
add_to_2d_table(this_geometry, 208, 9, { 3, 2, 9, 8 })
add_to_2d_table(this_geometry, 225, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 228, 12, { 8, 28, 9, 11 })
add_to_2d_table(this_geometry, 237, 7, { 9, 2, 19, 6 })
add_to_2d_table(this_obj, 26, 0, { id_bhvSmbFlyingFishFrenzy, 1 })
add_to_2d_table(this_obj, 39, 5, { id_bhvSmbKoopa, 1, 0x00000000, true })
add_to_2d_table(this_obj, 52, 5, { id_bhvSmbBouncingParatroopa, 1, 0x00000000, true })
add_to_2d_table(this_obj, 79, 5, { id_bhvSmbKoopa, 1, 0x00000001, true })
add_to_2d_table(this_obj, 95, 5, { id_bhvSmbKoopa, 1, 0x00000001, true })
add_to_2d_table(this_obj, 119, 2, { id_bhvSmbKoopa, 1, 0x00000001, true })
add_to_2d_table(this_obj, 140, 7, { id_bhvSmbFlyingParatroopa, 1, 0x00000000, true })
add_to_2d_table(this_obj, 156, 5, { id_bhvSmbFlyingParatroopa, 1, 0x00000000, true })
add_to_2d_table(this_obj, 197, 0, { id_bhvSmbStopFrenzy, 1 })

--- 2-4 ---
geometry_data[8] = {}
obj_data[8] = {}
-- area 1
geometry_data[8][1] = { width = 10 * 16, scrollStop = 10 * 16 - 1, theme = 2, bg = 0, timer = 300 }
obj_data[8][1] = {}
this_geometry = geometry_data[8][1]
this_obj = obj_data[8][1]
add_to_2d_table(this_geometry, 0, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 0, 7, { 6, 1, 5, 3 })
add_to_2d_table(this_geometry, 16, 0, { 0, 2, 0, 0 })
add_to_2d_table(this_geometry, 16, 1, { 11, 2, 16, 2 })
add_to_2d_table(this_geometry, 18, 5, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 22, 7, { 1, 1, 3, 1 })
add_to_2d_table(this_geometry, 23, 7, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 23, 11, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 27, 5, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 32, 0, { 0, 1, 5, 0 })
add_to_2d_table(this_geometry, 34, 0, { 0, 1, 2, 4 })
add_to_2d_table(this_geometry, 37, 5, { 1, 1, 12, 1 })
add_to_2d_table(this_geometry, 43, 1, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 49, 5, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 50, 5, { 1, 1, 11, 1 })
add_to_2d_table(this_geometry, 55, 1, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 55, 9, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 61, 5, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 62, 5, { 1, 1, 11, 1 })
add_to_2d_table(this_geometry, 67, 1, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 73, 5, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 80, 0, { 0, 1, 5, 4 })
add_to_2d_table(this_geometry, 82, 8, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 83, 0, { 0, 1, 5, 0 })
add_to_2d_table(this_geometry, 84, 0, { 5, 1, 8, 1 })
add_to_2d_table(this_geometry, 86, 12, { 1, -37, 1, 13 })
add_to_2d_table(this_geometry, 89, 12, { 1, -37, 1, 13 })
add_to_2d_table(this_geometry, 92, 4, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 93, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 99, 0, { 0, 1, 2, 0 })
add_to_2d_table(this_geometry, 102, 2, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 102, 6, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 103, 3, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 108, 4, { 1, 1, 1, 3 })
add_to_2d_table(this_geometry, 109, 0, { 5, 1, 2, 1 })
add_to_2d_table(this_geometry, 109, 1, { 11, 2, 2, 2 })
add_to_2d_table(this_geometry, 111, 4, { 1, 1, 2, 3 })
add_to_2d_table(this_geometry, 113, 0, { 5, 1, 2, 1 })
add_to_2d_table(this_geometry, 113, 1, { 11, 2, 2, 2 })
add_to_2d_table(this_geometry, 115, 0, { 0, 1, 2, 3 })
add_to_2d_table(this_geometry, 115, 4, { 1, 1, 5, 3 })
add_to_2d_table(this_geometry, 122, 4, { 1, 1, 2, 3 })
add_to_2d_table(this_geometry, 126, 4, { 1, 1, 2, 3 })
add_to_2d_table(this_geometry, 128, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 128, 1, { 11, 2, 13, 2 })
add_to_2d_table(this_geometry, 128, 4, { 1, 37, 13, 1 })
add_to_2d_table(this_geometry, 128, 9, { 1, 3, 6, 1 })
add_to_2d_table(this_geometry, 140, 5, { 1, TILE_BRIDGE_CHAIN, 1, 1 })
add_to_2d_table(this_geometry, 141, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 141, 5, { 1, 1, 3, 4 })
add_to_2d_table(this_geometry, 142, 11, { 1, 1, 2, 3 })
add_to_2d_table(this_obj, 16, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 20, 2, { id_bhvSmbPodoboo, 1, 0x00000000, true })
add_to_2d_table(this_obj, 23, 7, { id_bhvSmbFireBarBase, 1, 0x00010000, true })
add_to_2d_table(this_obj, 30, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 43, 1, { id_bhvSmbFireBarBase, 1, 0x00000000, true })
add_to_2d_table(this_obj, 49, 5, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 55, 1, { id_bhvSmbFireBarBase, 1, 0x00000000, true })
add_to_2d_table(this_obj, 55, 9, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 61, 5, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 67, 1, { id_bhvSmbFireBarBase, 1, 0x00000001, true })
add_to_2d_table(this_obj, 73, 5, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 82, 8, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 86, 4, { id_bhvSmbLoopingPlatform, 1, 0x00030001 })
add_to_2d_table(this_obj, 86, 12, { id_bhvSmbLoopingPlatform, 1, 0x00030001 })
add_to_2d_table(this_obj, 89, 4, { id_bhvSmbLoopingPlatform, 1, 0x00030000 })
add_to_2d_table(this_obj, 89, 12, { id_bhvSmbLoopingPlatform, 1, 0x00030000 })
add_to_2d_table(this_obj, 92, 4, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 98, 12, { id_bhvSmbBowserFlameFrenzy, 1 })
add_to_2d_table(this_obj, 103, 3, { id_bhvSmbFireBarBase, 1, 0x00000100, true })
add_to_2d_table(this_obj, 109, 2, { id_bhvSmbPodoboo, 1, 0x00000000, true })
add_to_2d_table(this_obj, 113, 2, { id_bhvSmbPodoboo, 1, 0x00000000, true })
add_to_2d_table(this_obj, 131, 2, { id_bhvSmbPodoboo, 1, 0x00000000, true })
add_to_2d_table(this_obj, 135, 5, { id_bhvSmbBowser, 1 })
add_to_2d_table(this_obj, 139, 8, { id_bhvSmbMovingPlatform, 1, 0x00040000 })
add_to_2d_table(this_obj, 141, 6, { id_bhvSmbAxe, 1 })
add_to_2d_table(this_obj, 153, 2, { id_bhvSmbMessenger, 1 })

--- 3-1 ---
geometry_data[9] = {}
obj_data[9] = {}
-- area 1
geometry_data[9][1] = { width = 14 * 16, theme = 5, bg = 3, checkpoint = 6 }
obj_data[9][1] = {}
this_geometry = geometry_data[9][1]
this_obj = obj_data[9][1]
add_to_2d_table(this_geometry, 0, 12, { 8, -18, 5, 11 })
add_to_2d_table(this_geometry, 5, 7, { 9, -18, 2, 6 })
add_to_2d_table(this_geometry, 16, 5, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 19, 6, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 22, 6, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 26, 5, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 32, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 38, 5, { 2, 23, 2, 4 })
add_to_2d_table(this_geometry, 45, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 57, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 61, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 67, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 73, 5, { 3, 2, 4, 4 })
add_to_2d_table(this_geometry, 77, 0, { 5, 2, 8, 2 })
add_to_2d_table(this_geometry, 77, 2, { 11, 2, 11, 3 })
add_to_2d_table(this_geometry, 77, 6, { 12, 2, 8, 2 })
add_to_2d_table(this_geometry, 82, 9, { 1, 11, 1, 1 })
add_to_2d_table(this_geometry, 85, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 86, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 88, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 89, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 90, 9, { 1, 8, 1, 1 })
add_to_2d_table(this_geometry, 91, 9, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 103, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 111, 5, { 1, 3, 11, 1 })
add_to_2d_table(this_geometry, 111, 9, { 1, 3, 10, 1 })
add_to_2d_table(this_geometry, 113, 9, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 117, 9, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 126, 2, { 1, TILE_INVISIBLE_BLOCK, 1, 1 }) -- inside of the springboard so it has side collision
add_to_2d_table(this_geometry, 128, 0, { 5, 2, 4, 1 })
add_to_2d_table(this_geometry, 129, 6, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 129, 9, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 131, 9, { 1, 26, 1, 1 })
add_to_2d_table(this_geometry, 136, 7, { 3, 2, 6, 6 })
add_to_2d_table(this_geometry, 142, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 150, 5, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 150, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 151, 5, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 151, 9, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 155, 5, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 155, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 156, 5, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 156, 9, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 166, 5, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 167, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 174, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 175, 7, { 1, 2, 1, 6 })
add_to_2d_table(this_geometry, 177, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 183, 9, { 3, 2, 9, 8 })
add_to_2d_table(this_geometry, 200, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 204, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 25, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 28, 3, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 37, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 38, 0, { id_bhvSmbExitController, 1, 0x00020004 })
add_to_2d_table(this_obj, 51, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 65, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 80, 6, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 94, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 101, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 113, 6, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 116, 2, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 126, 2, { id_bhvSmbSpringboard, 1 })
add_to_2d_table(this_obj, 131, 0, { id_bhvSmbExitController, 1, 0x0003000a })
add_to_2d_table(this_obj, 139, 6, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 140, 7, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 149, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 152, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 152, 10, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 165, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 168, 3, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 170, 7, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 171, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 188, 8, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 191, 10, { id_bhvSmbKoopa, 1 })

-- area 2 (W-shaped bonus area)
geometry_data[9][2] = { width = 17, theme = 1, bg = 0, scrollStop = 15 }
obj_data[9][2] = {}
this_geometry = geometry_data[9][2]
this_obj = obj_data[9][2]
add_to_2d_table(this_geometry, 0, 12, { 1, 3, 1, 11 })
add_to_2d_table(this_geometry, 3, 7, { 1, 3, 1, 2 })
add_to_2d_table(this_geometry, 3, 9, { 1, 3, 2, 2 })
add_to_2d_table(this_geometry, 4, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 4, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 5, 6, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 5, 7, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 5, 9, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 6, 7, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 6, 8, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 6, 10, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 7, 9, { 1, 3, 2, 2 })
add_to_2d_table(this_geometry, 7, 11, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 9, 7, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 9, 8, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 10, 6, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 10, 7, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 10, 9, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 11, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 11, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 11, 9, { 1, 3, 2, 2 })
add_to_2d_table(this_geometry, 12, 7, { 1, 3, 1, 2 })
add_to_2d_table(this_geometry, 13, 3, { 4, 17, 3, 2 })
add_to_2d_table(this_geometry, 15, 0, { 0, 3, 2, 0 })
add_to_2d_table(this_geometry, 15, 12, { 2, 15, 2, 11 })

-- area 3 (cloud bonus area 2)
geometry_data[9][3] = { width = 6 * 16, scrollStop = 6 * 16 - 1, theme = 5, bg = 0, bonusArea = true }
obj_data[9][3] = {}
this_geometry = geometry_data[9][3]
this_obj = obj_data[9][3]
add_to_2d_table(this_geometry, 0, 0, { 0, 2, 0, 0 })
add_to_2d_table(this_geometry, 0, 1, { 1, 39, 4, 1 })
add_to_2d_table(this_geometry, 5, 1, { 1, 39, 57, 1 })
add_to_2d_table(this_geometry, 15, 8, { 1, 12, 16, 1 })
add_to_2d_table(this_geometry, 32, 6, { 1, 39, 1, 1 })
add_to_2d_table(this_geometry, 34, 8, { 1, 12, 16, 1 })
add_to_2d_table(this_geometry, 51, 7, { 1, 39, 1, 2 })
add_to_2d_table(this_geometry, 53, 9, { 1, 12, 7, 1 })
add_to_2d_table(this_geometry, 61, 7, { 1, 39, 1, 2 })
add_to_2d_table(this_geometry, 62, 1, { 1, 39, 16, 1 })
add_to_2d_table(this_geometry, 67, 8, { 1, 39, 2, 1 })
add_to_2d_table(this_geometry, 71, 8, { 1, 39, 1, 1 })
add_to_2d_table(this_geometry, 71, 9, { 1, 12, 10, 1 })
add_to_2d_table(this_geometry, 73, 8, { 1, 39, 1, 1 })
add_to_2d_table(this_geometry, 75, 8, { 1, 39, 1, 1 })
add_to_2d_table(this_geometry, 77, 8, { 1, 39, 1, 1 })
add_to_2d_table(this_geometry, 78, 1, { 1, 39, 5, 1 })
add_to_2d_table(this_geometry, 79, 8, { 1, 39, 1, 1 })
add_to_2d_table(this_geometry, 85, 3, { 1, 12, 3, 1 })
add_to_2d_table(this_obj, 17, 4, { id_bhvSmbCloudPlatform, 1 })

--- 3-2 ---
geometry_data[10] = {}
obj_data[10] = {}
-- area 1
geometry_data[10][1] = { width = 15 * 16, theme = 5, bg = 3, checkpoint = 6, timer = 300 }
obj_data[10][1] = {}
this_geometry = geometry_data[10][1]
this_obj = obj_data[10][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 })
add_to_2d_table(this_geometry, 49, 2, { 1, 2, 1, 1 })
add_to_2d_table(this_geometry, 55, 5, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 60, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 60, 8, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 75, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 77, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 77, 9, { 1, 8, 1, 1 })
add_to_2d_table(this_geometry, 79, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 80, 0, { 5, 2, 2, 4 })
add_to_2d_table(this_geometry, 123, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 126, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 126, 8, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 128, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 168, 8, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 169, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 192, 9, { 3, 2, 9, 8 })
add_to_2d_table(this_geometry, 209, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 213, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 17, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 22, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 31, 2, { id_bhvSmbKoopa, 3 })
add_to_2d_table(this_obj, 43, 2, { id_bhvSmbKoopa, 2 })
add_to_2d_table(this_obj, 66, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 69, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 78, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 92, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 111, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 117, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 134, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 138, 2, { id_bhvSmbKoopa, 3 })
add_to_2d_table(this_obj, 150, 2, { id_bhvSmbKoopa, 2 })
add_to_2d_table(this_obj, 160, 2, { id_bhvSmbKoopa, 3 })
add_to_2d_table(this_obj, 175, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 177, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 186, 2, { id_bhvSmbGoomba, 3 })

--- 3-3 ---
geometry_data[11] = {}
obj_data[11] = {}
-- area 1
geometry_data[11][1] = { width = 11 * 16, palette = 0, theme = 5, bg = 2, checkpoint = 4, timer = 300 }
obj_data[11][1] = {}
this_geometry = geometry_data[11][1]
this_obj = obj_data[11][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 })
add_to_2d_table(this_geometry, 16, 0, { 0, 2, 0, 0 })
add_to_2d_table(this_geometry, 18, 4, { 10, 31, 5, 5 })
add_to_2d_table(this_geometry, 22, 7, { 10, 31, 5, 8 })
add_to_2d_table(this_geometry, 30, 1, { 10, 31, 3, 2 })
add_to_2d_table(this_geometry, 31, 2, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 36, 2, { 10, 31, 7, 3 })
add_to_2d_table(this_geometry, 37, 8, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 42, 8, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 43, 5, { 10, 31, 4, 6 })
add_to_2d_table(this_geometry, 46, 3, { 10, 31, 10, 4 })
add_to_2d_table(this_geometry, 47, 7, { 10, 31, 6, 4 })
add_to_2d_table(this_geometry, 49, 11, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 52, 5, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 55, 11, { 10, 31, 4, 12 })
add_to_2d_table(this_geometry, 56, 12, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 65, 1, { 10, 31, 16, 2 })
add_to_2d_table(this_geometry, 65, 7, { 10, 31, 3, 6 })
add_to_2d_table(this_geometry, 66, 8, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 69, 7, { 10, 31, 3, 6 })
add_to_2d_table(this_geometry, 70, 8, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 73, 7, { 10, 31, 3, 6 })
add_to_2d_table(this_geometry, 74, 8, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 77, 10, { 10, 31, 3, 9 })
add_to_2d_table(this_geometry, 78, 11, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 81, 9, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 82, 12, { 13, 2, 8, 1 })
add_to_2d_table(this_geometry, 84, 3, { 10, 31, 4, 4 })
add_to_2d_table(this_geometry, 88, 9, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 90, 9, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 97, 5, { 10, 31, 3, 6 })
add_to_2d_table(this_geometry, 104, 9, { 10, 31, 4, 10 })
add_to_2d_table(this_geometry, 105, 10, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 107, 3, { 10, 31, 5, 4 })
add_to_2d_table(this_geometry, 108, 4, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 108, 7, { 10, 31, 3, 4 })
add_to_2d_table(this_geometry, 109, 8, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 116, 1, { 10, 31, 3, 2 })
add_to_2d_table(this_geometry, 119, 4, { 10, 31, 12, 5 })
add_to_2d_table(this_geometry, 137, 12, { 13, 2, 5, 1 })
add_to_2d_table(this_geometry, 144, 0, { 0, 1, 2, 0 })
add_to_2d_table(this_geometry, 151, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 154, 12, { 8, 28, 9, 11 })
add_to_2d_table(this_geometry, 163, 7, { 9, 28, 13, 6 })
add_to_2d_table(this_obj, 25, 8, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 31, 10, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 34, 6, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 52, 8, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 54, 4, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 61, 8, { id_bhvSmbFallingPlatform, 1 })
add_to_2d_table(this_obj, 73, 2, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 82, 8, { id_bhvSmbPulleyPlatform, 1 })
add_to_2d_table(this_obj, 89, 6, { id_bhvSmbPulleyPlatform, 1 })
add_to_2d_table(this_obj, 95, 5, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 97, 9, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 104, 3, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 114, 9, { id_bhvSmbFlyingParatroopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 124, 5, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 126, 5, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 133, 8, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 137, 9, { id_bhvSmbPulleyPlatform, 0, 0x00000001 })
add_to_2d_table(this_obj, 141, 6, { id_bhvSmbPulleyPlatform, 1, 0x00000001 })

--- 3-4 ---
geometry_data[12] = {}
obj_data[12] = {}
-- area 1
geometry_data[12][1] = { width = 10 * 16, scrollStop = 10 * 16 - 1, theme = 2, bg = 0, timer = 300 }
obj_data[12][1] = {}
this_geometry = geometry_data[12][1]
this_obj = obj_data[12][1]
add_to_2d_table(this_geometry, 0, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 0, 7, { 6, 1, 5, 3 })
add_to_2d_table(this_geometry, 16, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 18, 4, { 1, 1, 3, 5 })
add_to_2d_table(this_geometry, 19, 3, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 23, 4, { 1, 1, 3, 5 })
add_to_2d_table(this_geometry, 24, 3, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 28, 4, { 1, 1, 3, 5 })
add_to_2d_table(this_geometry, 29, 3, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 33, 4, { 1, 1, 2, 5 })
add_to_2d_table(this_geometry, 35, 0, { 0, 1, 2, 3 })
add_to_2d_table(this_geometry, 42, 5, { 1, 4, 3, 1 })
add_to_2d_table(this_geometry, 43, 5, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 46, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 46, 1, { 11, 2, 2, 2 })
add_to_2d_table(this_geometry, 48, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 53, 0, { 0, 1, 3, 3 })
add_to_2d_table(this_geometry, 54, 3, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 54, 9, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 56, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 63, 0, { 0, 1, 3, 3 })
add_to_2d_table(this_geometry, 64, 3, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 64, 9, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 66, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 79, 0, { 0, 1, 3, 3 })
add_to_2d_table(this_geometry, 80, 3, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 80, 9, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 81, 8, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 82, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 88, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 88, 1, { 11, 2, 2, 2 })
add_to_2d_table(this_geometry, 90, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 96, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 96, 1, { 11, 2, 15, 2 })
add_to_2d_table(this_geometry, 99, 4, { 1, 1, 3, 5 })
add_to_2d_table(this_geometry, 105, 4, { 1, 1, 3, 5 })
add_to_2d_table(this_geometry, 111, 0, { 0, 1, 2, 3 })
add_to_2d_table(this_geometry, 111, 4, { 1, 1, 5, 3 })
add_to_2d_table(this_geometry, 118, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 128, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 128, 1, { 11, 2, 13, 2 })
add_to_2d_table(this_geometry, 128, 4, { 1, 37, 13, 1 })
add_to_2d_table(this_geometry, 132, 11, { 1, 3, 2, 3 })
add_to_2d_table(this_geometry, 140, 5, { 1, -30, 1, 1 })
add_to_2d_table(this_geometry, 141, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 141, 5, { 1, 1, 3, 4 })
add_to_2d_table(this_geometry, 142, 11, { 1, 1, 2, 3 })
add_to_2d_table(this_obj, 16, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 19, 3, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 24, 3, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 26, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 29, 3, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 54, 3, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 54, 9, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 64, 3, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 64, 9, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 80, 3, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 80, 9, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 88, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 97, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 103, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 103, 12, { id_bhvSmbBowserFlameFrenzy, 1 })
add_to_2d_table(this_obj, 109, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 135, 5, { id_bhvSmbBowser, 1 })
add_to_2d_table(this_obj, 139, 8, { id_bhvSmbMovingPlatform, 1, 0x00040000 })
add_to_2d_table(this_obj, 141, 6, { id_bhvSmbAxe, 1 })
add_to_2d_table(this_obj, 153, 2, { id_bhvSmbMessenger, 1 })

--- 4-1 ---
geometry_data[13] = {}
obj_data[13] = {}
-- area 1
geometry_data[13][1] = { width = 16 * 16, theme = 0, bg = 1, checkpoint = 6 }
obj_data[13][1] = {}
this_geometry = geometry_data[13][1]
this_obj = obj_data[13][1]
add_to_2d_table(this_geometry, 0, 12, { 8, -18, 5, 11 })
add_to_2d_table(this_geometry, 5, 7, { 9, -18, 2, 6 })
add_to_2d_table(this_geometry, 21, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 25, 5, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 25, 9, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 32, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 41, 5, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 42, 6, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 44, 5, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 64, 5, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 64, 9, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 66, 5, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 66, 9, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 78, 0, { 5, 2, 4, 1 })
add_to_2d_table(this_geometry, 90, 5, { 1, 4, 4, 1 })
add_to_2d_table(this_geometry, 92, 9, { 1, 11, 1, 1 })
add_to_2d_table(this_geometry, 103, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 105, 8, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 116, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 119, 8, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 132, 5, { 2, 23, 2, 4 })
add_to_2d_table(this_geometry, 135, 8, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 146, 5, { 1, 4, 2, 1 })
add_to_2d_table(this_geometry, 148, 5, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 148, 9, { 1, 4, 4, 1 })
add_to_2d_table(this_geometry, 149, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 149, 5, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 151, 5, { 1, 4, 3, 1 })
add_to_2d_table(this_geometry, 163, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 174, 0, { 5, 8, 3, 1 })
add_to_2d_table(this_geometry, 180, 0, { 5, 8, 2, 1 })
add_to_2d_table(this_geometry, 189, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 190, 0, { 5, 11, 2, 1 })
add_to_2d_table(this_geometry, 208, 9, { 3, 2, 9, 8 })
add_to_2d_table(this_geometry, 220, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 225, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 229, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 30, 11, { id_bhvSmbLakitu, 1 })
add_to_2d_table(this_obj, 132, 0, { id_bhvSmbExitController, 1, 0x0002000a })
add_to_2d_table(this_obj, 222, 0, { id_bhvSmbStopFrenzy, 1 })

-- area 2 (upside-down U shaped bonus area)
geometry_data[13][2] = { width = 17, theme = 1, bg = 0, scrollStop = 15 }
obj_data[13][2] = {}
this_geometry = geometry_data[13][2]
this_obj = obj_data[13][2]
add_to_2d_table(this_geometry, 0, 12, { 1, 3, 1, 11 })
add_to_2d_table(this_geometry, 3, 2, { 1, 12, 10, 1 })
add_to_2d_table(this_geometry, 3, 4, { 1, 3, 1, 2 })
add_to_2d_table(this_geometry, 3, 5, { 1, 3, 8, 1 })
add_to_2d_table(this_geometry, 3, 6, { 1, 12, 8, 1 })
add_to_2d_table(this_geometry, 3, 12, { 1, 3, 12, 1 })
add_to_2d_table(this_geometry, 10, 4, { 1, 3, 1, 2 })
add_to_2d_table(this_geometry, 13, 3, { 4, 17, 3, 2 })
add_to_2d_table(this_geometry, 13, 5, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 15, 12, { 2, 15, 2, 11 })

--- 4-2 ---
geometry_data[14] = {}
obj_data[14] = {}
-- area 1 (pipe entrance, copy of 1-2's)
geometry_data[14][1] = geometry_data[2][1]
obj_data[14][1] = obj_data[2][1]

-- area 2
geometry_data[14][2] = { width = 14 * 16 + 1, theme = 1, bg = 0, scrollStop = 14 * 16 - 1, checkpoint = 6}
obj_data[14][2] = {}
this_geometry = geometry_data[14][2]
this_obj = obj_data[14][2]
add_to_2d_table(this_geometry, 0, 12, { 1, 3, 1, 11 })
add_to_2d_table(this_geometry, 6, 0, { 0, 3, 2, 1 })
add_to_2d_table(this_geometry, 11, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 15, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 18, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 20, 0, { 0, 3, 2, 4 })
add_to_2d_table(this_geometry, 22, 5, { 1, 3, 5, 3 })
add_to_2d_table(this_geometry, 27, 2, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 27, 5, { 1, 3, 1, 0 })
add_to_2d_table(this_geometry, 28, 5, { 1, 27, 1, 0 })
add_to_2d_table(this_geometry, 30, 5, { 1, 3, 18, 4 })
add_to_2d_table(this_geometry, 43, 10, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 48, 0, { 0, 3, 2, 1 })
add_to_2d_table(this_geometry, 50, 5, { 1, 4, 2, 1 })
add_to_2d_table(this_geometry, 50, 9, { 1, 4, 2, 1 })
add_to_2d_table(this_geometry, 54, 5, { 1, 4, 3, 1 })
add_to_2d_table(this_geometry, 55, 5, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 57, 0, { 0, 3, 0, 0 })
add_to_2d_table(this_geometry, 63, 0, { 0, 3, 2, 0 })
add_to_2d_table(this_geometry, 63, 6, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 64, 7, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 64, 9, { 1, 26, 1, 1 })
add_to_2d_table(this_geometry, 65, 6, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 65, 9, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 66, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 67, 0, { 0, 3, 2, 1 })
add_to_2d_table(this_geometry, 72, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 76, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 77, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 78, 8, { 2, 13, 2, 7 })
add_to_2d_table(this_geometry, 80, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 81, 5, { 1, 8, 1, 1 })
add_to_2d_table(this_geometry, 84, 4, { 2, 23, 2, 3 })
add_to_2d_table(this_geometry, 87, 6, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 89, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 103, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 104, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 105, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 107, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 109, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 111, 4, { 1, 2, 2, 3 })
add_to_2d_table(this_geometry, 112, 0, { 0, 3, 2, 0 })
add_to_2d_table(this_geometry, 113, 0, { 5, 5, 6, 1 })
add_to_2d_table(this_geometry, 119, 5, { 1, 3, 4, 1 })
add_to_2d_table(this_geometry, 119, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 119, 12, { 1, 3, 4, 1 })
add_to_2d_table(this_geometry, 120, 9, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 123, 0, { 5, 3, 6, 0 })
add_to_2d_table(this_geometry, 128, 0, { 0, 3, 2, 1 })
add_to_2d_table(this_geometry, 131, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 138, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 142, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 144, 0, { 5, 3, 2, 1 })
add_to_2d_table(this_geometry, 152, 4, { 3, 2, 3, 3 })
add_to_2d_table(this_geometry, 155, 0, { 0, 3, 0, 0 })
add_to_2d_table(this_geometry, 160, 0, { 0, 3, 2, 4 })
add_to_2d_table(this_geometry, 160, 8, { 1, 3, 1, 2 })
add_to_2d_table(this_geometry, 161, 5, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 162, 5, { 1, 3, 10, 1 })
add_to_2d_table(this_geometry, 162, 6, { 1, 12, 10, 1 })
add_to_2d_table(this_geometry, 173, 5, { 3, 2, 4, 4 })
add_to_2d_table(this_geometry, 176, 0, { 0, 3, 2, 1 })
add_to_2d_table(this_geometry, 180, 8, { 2, 13, 2, 7 })
add_to_2d_table(this_geometry, 183, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 185, 4, { 1, 3, 6, 3 })
add_to_2d_table(this_geometry, 187, 6, { 4, 15, 3, 2 })
add_to_2d_table(this_geometry, 189, 12, { 2, 15, 2, 8 })
add_to_2d_table(this_geometry, 191, 0, { 0, 3, 2, 11 })
add_to_2d_table(this_geometry, 209, 0, { 0, 3, 2, 1 })
add_to_2d_table(this_geometry, 214, 4, { 2, 29, 2, 3 })
add_to_2d_table(this_geometry, 219, 0, { 0, 3, 2, 0 })
add_to_2d_table(this_geometry, 222, 0, { 0, 3, 2, 11 })
add_to_2d_table(this_obj, 41, 6, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 59, 9, { id_bhvSmbLoopingPlatform, 1 })
add_to_2d_table(this_obj, 64, 0, { id_bhvSmbExitController, 1, 0x00030000 })
add_to_2d_table(this_obj, 77, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 83, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 84, 0, { id_bhvSmbExitController, 1, 0x00040008 })
add_to_2d_table(this_obj, 88, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 100, 2, { id_bhvSmbKoopa, 2 })
add_to_2d_table(this_obj, 114, 2, { id_bhvSmbLoopingPlatform, 1 })
add_to_2d_table(this_obj, 114, 9, { id_bhvSmbLoopingPlatform, 1 })
add_to_2d_table(this_obj, 124, 5, { id_bhvSmbLoopingPlatform, 0, 0x00000001 })
add_to_2d_table(this_obj, 124, 12, { id_bhvSmbLoopingPlatform, 0, 0x00000001 })
add_to_2d_table(this_obj, 137, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 154, 5, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 156, 2, { id_bhvSmbLoopingPlatform, 0 })
add_to_2d_table(this_obj, 156, 9, { id_bhvSmbLoopingPlatform, 0 })
add_to_2d_table(this_obj, 168, 2, { id_bhvSmbKoopa, 2 })
add_to_2d_table(this_obj, 179, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 187, 0, { id_bhvSmbExitController, 1, 0x00050000 })
add_to_2d_table(this_obj, 224, 0, { id_bhvSmbWarpZoneController, 1, 0x00240524 })

-- area 3 (8-6-7 warp zone)
geometry_data[14][3] = { width = 4 * 16 + 1, scrollStop = 4 * 16 - 1, theme = 4, bg = 2 }
obj_data[14][3] = {}
this_geometry = geometry_data[14][3]
this_obj = obj_data[14][3]
add_to_2d_table(this_geometry, 4, 0, { 5, 6, 1, 1 })
add_to_2d_table(this_geometry, 12, 5, { 10, 34, 3, 4 })
add_to_2d_table(this_geometry, 12, 6, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 16, 9, { 10, 34, 3, 8 })
add_to_2d_table(this_geometry, 16, 10, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 18, 3, { 10, 34, 3, 2 })
add_to_2d_table(this_geometry, 22, 3, { 10, 34, 5, 2 })
add_to_2d_table(this_geometry, 22, 9, { 10, 34, 3, 8 })
add_to_2d_table(this_geometry, 22, 10, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 26, 7, { 10, 34, 3, 6 })
add_to_2d_table(this_geometry, 26, 8, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 30, 10, { 10, 34, 5, 9 })
add_to_2d_table(this_geometry, 30, 11, { 1, 12, 5, 1 })
add_to_2d_table(this_geometry, 31, 4, { 10, 34, 7, 3 })
add_to_2d_table(this_geometry, 35, 5, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 40, 10, { 3, 2, 9, 9 })
add_to_2d_table(this_geometry, 49, 10, { 1, 2, 11, 1 })
add_to_2d_table(this_geometry, 50, 4, { 2, 29, 2, 3 })
add_to_2d_table(this_geometry, 54, 4, { 2, 29, 2, 3 })
add_to_2d_table(this_geometry, 58, 4, { 2, 29, 2, 3 })
add_to_2d_table(this_geometry, 62, 12, { 1, 2, 2, 11 })
add_to_2d_table(this_obj, 64, 0, { id_bhvSmbWarpZoneController, 1, 0x00080706 })

-- area 4 (Q-shaped bonus room)
geometry_data[14][4] = { width = 17, theme = 1, bg = 0, scrollStop = 15 }
obj_data[14][4] = {}
this_geometry = geometry_data[14][4]
this_obj = obj_data[14][4]
add_to_2d_table(this_geometry, 0, 12, { 1, 3, 1, 11 })
add_to_2d_table(this_geometry, 4, 8, { 1, 3, 1, 2 })
add_to_2d_table(this_geometry, 4, 12, { 1, 3, 7, 1 })
add_to_2d_table(this_geometry, 5, 7, { 1, 3, 6, 1 })
add_to_2d_table(this_geometry, 5, 9, { 1, 12, 5, 2 })
add_to_2d_table(this_geometry, 10, 11, { 1, 3, 1, 4 })
add_to_2d_table(this_geometry, 11, 8, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 13, 3, { 4, 17, 3, 2 })
add_to_2d_table(this_geometry, 14, 7, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 15, 12, { 2, 15, 2, 11 })

-- area... 5!? (Yes, this one level has that many rooms!)
-- Also it's just another copy of 1-2's ending area
geometry_data[14][5] = geometry_data[2][4]
obj_data[14][5] = obj_data[2][4]

--- 4-3 ---
geometry_data[15] = {}
obj_data[15] = {}
-- area 1
geometry_data[15][1] = { width = 11 * 16, theme = 4, bg = 2, checkpoint = 4, timer = 300 }
obj_data[15][1] = {}
this_geometry = geometry_data[15][1]
this_obj = obj_data[15][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 })
add_to_2d_table(this_geometry, 15, 0, { 0, 1, 0, 0 })
add_to_2d_table(this_geometry, 16, 1, { 10, 34, 5, 2 })
add_to_2d_table(this_geometry, 19, 9, { 10, 34, 5, 10 })
add_to_2d_table(this_geometry, 20, 10, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 23, 5, { 10, 34, 7, 6 })
add_to_2d_table(this_geometry, 24, 6, { 1, 12, 5, 1 })
add_to_2d_table(this_geometry, 32, 10, { 10, 34, 3, 11 })
add_to_2d_table(this_geometry, 36, 2, { 10, 34, 7, 3 })
add_to_2d_table(this_geometry, 38, 3, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 39, 9, { 10, 34, 5, 10 })
add_to_2d_table(this_geometry, 43, 12, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 44, 5, { 10, 34, 3, 6 })
add_to_2d_table(this_geometry, 48, 7, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 49, 12, { 13, 2, 8, 1 })
add_to_2d_table(this_geometry, 51, 6, { 10, 34, 3, 7 })
add_to_2d_table(this_geometry, 65, 1, { 10, 34, 5, 2 })
add_to_2d_table(this_geometry, 67, 7, { 10, 34, 3, 8 })
add_to_2d_table(this_geometry, 67, 8, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 70, 11, { 10, 34, 3, 12 })
add_to_2d_table(this_geometry, 70, 12, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 72, 5, { 10, 34, 3, 6 })
add_to_2d_table(this_geometry, 73, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 74, 9, { 10, 34, 5, 10 })
add_to_2d_table(this_geometry, 81, 12, { 13, 2, 9, 1 })
add_to_2d_table(this_geometry, 84, 5, { 10, 34, 3, 6 })
add_to_2d_table(this_geometry, 92, 12, { 13, 2, 6, 1 })
add_to_2d_table(this_geometry, 99, 3, { 10, 34, 3, 4 })
add_to_2d_table(this_geometry, 103, 12, { 13, 2, 7, 1 })
add_to_2d_table(this_geometry, 105, 4, { 10, 34, 3, 5 })
add_to_2d_table(this_geometry, 113, 5, { 10, 34, 5, 6 })
add_to_2d_table(this_geometry, 113, 6, { 1, 12, 5, 1 })
add_to_2d_table(this_geometry, 117, 8, { 10, 34, 3, 9 })
add_to_2d_table(this_geometry, 121, 1, { 10, 34, 7, 2 })
add_to_2d_table(this_geometry, 130, 4, { 10, 34, 5, 5 })
add_to_2d_table(this_geometry, 141, 0, { 0, 1, 2, 0 })
add_to_2d_table(this_geometry, 142, 3, { 1, -42, 3, 2 })
add_to_2d_table(this_geometry, 147, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 148, 11, { 1, -42, 4, 2 })
add_to_2d_table(this_geometry, 150, 12, { 8, 28, 9, 11 })
add_to_2d_table(this_geometry, 159, 7, { 9, 28, 12, 6 })
add_to_2d_table(this_obj, 28, 6, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 29, 6, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 36, 11, { id_bhvSmbFlyingParatroopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 39, 3, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 49, 9, { id_bhvSmbPulleyPlatform, 1 })
add_to_2d_table(this_obj, 56, 6, { id_bhvSmbPulleyPlatform, 1 })
add_to_2d_table(this_obj, 59, 8, { id_bhvSmbMovingPlatform, 1, 0x00000001 })
add_to_2d_table(this_obj, 63, 10, { id_bhvSmbMovingPlatform, 1, 0x00000001 })
add_to_2d_table(this_obj, 68, 2, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 78, 10, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 81, 9, { id_bhvSmbPulleyPlatform, 1, 0x00000001 })
add_to_2d_table(this_obj, 89, 5, { id_bhvSmbPulleyPlatform, 1, 0x00000001 })
add_to_2d_table(this_obj, 92, 9, { id_bhvSmbPulleyPlatform, 0, 0x00000002 })
add_to_2d_table(this_obj, 97, 5, { id_bhvSmbPulleyPlatform, 1, 0x00000002 })
add_to_2d_table(this_obj, 103, 9, { id_bhvSmbPulleyPlatform, 1, 0x00000003 })
add_to_2d_table(this_obj, 109, 5, { id_bhvSmbPulleyPlatform, 1, 0x00000003 })
add_to_2d_table(this_obj, 137, 9, { id_bhvSmbMovingPlatform, 1, 0x00000001 })

--- 4-4 ---
geometry_data[16] = {}
obj_data[16] = {}
-- area 1
geometry_data[16][1] = { width = 12 * 16, scrollStop = 12 * 16 - 1, theme = 2, bg = 0 }
obj_data[16][1] = {}
this_geometry = geometry_data[16][1]
this_obj = obj_data[16][1]
add_to_2d_table(this_geometry, 0, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 0, 7, { 6, 1, 5, 3 })
add_to_2d_table(this_geometry, 6, 0, { 0, 1, 5, 1 })
add_to_2d_table(this_geometry, 7, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 7, 1, { 11, 2, 6, 2 })
add_to_2d_table(this_geometry, 11, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 16, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 18, 8, { 1, 1, 6, 4 })
add_to_2d_table(this_geometry, 25, 8, { 1, 1, 1, 4 })
add_to_2d_table(this_geometry, 27, 8, { 1, 1, 1, 4 })
add_to_2d_table(this_geometry, 29, 8, { 1, 1, 1, 4 })
add_to_2d_table(this_geometry, 31, 8, { 1, 1, 1, 4 })
add_to_2d_table(this_geometry, 33, 8, { 1, 1, 1, 4 })
add_to_2d_table(this_geometry, 35, 8, { 1, 1, 3, 4 })
add_to_2d_table(this_geometry, 38, 8, { 1, 1, 6, 1 })
add_to_2d_table(this_geometry, 40, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 44, 8, { 1, 1, 31, 4 })
add_to_2d_table(this_geometry, 77, 4, { 1, 1, 3, 3 })
add_to_2d_table(this_geometry, 77, 11, { 1, 1, 3, 3 })
add_to_2d_table(this_geometry, 86, 4, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 88, 0, { 5, 1, 7, 1 })
add_to_2d_table(this_geometry, 88, 1, { 11, 2, 7, 2 })
add_to_2d_table(this_geometry, 89, 6, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 90, 4, { 1, 1, 1, 5 })
add_to_2d_table(this_geometry, 91, 4, { 1, 1, 4, 1 })
add_to_2d_table(this_geometry, 93, 7, { 1, 1, 1, 1 })
add_to_2d_table(this_geometry, 94, 6, { 1, 1, 1, 2 })
add_to_2d_table(this_geometry, 95, 8, { 1, 1, 1, 2 })
add_to_2d_table(this_geometry, 96, 4, { 1, 1, 48, 1 })
add_to_2d_table(this_geometry, 96, 8, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 100, 8, { 1, 1, 4, 1 })
add_to_2d_table(this_geometry, 105, 8, { 1, 1, 1, 4 })
add_to_2d_table(this_geometry, 106, 8, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 110, 8, { 1, 1, 34, 1 })
add_to_2d_table(this_geometry, 144, 9, { 1, 1, 1, 5 })
add_to_2d_table(this_geometry, 145, 11, { 1, 1, 2, 2 })
add_to_2d_table(this_geometry, 147, 0, { 0, 1, 2, 0 })
add_to_2d_table(this_geometry, 152, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 152, 4, { 1, 1, 4, 3 })
add_to_2d_table(this_geometry, 158, 4, { 1, 1, 2, 3 })
add_to_2d_table(this_geometry, 160, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 160, 1, { 11, 2, 13, 2 })
add_to_2d_table(this_geometry, 160, 4, { 1, 37, 13, 1 })
add_to_2d_table(this_geometry, 173, 5, { 1, 1, 3, 6 })
add_to_2d_table(this_geometry, 174, 11, { 1, 1, 2, 3 })
add_to_2d_table(this_geometry, 176, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_obj, 53, 8, { id_bhvSmbFireBarBase, 0 })
add_to_2d_table(this_obj, 60, 5, { id_bhvSmbFireBarBase, 0 })
add_to_2d_table(this_obj, 64, 10, { id_bhvSmbLoopController, 1, 0x00010005 })
add_to_2d_table(this_obj, 115, 8, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 122, 4, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 128, 2, { id_bhvSmbLoopController, 1, 0x00050009 })
add_to_2d_table(this_obj, 133, 6, { id_bhvSmbBowserFlameFrenzy, 1 })
add_to_2d_table(this_obj, 162, 4, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 165, 2, { id_bhvSmbPodoboo, 0 })
add_to_2d_table(this_obj, 167, 5, { id_bhvSmbBowser, 0 })
add_to_2d_table(this_obj, 173, 6, { id_bhvSmbAxe, 0 })
add_to_2d_table(this_obj, 185, 2, { id_bhvSmbMessenger, 0 })

--- 5-1 ---
geometry_data[17] = {}
obj_data[17] = {}
-- area 1
geometry_data[17][1] = { width = 14 * 16, theme = 0, palette = 5, bg = 3, checkpoint = 6 }
obj_data[17][1] = {}
this_geometry = geometry_data[17][1]
this_obj = obj_data[17][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 }) -- fun fact: this is a small castle, for some reason!
add_to_2d_table(this_geometry, 44, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 49, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 51, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 89, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 90, 5, { 1, 2, 4, 1 })
add_to_2d_table(this_geometry, 90, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 91, 9, { 1, 8, 1, 1 })
add_to_2d_table(this_geometry, 92, 0, { 5, 2, 4, 1 })
add_to_2d_table(this_geometry, 111, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 114, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 116, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 147, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 148, 5, { 1, 11, 1, 1 })
add_to_2d_table(this_geometry, 149, 5, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 152, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 156, 5, { 1, 2, 2, 1 })
add_to_2d_table(this_geometry, 156, 7, { 2, 23, 2, 2 })
add_to_2d_table(this_geometry, 159, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 163, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 170, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 182, 6, { 3, 2, 5, 5 })
add_to_2d_table(this_geometry, 189, 9, { 1, 2, 2, 7 })
add_to_2d_table(this_geometry, 199, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 203, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 16, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 18, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 28, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 41, 2, { id_bhvSmbKoopa, 2 })
add_to_2d_table(this_obj, 61, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 63, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 74, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 87, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 101, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 119, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 127, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 133, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 144, 2, { id_bhvSmbKoopa, 2 })
add_to_2d_table(this_obj, 156, 0, { id_bhvSmbExitController, 1, 0x0002000a })
add_to_2d_table(this_obj, 179, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 183, 6, { id_bhvSmbBouncingParatroopa, 1 })

-- area 2 (Q-shaped bonus room; copied from 4-2)
geometry_data[17][2] = geometry_data[14][4]
obj_data[17][2] = geometry_data[14][4]

--- 5-2 ---
geometry_data[18] = {}
obj_data[18] = {}
-- area 1
geometry_data[18][1] = { width = 14 * 16, theme = 0, palette = 5, bg = 3, checkpoint = 6 }
obj_data[18][1] = {}
this_geometry = geometry_data[18][1]
this_obj = obj_data[18][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 })
add_to_2d_table(this_geometry, 12, 5, { 3, 2, 4, 4 })
add_to_2d_table(this_geometry, 16, 5, { 1, 2, 3, 1 })
add_to_2d_table(this_geometry, 17, 7, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 21, 10, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 25, 2, { 1, 25, 1, 1 })
add_to_2d_table(this_geometry, 26, 0, { 5, 1, 3, 1 })
add_to_2d_table(this_geometry, 29, 5, { 1, 3, 6, 1 })
add_to_2d_table(this_geometry, 29, 6, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 29, 9, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 34, 9, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 44, 5, { 3, 2, 5, 4 })
add_to_2d_table(this_geometry, 49, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 55, 4, { 2, 23, 2, 3 })
add_to_2d_table(this_geometry, 62, 5, { 3, 2, 4, 4 })
add_to_2d_table(this_geometry, 66, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 68, 6, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 69, 7, { 1, 2, 2, 6 })
add_to_2d_table(this_geometry, 78, 5, { 1, 4, 5, 1 })
add_to_2d_table(this_geometry, 84, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 85, 9, { 1, 26, 1, 1 })
add_to_2d_table(this_geometry, 86, 9, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 86, 10, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 89, 2, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 89, 6, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 92, 0, { 5, 2, 4, 1 })
add_to_2d_table(this_geometry, 107, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 115, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 118, 5, { 1, 3, 8, 1 })
add_to_2d_table(this_geometry, 118, 9, { 1, 3, 7, 1 })
add_to_2d_table(this_geometry, 125, 9, { 1, 8, 1, 1 })
add_to_2d_table(this_geometry, 127, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 129, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 141, 3, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 142, 3, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 144, 0, { 5, 2, 7, 1 })
add_to_2d_table(this_geometry, 147, 5, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 153, 9, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 168, 5, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 170, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 172, 9, { 1, 3, 4, 1 })
add_to_2d_table(this_geometry, 172, 10, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 173, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 175, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 183, 3, { 3, 2, 2, 2 })
add_to_2d_table(this_geometry, 185, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 186, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 187, 6, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 188, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 189, 8, { 1, 2, 1, 7 })
add_to_2d_table(this_geometry, 190, 9, { 1, 2, 2, 8 })
add_to_2d_table(this_geometry, 200, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 204, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 23, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 25, 2, { id_bhvSmbSpringboard, 1 })
add_to_2d_table(this_obj, 40, 2, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 46, 5, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 55, 0, { id_bhvSmbExitController, 1, 0x00020007 })
add_to_2d_table(this_obj, 63, 4, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 65, 6, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 81, 7, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 85, 0, { id_bhvSmbExitController, 1, 0x00030008 })
add_to_2d_table(this_obj, 106, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 120, 6, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 124, 10, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 136, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 137, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 138, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 155, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 156, 2, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 157, 10, { id_bhvSmbKoopa, 1, 0x00000001 })
add_to_2d_table(this_obj, 163, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 166, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 186, 6, { id_bhvSmbBouncingParatroopa, 1 })

-- area 2 (suddenly underwater...?)
geometry_data[18][2] = { width = 4 * 16 + 1, scrollStop = 4 * 16 - 1, theme = 3, bg = 4 }
obj_data[18][2] = {}
this_geometry = geometry_data[18][2]
this_obj = obj_data[18][2]
add_to_2d_table(this_geometry, 11, 8, { 1, 1, 5, 1 })
add_to_2d_table(this_geometry, 12, 4, { 1, 40, 1, 3 })
add_to_2d_table(this_geometry, 15, 10, { 1, 40, 1, 2 })
add_to_2d_table(this_geometry, 20, 5, { 1, 40, 1, 4 })
add_to_2d_table(this_geometry, 22, 0, { 5, 2, 4, 1 })
add_to_2d_table(this_geometry, 22, 7, { 1, 12, 10, 1 })
add_to_2d_table(this_geometry, 26, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 28, 0, { 0, 1, 0, 0 })
add_to_2d_table(this_geometry, 32, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 34, 0, { 0, 1, 2, 0 })
add_to_2d_table(this_geometry, 38, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 38, 9, { 1, 40, 1, 4 })
add_to_2d_table(this_geometry, 38, 10, { 1, 1, 6, 1 })
add_to_2d_table(this_geometry, 40, 2, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 42, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 43, 9, { 1, 40, 1, 4 })
add_to_2d_table(this_geometry, 46, 3, { 1, 40, 1, 2 })
add_to_2d_table(this_geometry, 50, 5, { 1, 1, 4, 1 })
add_to_2d_table(this_geometry, 50, 6, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 54, 8, { 1, 1, 4, 1 })
add_to_2d_table(this_geometry, 54, 9, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 59, 3, { 3, 1, 2, 2 })
add_to_2d_table(this_geometry, 61, 0, { 0, 1, 6, 4 })
add_to_2d_table(this_geometry, 62, 7, { 4, 2, 1, 2 })
add_to_2d_table(this_geometry, 63, 0, { 0, 1, 9, 4 })
add_to_2d_table(this_obj, 19, 2, { id_bhvSmbBlooper, 0 })
add_to_2d_table(this_obj, 23, 8, { id_bhvSmbLoopingPlatform, 1 })
add_to_2d_table(this_obj, 29, 2, { id_bhvSmbLoopingPlatform, 1 })
add_to_2d_table(this_obj, 32, 0, { id_bhvSmbUwFishFrenzy, 0 })
add_to_2d_table(this_obj, 35, 2, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 45, 2, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 64, 0, { id_bhvSmbStopFrenzy, 1 })

-- area 3 (cloud bonus room, copied from 2-1)
geometry_data[18][3] = geometry_data[5][2]
obj_data[18][3] = obj_data[5][2]

--- 5-3 (copy of 1-3) ---
geometry_data[19] = geometry_data[3]
obj_data[19] = obj_data[3]

--- 5-4 (copy of 2-4) ---
geometry_data[20] = geometry_data[8]
obj_data[20] = obj_data[8]

--- 6-1 ---
geometry_data[21] = {}
obj_data[21] = {}
-- area 1
geometry_data[21][1] = { width = 14 * 16, theme = 5, palette = 0, bg = 1, checkpoint = 6 }
obj_data[21][1] = {}
this_geometry = geometry_data[21][1]
this_obj = obj_data[21][1]
add_to_2d_table(this_geometry, 0, 12, { 8, -18, 5, 11 })
add_to_2d_table(this_geometry, 5, 7, { 9, -18, 2, 6 })
add_to_2d_table(this_geometry, 16, 5, { 1, 4, 2, 1 })
add_to_2d_table(this_geometry, 20, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 26, 2, { 1, 2, 6, 1 })
add_to_2d_table(this_geometry, 29, 3, { 1, 2, 5, 1 })
add_to_2d_table(this_geometry, 31, 0, { 5, 2, 6, 1 })
add_to_2d_table(this_geometry, 32, 4, { 1, 2, 4, 1 })
add_to_2d_table(this_geometry, 35, 5, { 1, 2, 3, 1 })
add_to_2d_table(this_geometry, 36, 9, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 37, 9, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 39, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 41, 5, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 43, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 57, 0, { 5, 3, 2, 1 })
add_to_2d_table(this_geometry, 62, 5, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 69, 5, { 3, 2, 5, 4 })
add_to_2d_table(this_geometry, 74, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 76, 6, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 84, 4, { 3, 2, 2, 2 })
add_to_2d_table(this_geometry, 87, 6, { 1, 2, 3, 5 })
add_to_2d_table(this_geometry, 88, 8, { 3, 2, 2, 2 })
add_to_2d_table(this_geometry, 90, 6, { 1, 11, 1, 1 })
add_to_2d_table(this_geometry, 90, 8, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 92, 4, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 93, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 102, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 104, 6, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 113, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 113, 9, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 122, 6, { 3, 2, 5, 5 })
add_to_2d_table(this_geometry, 127, 0, { 5, 2, 7, 1 })
add_to_2d_table(this_geometry, 127, 6, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 130, 2, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 130, 6, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 131, 6, { 1, 4, 1, 1 })
add_to_2d_table(this_geometry, 136, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 143, 7, { 3, 2, 6, 6 })
add_to_2d_table(this_geometry, 149, 0, { 5, 2, 6, 1 })
add_to_2d_table(this_geometry, 149, 7, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 151, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 152, 3, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 152, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 164, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 169, 6, { 3, 2, 5, 5 })
add_to_2d_table(this_geometry, 174, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 176, 9, { 1, 2, 2, 8 })
add_to_2d_table(this_geometry, 186, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 192, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 32, 11, { id_bhvSmbLakitu, 1 })
add_to_2d_table(this_obj, 184, 0, { id_bhvSmbStopFrenzy, 0 })

--- 6-2 ---
geometry_data[22] = {}
obj_data[22] = {}
-- area 1
geometry_data[22][1] = { width = 15 * 16, theme = 5, palette = 0, bg = 1, checkpoint = 6 }
obj_data[22][1] = {}
this_geometry = geometry_data[22][1]
this_obj = obj_data[22][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 })
add_to_2d_table(this_geometry, 10, 5, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 19, 5, { 2, 23, 2, 4 })
add_to_2d_table(this_geometry, 23, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 24, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 24, 9, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 28, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 32, 6, { 1, 2, 2, 1 })
add_to_2d_table(this_geometry, 32, 8, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 35, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 37, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 46, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 51, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 52, 5, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 56, 6, { 2, 23, 2, 5 })
add_to_2d_table(this_geometry, 62, 5, { 1, 2, 2, 1 })
add_to_2d_table(this_geometry, 62, 7, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 67, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 67, 9, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 74, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 77, 9, { 1, 3, 4, 1 })
add_to_2d_table(this_geometry, 80, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 81, 9, { 1, 26, 1, 1 })
add_to_2d_table(this_geometry, 82, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 84, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 87, 7, { 2, 13, 2, 6 })
add_to_2d_table(this_geometry, 94, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 102, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 105, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 110, 5, { 1, 3, 4, 1 })
add_to_2d_table(this_geometry, 111, 5, { 1, 2, 2, 1 })
add_to_2d_table(this_geometry, 111, 8, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 115, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 115, 9, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 119, 9, { 1, 3, 9, 1 })
add_to_2d_table(this_geometry, 123, 0, { 5, 2, 6, 1 })
add_to_2d_table(this_geometry, 131, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 135, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 138, 6, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 140, 9, { 1, 8, 1, 1 })
add_to_2d_table(this_geometry, 141, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 141, 9, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 143, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 144, 6, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 145, 9, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 149, 4, { 3, 2, 3, 3 })
add_to_2d_table(this_geometry, 152, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 153, 4, { 2, 23, 2, 3 })
add_to_2d_table(this_geometry, 156, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 157, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 160, 5, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 160, 9, { 1, 3, 3, 1 })
add_to_2d_table(this_geometry, 167, 5, { 1, 2, 2, 1 })
add_to_2d_table(this_geometry, 167, 8, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 174, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 179, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 181, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 183, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 189, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 199, 3, { 3, 2, 2, 2 })
add_to_2d_table(this_geometry, 201, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 203, 5, { 1, 2, 5, 4 })
add_to_2d_table(this_geometry, 203, 9, { 3, 2, 5, 4 })
add_to_2d_table(this_geometry, 216, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 220, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 19, 0, { id_bhvSmbExitController, 0, 0x00020004 })
add_to_2d_table(this_obj, 26, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 43, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 54, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 56, 0, { id_bhvSmbExitController, 1, 0x00030007 })
add_to_2d_table(this_obj, 67, 10, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 68, 10, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 81, 0, { id_bhvSmbExitController, 1, 0x0004000a })
add_to_2d_table(this_obj, 92, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 120, 10, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 153, 0, { id_bhvSmbExitController, 1, 0x0005000b })
add_to_2d_table(this_obj, 163, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 169, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 206, 10, { id_bhvSmbBouncingParatroopa, 1 })

-- area 2 (Q-shaped bonus room; copied from 4-2)
geometry_data[22][2] = geometry_data[14][4]
obj_data[22][2] = obj_data[14][4]

-- area 3 (underwater subarea, copied from 5-2)
geometry_data[22][3] = geometry_data[18][2]
obj_data[22][3] = obj_data[18][2]

-- area 4 (cloud bonus area 2, copied from 3-1)
geometry_data[22][4] = geometry_data[9][3]
obj_data[22][4] = obj_data[9][3]

-- area 5 (coin row bonus area; copied from 1-2)
-- another level with 5 areas! crazy
geometry_data[22][5] = geometry_data[2][3]
obj_data[22][5] = obj_data[2][3]

--- 6-3 ---
geometry_data[23] = {}
obj_data[23] = {}
-- area 1
geometry_data[23][1] = { width = 12 * 16, theme = 5, palette = 2, bg = 2, checkpoint = 6, timer = 300 }
obj_data[23][1] = {}
this_geometry = geometry_data[23][1]
this_obj = obj_data[23][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 })
add_to_2d_table(this_geometry, 16, 0, { 0, 1, 0, 0 })
add_to_2d_table(this_geometry, 18, 1, { 10, 31, 3, 2 })
add_to_2d_table(this_geometry, 21, 5, { 10, 31, 3, 6 })
add_to_2d_table(this_geometry, 24, 1, { 10, 31, 3, 2 })
add_to_2d_table(this_geometry, 28, 12, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 31, 5, { 10, 31, 4, 6 })
add_to_2d_table(this_geometry, 37, 1, { 10, 31, 3, 2 })
add_to_2d_table(this_geometry, 38, 2, { 1, 25, 1, 1 })
add_to_2d_table(this_geometry, 43, 1, { 10, 31, 3, 2 })
add_to_2d_table(this_geometry, 43, 10, { 1, 12, 7, 1 })
add_to_2d_table(this_geometry, 49, 3, { 10, 31, 4, 4 })
add_to_2d_table(this_geometry, 55, 11, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 65, 5, { 10, 31, 5, 6 })
add_to_2d_table(this_geometry, 71, 12, { 13, 2, 5, 1 })
add_to_2d_table(this_geometry, 73, 9, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 79, 12, { 13, 2, 4, 1 })
add_to_2d_table(this_geometry, 85, 4, { 10, 31, 5, 5 })
add_to_2d_table(this_geometry, 85, 11, { 10, 31, 3, 7 })
add_to_2d_table(this_geometry, 85, 12, { 1, 12, 3, 1 })
add_to_2d_table(this_geometry, 90, 6, { 10, 31, 3, 7 })
add_to_2d_table(this_geometry, 93, 1, { 10, 31, 3, 2 })
add_to_2d_table(this_geometry, 97, 1, { 10, 31, 4, 2 })
add_to_2d_table(this_geometry, 100, 6, { 1, 12, 4, 1 })
add_to_2d_table(this_geometry, 103, 1, { 10, 31, 3, 2 })
add_to_2d_table(this_geometry, 107, 5, { 10, 31, 5, 6 })
add_to_2d_table(this_geometry, 112, 1, { 10, 31, 5, 2 })
add_to_2d_table(this_geometry, 115, 2, { 1, 25, 1, 1 })
add_to_2d_table(this_geometry, 123, 1, { 10, 31, 3, 2 })
add_to_2d_table(this_geometry, 127, 12, { 13, 2, 4, 1 })
add_to_2d_table(this_geometry, 128, 9, { 3, 12, 2, 1 })
add_to_2d_table(this_geometry, 132, 1, { 10, 31, 4, 2 })
add_to_2d_table(this_geometry, 132, 9, { 10, 31, 3, 8 })
add_to_2d_table(this_geometry, 135, 5, { 10, 31, 4, 6 })
add_to_2d_table(this_geometry, 145, 7, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 154, 11, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 156, 9, { 10, 31, 3, 10 })
add_to_2d_table(this_geometry, 160, 0, { 0, 1, 2, 0 })
add_to_2d_table(this_geometry, 162, 12, { 1, -42, 4, 2 })
add_to_2d_table(this_geometry, 167, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 170, 12, { 8, 28, 9, 11 })
add_to_2d_table(this_geometry, 179, 7, { 9, 2, 13, 6 })
add_to_2d_table(this_geometry, 182, 8, { 1, -42, 3, 1 })
add_to_2d_table(this_obj, 29, 9, { id_bhvSmbMovingPlatform, 1, 0x00000001 })
add_to_2d_table(this_obj, 38, 2, { id_bhvSmbSpringboard, 1 })
add_to_2d_table(this_obj, 43, 9, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 49, 7, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 56, 8, { id_bhvSmbMovingPlatform, 0 })
add_to_2d_table(this_obj, 61, 9, { id_bhvSmbMovingPlatform, 0, 0x00000001 })
add_to_2d_table(this_obj, 71, 9, { id_bhvSmbPulleyPlatform, 1 })
add_to_2d_table(this_obj, 75, 5, { id_bhvSmbPulleyPlatform, 1 })
add_to_2d_table(this_obj, 79, 9, { id_bhvSmbPulleyPlatform, 0, 0x00000001 })
add_to_2d_table(this_obj, 82, 5, { id_bhvSmbPulleyPlatform, 0, 0x00000001 })
add_to_2d_table(this_obj, 104, 0, { id_bhvSmbBulletBillFrenzy, 1 })
add_to_2d_table(this_obj, 115, 2, { id_bhvSmbSpringboard, 1 })
add_to_2d_table(this_obj, 122, 9, { id_bhvSmbMovingPlatform, 1 })
add_to_2d_table(this_obj, 127, 8, { id_bhvSmbPulleyPlatform, 1, 0x00000002 })
add_to_2d_table(this_obj, 130, 5, { id_bhvSmbPulleyPlatform, 1, 0x00000002 })
add_to_2d_table(this_obj, 137, 0, { id_bhvSmbStopFrenzy, 1 })
add_to_2d_table(this_obj, 142, 7, { id_bhvSmbFallingPlatform, 0 })
add_to_2d_table(this_obj, 146, 8, { id_bhvSmbFallingPlatform, 0 })
add_to_2d_table(this_obj, 150, 6, { id_bhvSmbFallingPlatform, 0 })
add_to_2d_table(this_obj, 154, 7, { id_bhvSmbFallingPlatform, 0 })

--- 6-4 (copy of 1-4) ---
geometry_data[24] = geometry_data[4]
obj_data[24] = obj_data[4]

--- 7-1 ---
geometry_data[25] = {}
obj_data[25] = {}
-- area 1
geometry_data[25][1] = { width = 13 * 16, theme = 0, palette = 5, bg = 3, checkpoint = 6 }
obj_data[25][1] = {}
this_geometry = geometry_data[25][1]
this_obj = obj_data[25][1]
add_to_2d_table(this_geometry, 0, 11, { 1, -42, 1, 1 })
add_to_2d_table(this_geometry, 0, 12, { 8, -18, 5, 11 })
add_to_2d_table(this_geometry, 5, 7, { 9, -18, 2, 6 })
add_to_2d_table(this_geometry, 19, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 27, 9, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 28, 2, { 14, 2, 1, 1 })
add_to_2d_table(this_geometry, 28, 4, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 28, 9, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 36, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 39, 5, { 1, 4, 4, 1 })
add_to_2d_table(this_geometry, 46, 4, { 14, 2, 1, 3 })
add_to_2d_table(this_geometry, 56, 2, { 14, 2, 1, 1 })
add_to_2d_table(this_geometry, 56, 4, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 62, 5, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 64, 5, { 1, 2, 1, 1 })
add_to_2d_table(this_geometry, 64, 7, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 65, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 68, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 73, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 76, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 82, 5, { 1, 3, 7, 1 })
add_to_2d_table(this_geometry, 82, 9, { 1, 3, 7, 1 })
add_to_2d_table(this_geometry, 93, 4, { 2, 23, 2, 3 })
add_to_2d_table(this_geometry, 93, 9, { 1, 11, 1, 1 })
add_to_2d_table(this_geometry, 104, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 109, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 115, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 122, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 128, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 134, 5, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 134, 9, { 1, 3, 5, 1 })
add_to_2d_table(this_geometry, 141, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 146, 2, { 14, 2, 1, 1 })
add_to_2d_table(this_geometry, 146, 4, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 149, 6, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 151, 2, { 1, 25, 1, 1 })
add_to_2d_table(this_geometry, 151, 12, { 1, 5, 1, 1 })
add_to_2d_table(this_geometry, 152, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 153, 7, { 3, 2, 6, 6 })
add_to_2d_table(this_geometry, 153, 8, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 162, 9, { 3, 2, 9, 8 })
add_to_2d_table(this_geometry, 179, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 183, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 26, 2, { id_bhvSmbBouncingParatroopa, 1, 0x00000000, true })
add_to_2d_table(this_obj, 44, 2, { id_bhvSmbBouncingParatroopa, 1, 0x00000000, true })
add_to_2d_table(this_obj, 53, 2, { id_bhvSmbBouncingParatroopa, 1, 0x00000000, true })
add_to_2d_table(this_obj, 65, 2, { id_bhvSmbBouncingParatroopa, 1, 0x00000000, true })
add_to_2d_table(this_obj, 84, 2, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 86, 6, { id_bhvSmbHammerBro, 1, 0x00000000, true })
add_to_2d_table(this_obj, 93, 0, { id_bhvSmbExitController, 1, 0x00020007 })
add_to_2d_table(this_obj, 114, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 135, 2, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 137, 6, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 151, 2, { id_bhvSmbSpringboard, 1 })
add_to_2d_table(this_obj, 169, 11, { id_bhvSmbBuzzyBeetle, 1 })

-- area 2 (copy of 1-1's bonus area)
geometry_data[25][2] = geometry_data[1][2]
obj_data[25][2] = obj_data[1][2]

--- 7-2 (copy of 2-2) ---
geometry_data[26] = geometry_data[6]
obj_data[26] = obj_data[6]

--- 7-3 (copy of 2-3) ---
geometry_data[27] = geometry_data[7]
obj_data[27] = obj_data[7]

--- 7-4 ---
geometry_data[28] = {}
obj_data[28] = {}
-- area 1
geometry_data[28][1] = { width = 14 * 16, scrollStop = 14 * 16 - 1, theme = 2, bg = 0, timer = 300 }
obj_data[28][1] = {}
this_geometry = geometry_data[28][1]
this_obj = obj_data[28][1]
add_to_2d_table(this_geometry, 0, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 0, 7, { 6, 1, 5, 3 })
add_to_2d_table(this_geometry, 16, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 16, 1, { 11, 2, 11, 2 })
add_to_2d_table(this_geometry, 27, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 27, 4, { 1, 1, 5, 3 })
add_to_2d_table(this_geometry, 28, 11, { 1, 1, 4, 2 })
add_to_2d_table(this_geometry, 34, 5, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 36, 6, { 1, 1, 1, 2 })
add_to_2d_table(this_geometry, 37, 7, { 1, 1, 1, 3 })
add_to_2d_table(this_geometry, 38, 8, { 1, 1, 12, 4 })
add_to_2d_table(this_geometry, 54, 4, { 1, 1, 13, 1 })
add_to_2d_table(this_geometry, 55, 8, { 1, 1, 11, 1 })
add_to_2d_table(this_geometry, 70, 8, { 1, 1, 18, 4 })
add_to_2d_table(this_geometry, 88, 8, { 1, 1, 1, 3 })
add_to_2d_table(this_geometry, 89, 8, { 1, 1, 1, 2 })
add_to_2d_table(this_geometry, 90, 8, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 93, 4, { 1, 1, 3, 3 })
add_to_2d_table(this_geometry, 99, 8, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 100, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 100, 1, { 11, 2, 7, 2 })
add_to_2d_table(this_geometry, 102, 8, { 1, 1, 3, 1 })
add_to_2d_table(this_geometry, 103, 7, { 1, 6, 1, 1 })
add_to_2d_table(this_geometry, 104, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 106, 8, { 1, 1, 4, 1 })
add_to_2d_table(this_geometry, 110, 8, { 1, 1, 6, 4 })
add_to_2d_table(this_geometry, 118, 8, { 1, 1, 3, 1 })
add_to_2d_table(this_geometry, 119, 5, { 1, 1, 3, 1 })
add_to_2d_table(this_geometry, 123, 8, { 1, 1, 7, 1 })
add_to_2d_table(this_geometry, 124, 5, { 1, 1, 7, 1 })
add_to_2d_table(this_geometry, 132, 8, { 1, 1, 3, 1 })
add_to_2d_table(this_geometry, 133, 5, { 1, 1, 3, 1 })
add_to_2d_table(this_geometry, 137, 8, { 1, 1, 1, 3 })
add_to_2d_table(this_geometry, 138, 8, { 1, 1, 15, 1 })
add_to_2d_table(this_geometry, 139, 4, { 3, 1, 3, 3 })
add_to_2d_table(this_geometry, 142, 0, { 0, 1, 5, 1 })
add_to_2d_table(this_geometry, 160, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 163, 4, { 1, 1, 3, 3 })
add_to_2d_table(this_geometry, 168, 4, { 1, 1, 8, 3 })
add_to_2d_table(this_geometry, 178, 4, { 1, 1, 2, 3 })
add_to_2d_table(this_geometry, 182, 4, { 1, 1, 2, 3 })
add_to_2d_table(this_geometry, 186, 4, { 1, 1, 6, 3 })
add_to_2d_table(this_geometry, 192, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 192, 1, { 11, 2, 13, 2 })
add_to_2d_table(this_geometry, 192, 4, { 1, 37, 13, 1 })
add_to_2d_table(this_geometry, 205, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 205, 5, { 1, 1, 3, 4 })
add_to_2d_table(this_geometry, 206, 11, { 1, 1, 2, 3 })
add_to_2d_table(this_obj, 19, 7, { id_bhvSmbFallingPlatform, 1, 0x00040000 })
add_to_2d_table(this_obj, 20, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 23, 6, { id_bhvSmbFallingPlatform, 1, 0x00040000 })
add_to_2d_table(this_obj, 48, 3, { id_bhvSmbLoopController, 1, 0x00020006 })
add_to_2d_table(this_obj, 64, 6, { id_bhvSmbLoopController, 1, 0x00020006 })
add_to_2d_table(this_obj, 80, 10, { id_bhvSmbLoopController, 1, 0x00020006 })
add_to_2d_table(this_obj, 103, 7, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 112, 10, { id_bhvSmbLoopController, 1, 0x0006000a })
add_to_2d_table(this_obj, 128, 6, { id_bhvSmbLoopController, 1, 0x0006000a })
add_to_2d_table(this_obj, 144, 10, { id_bhvSmbLoopController, 1, 0x0006000a })
add_to_2d_table(this_obj, 182, 12, { id_bhvSmbBowserFlameFrenzy, 1 })
add_to_2d_table(this_obj, 196, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 199, 5, { id_bhvSmbBowser, 1 })
add_to_2d_table(this_obj, 205, 6, { id_bhvSmbAxe, 1 })
add_to_2d_table(this_obj, 217, 2, { id_bhvSmbMessenger, 1 })

--- 8-1 ---
geometry_data[29] = {}
obj_data[29] = {}
-- area 1
geometry_data[29][1] = { width = 25 * 16, theme = 0, bg = 3, timer = 300 }
obj_data[29][1] = {}
this_geometry = geometry_data[29][1]
this_obj = obj_data[29][1]
add_to_2d_table(this_geometry, 0, 11, { 1, -42, 1, 1 })
add_to_2d_table(this_geometry, 0, 12, { 8, -18, 5, 11 })
add_to_2d_table(this_geometry, 5, 7, { 9, -18, 2, 6 })
add_to_2d_table(this_geometry, 35, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 46, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 48, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 51, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 54, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 57, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 64, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 76, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 80, 6, { 1, 11, 1, 1 })
add_to_2d_table(this_geometry, 82, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 89, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 94, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 98, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 104, 5, { 2, 23, 2, 4 })
add_to_2d_table(this_geometry, 109, 10, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 115, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 140, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 153, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 154, 9, { 1, 3, 8, 1 })
add_to_2d_table(this_geometry, 158, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 158, 9, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 163, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 169, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 171, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 174, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 176, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 179, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 184, 6, { 1, 3, 8, 1 })
add_to_2d_table(this_geometry, 186, 6, { 1, 8, 1, 1 })
add_to_2d_table(this_geometry, 197, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 199, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 201, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 210, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 221, 0, { 5, 2, 6, 1 })
add_to_2d_table(this_geometry, 223, 6, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 237, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 238, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 240, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 242, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 244, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 246, 6, { 2, 13, 2, 5 })
add_to_2d_table(this_geometry, 275, 7, { 3, 2, 6, 6 })
add_to_2d_table(this_geometry, 283, 6, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 290, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 291, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 295, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 296, 6, { 1, 12, 1, 1 })
add_to_2d_table(this_geometry, 303, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 307, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 314, 0, { 5, 2, 5, 1 })
add_to_2d_table(this_geometry, 316, 6, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 320, 0, { 5, 2, 4, 1 })
add_to_2d_table(this_geometry, 321, 6, { 1, 12, 2, 1 })
add_to_2d_table(this_geometry, 344, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 355, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 358, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 359, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 360, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 361, 5, { 1, 2, 1, 4 })
add_to_2d_table(this_geometry, 362, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 363, 7, { 1, 2, 1, 6 })
add_to_2d_table(this_geometry, 364, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 365, 9, { 1, 2, 2, 8 })
add_to_2d_table(this_geometry, 376, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 380, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 18, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 21, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 28, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 43, 2, { id_bhvSmbKoopa, 2 })
add_to_2d_table(this_obj, 61, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 67, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 81, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 104, 0, { id_bhvSmbExitController, 1, 0x00020007 })
add_to_2d_table(this_obj, 106, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 119, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 122, 2, { id_bhvSmbKoopa, 3 })
add_to_2d_table(this_obj, 128, 2, { id_bhvSmbKoopa, 3 })
add_to_2d_table(this_obj, 146, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 161, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 172, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 177, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 207, 2, { id_bhvSmbKoopa, 2 })
add_to_2d_table(this_obj, 230, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 254, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 255, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 262, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 272, 2, { id_bhvSmbGoomba, 2 })
add_to_2d_table(this_obj, 283, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 305, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 332, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 337, 2, { id_bhvSmbKoopa, 3 })

-- area 2 (coin row bonus area; copied from 1-2)
geometry_data[29][2] = geometry_data[2][3]
obj_data[29][2] = obj_data[2][3]

--- 8-2 ---
geometry_data[30] = {}
obj_data[30] = {}
-- area 1
geometry_data[30][1] = { width = 15 * 16, theme = 0, bg = 3 }
obj_data[30][1] = {}
this_geometry = geometry_data[30][1]
this_obj = obj_data[30][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 })
add_to_2d_table(this_geometry, 15, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 17, 5, { 3, 2, 4, 4 })
add_to_2d_table(this_geometry, 21, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 22, 6, { 1, 2, 4, 5 })
add_to_2d_table(this_geometry, 22, 9, { 3, 2, 4, 3 })
add_to_2d_table(this_geometry, 29, 5, { 1, 4, 4, 1 })
add_to_2d_table(this_geometry, 36, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 43, 9, { 1, 3, 33, 1 })
add_to_2d_table(this_geometry, 44, 2, { 1, 25, 1, 1 })
add_to_2d_table(this_geometry, 44, 9, { 1, 9, 1, 1 })
add_to_2d_table(this_geometry, 45, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 50, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 52, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 56, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 63, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 77, 5, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 78, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 84, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 85, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 93, 2, { 14, 2, 1, 1 })
add_to_2d_table(this_geometry, 93, 4, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 99, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 100, 5, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 105, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 110, 5, { 1, 3, 2, 1 })
add_to_2d_table(this_geometry, 115, 2, { 14, 2, 1, 1 })
add_to_2d_table(this_geometry, 118, 5, { 1, 3, 1, 1 })
add_to_2d_table(this_geometry, 119, 5, { 1, 2, 1, 1 })
add_to_2d_table(this_geometry, 119, 6, { 14, 2, 1, 1 })
add_to_2d_table(this_geometry, 120, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 125, 4, { 14, 2, 1, 3 })
add_to_2d_table(this_geometry, 131, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 138, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 142, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 144, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 146, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 148, 0, { 5, 2, 6, 1 })
add_to_2d_table(this_geometry, 156, 5, { 2, 23, 2, 4 })
add_to_2d_table(this_geometry, 163, 3, { 2, 13, 2, 2 })
add_to_2d_table(this_geometry, 174, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 175, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 176, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 182, 6, { 3, 2, 5, 5 })
add_to_2d_table(this_geometry, 191, 2, { 14, 2, 1, 1 })
add_to_2d_table(this_geometry, 191, 4, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 199, 4, { 3, 2, 3, 3 })
add_to_2d_table(this_geometry, 202, 0, { 5, 2, 1, 1 })
add_to_2d_table(this_geometry, 203, 6, { 1, 2, 1, 5 })
add_to_2d_table(this_geometry, 204, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 206, 9, { 1, 2, 2, 8 })
add_to_2d_table(this_geometry, 216, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 220, 6, { 8, 28, 5, 5 })
add_to_2d_table(this_obj, 18, 4, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 21, 11, { id_bhvSmbLakitu, 1 })
add_to_2d_table(this_obj, 24, 10, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 44, 2, { id_bhvSmbSpringboard, 1 })
add_to_2d_table(this_obj, 57, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 62, 0, { id_bhvSmbStopFrenzy, 1 })
add_to_2d_table(this_obj, 66, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 69, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 92, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 95, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 111, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 121, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 123, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 139, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 156, 0, { id_bhvSmbExitController, 1, 0x0002000a })
add_to_2d_table(this_obj, 170, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 172, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 175, 4, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 184, 5, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 186, 7, { id_bhvSmbGoomba, 1 })
add_to_2d_table(this_obj, 189, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 203, 7, { id_bhvSmbBouncingParatroopa, 1 })

-- area 2 (Q-shaped bonus room; copied from 4-2)
geometry_data[30][2] = geometry_data[14][4]
obj_data[30][2] = obj_data[14][4]

--- 8-3 ---
geometry_data[31] = {}
obj_data[31] = {}
-- area 1
geometry_data[31][1] = { width = 15 * 16, theme = 0, bg = 3 }
obj_data[31][1] = {}
this_geometry = geometry_data[31][1]
this_obj = obj_data[31][1]
add_to_2d_table(this_geometry, 0, 6, { 8, -18, 5, 5 })
add_to_2d_table(this_geometry, 18, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 24, 7, { 9, 2, 8, 6 })
add_to_2d_table(this_geometry, 34, 4, { 14, 2, 1, 3 })
add_to_2d_table(this_geometry, 37, 7, { 9, 2, 14, 6 })
add_to_2d_table(this_geometry, 53, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 60, 5, { 1, 3, 8, 1 })
add_to_2d_table(this_geometry, 60, 9, { 1, 3, 8, 1 })
add_to_2d_table(this_geometry, 66, 9, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 68, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 71, 5, { 6, 2, 4, 4 })
add_to_2d_table(this_geometry, 75, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 79, 7, { 9, 2, 6, 6 })
add_to_2d_table(this_geometry, 86, 3, { 14, 2, 1, 2 })
add_to_2d_table(this_geometry, 88, 7, { 9, 2, 6, 6 })
add_to_2d_table(this_geometry, 95, 4, { 1, 2, 1, 3 })
add_to_2d_table(this_geometry, 97, 7, { 9, 2, 10, 6 })
add_to_2d_table(this_geometry, 109, 5, { 1, 2, 2, 4 })
add_to_2d_table(this_geometry, 115, 5, { 1, 3, 8, 1 })
add_to_2d_table(this_geometry, 115, 9, { 1, 3, 8, 1 })
add_to_2d_table(this_geometry, 116, 9, { 1, 27, 1, 1 })
add_to_2d_table(this_geometry, 124, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 126, 5, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 128, 0, { 5, 2, 2, 1 })
add_to_2d_table(this_geometry, 132, 7, { 9, 2, 34, 6 })
add_to_2d_table(this_geometry, 168, 4, { 2, 13, 2, 3 })
add_to_2d_table(this_geometry, 172, 7, { 9, 2, 20, 6 })
add_to_2d_table(this_geometry, 190, 5, { 1, 7, 1, 1 })
add_to_2d_table(this_geometry, 195, 3, { 1, 2, 1, 2 })
add_to_2d_table(this_geometry, 197, 0, { 5, 2, 11, 1 })
add_to_2d_table(this_geometry, 198, 3, { 1, 2, 1, 1 })
add_to_2d_table(this_geometry, 200, 5, { 1, 2, 1, 1 })
add_to_2d_table(this_geometry, 202, 7, { 1, 2, 1, 1 })
add_to_2d_table(this_geometry, 204, 9, { 1, 2, 2, 1 })
add_to_2d_table(this_geometry, 214, 12, { 7, 2, 1, 11 })
add_to_2d_table(this_geometry, 220, 12, { 8, 28, 9, 11 })
add_to_2d_table(this_geometry, 222, 11, { 1, -42, 1, 1 })
add_to_2d_table(this_obj, 30, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 63, 2, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 65, 6, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 93, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 117, 6, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 119, 2, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 137, 2, { id_bhvSmbKoopa, 1 })
add_to_2d_table(this_obj, 146, 2, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 159, 2, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 177, 2, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 185, 2, { id_bhvSmbHammerBro, 1 })

--- 8-4 ---
geometry_data[32] = {}
obj_data[32] = {}
-- area 1
geometry_data[32][1] = { width = 20 * 16, scrollStop = 20 * 16 - 1, theme = 2, bg = 0 }
obj_data[32][1] = {}
this_geometry = geometry_data[32][1]
this_obj = obj_data[32][1]
add_to_2d_table(this_geometry, 0, 0, { 0, 1, 5, 1 })
add_to_2d_table(this_geometry, 0, 7, { 6, 1, 5, 3 })
add_to_2d_table(this_geometry, 6, 0, { 5, 2, 5, 1 })
add_to_2d_table(this_geometry, 6, 1, { 11, 2, 5, 2 })
add_to_2d_table(this_geometry, 11, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 19, 3, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 51, 3, { 2, 23, 2, 4 })
add_to_2d_table(this_geometry, 62, 0, { 0, 1, 5, 1 })
add_to_2d_table(this_geometry, 66, 0, { 5, 2, 9, 1 })
add_to_2d_table(this_geometry, 66, 1, { 11, 2, 9, 2 })
add_to_2d_table(this_geometry, 76, 8, { 1, 1, 4, 1 })
add_to_2d_table(this_geometry, 81, 6, { 2, 23, 2, 7 })
add_to_2d_table(this_geometry, 90, 7, { 2, 13, 2, 8 })
add_to_2d_table(this_geometry, 96, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 115, 3, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 122, 4, { 2, 13, 2, 5 })
add_to_2d_table(this_geometry, 132, 3, { 2, 23, 2, 4 })
add_to_2d_table(this_geometry, 142, 4, { 2, 13, 2, 5 })
add_to_2d_table(this_geometry, 144, 0, { 5, 2, 3, 1 })
add_to_2d_table(this_geometry, 144, 1, { 11, 2, 3, 2 })
add_to_2d_table(this_geometry, 150, 5, { 1, 10, 1, 1 })
add_to_2d_table(this_geometry, 152, 5, { 1, 1, 2, 1 })
add_to_2d_table(this_geometry, 152, 8, { 2, 23, 2, 3 })
add_to_2d_table(this_geometry, 195, 3, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 198, 0, { 0, 1, 5, 1 })
add_to_2d_table(this_geometry, 204, 6, { 2, 13, 2, 7 })
add_to_2d_table(this_geometry, 212, 7, { 2, 23, 2, 8 })
add_to_2d_table(this_geometry, 220, 0, { 5, 2, 4, 1 })
add_to_2d_table(this_geometry, 220, 1, { 11, 2, 4, 2 })
add_to_2d_table(this_geometry, 228, 6, { 2, 23, 2, 7 })
add_to_2d_table(this_geometry, 256, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 259, 3, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 266, 3, { 2, 23, 2, 4 })
add_to_2d_table(this_geometry, 277, 0, { 5, 2, 5, 1 })
add_to_2d_table(this_geometry, 277, 1, { 11, 2, 5, 2 })
add_to_2d_table(this_geometry, 282, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 288, 0, { 0, 1, 0, 1 })
add_to_2d_table(this_geometry, 288, 1, { 11, 2, 13, 2 })
add_to_2d_table(this_geometry, 288, 4, { 1, 37, 13, 1 })
add_to_2d_table(this_geometry, 301, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 301, 5, { 1, 1, 3, 4 })
add_to_2d_table(this_geometry, 302, 11, { 1, 1, 2, 3 })
add_to_2d_table(this_obj, 51, 0, { id_bhvSmbExitController, 0, 0x01010100 })
add_to_2d_table(this_obj, 54, 2, { id_bhvSmbGoomba, 3 })
add_to_2d_table(this_obj, 71, 1, { id_bhvSmbMovingPlatform, 1, 0x00040000 })
add_to_2d_table(this_obj, 81, 0, { id_bhvSmbExitController, 0, 0x01010700 })
add_to_2d_table(this_obj, 87, 0, { id_bhvSmbLoopController, 1, 0x00020006 })
add_to_2d_table(this_obj, 128, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 130, 2, { id_bhvSmbBuzzyBeetle, 1 })
add_to_2d_table(this_obj, 132, 0, { id_bhvSmbExitController, 1, 0x01010100 })
add_to_2d_table(this_obj, 139, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 141, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 152, 0, { id_bhvSmbExitController, 1, 0x01010c00 })
add_to_2d_table(this_obj, 155, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 157, 2, { id_bhvSmbBouncingParatroopa, 1 })
add_to_2d_table(this_obj, 167, 0, { id_bhvSmbLoopController, 1, 0x0107000b })
add_to_2d_table(this_obj, 212, 0, { id_bhvSmbExitController, 1, 0x01010100 })
add_to_2d_table(this_obj, 221, 0, { id_bhvSmbFlyingFishFrenzy, 1 })
add_to_2d_table(this_obj, 228, 0, { id_bhvSmbExitController, 1, 0x01020010 })
add_to_2d_table(this_obj, 234, 0, { id_bhvSmbStopFrenzy, 1 })
add_to_2d_table(this_obj, 247, 0, { id_bhvSmbLoopController, 1, 0x000c0010 })
add_to_2d_table(this_obj, 266, 0, { id_bhvSmbExitController, 1, 0x01010100 })
add_to_2d_table(this_obj, 273, 2, { id_bhvSmbHammerBro, 1 })
add_to_2d_table(this_obj, 279, 2, { id_bhvSmbPodoboo, 1 })
add_to_2d_table(this_obj, 295, 5, { id_bhvSmbBowser, 1 })
add_to_2d_table(this_obj, 301, 6, { id_bhvSmbAxe, 1 })
add_to_2d_table(this_obj, 313, 2, { id_bhvSmbMessenger, 1 })

-- area 2 (water section)
geometry_data[32][2] = { width = 5 * 16 - 8, scrollStop = 5 * 16 - 9, theme = 3, bg = 4 }
obj_data[32][2] = {}
this_geometry = geometry_data[32][2]
this_obj = obj_data[32][2]
add_to_2d_table(this_geometry, 0, 12, { 1, 1, 2, 11 })
add_to_2d_table(this_geometry, 3, 3, { 2, 13, 2, 4 })
add_to_2d_table(this_geometry, 6, 0, { 0, 1, 5, 3 })
add_to_2d_table(this_geometry, 11, 0, { 0, 1, 6, 4 })
add_to_2d_table(this_geometry, 18, 0, { 0, 1, 2, 1 })
add_to_2d_table(this_geometry, 39, 4, { 1, 1, 3, 3 })
add_to_2d_table(this_geometry, 39, 11, { 1, 1, 3, 3 })
add_to_2d_table(this_geometry, 67, 0, { 0, 1, 6, 4 })
add_to_2d_table(this_geometry, 68, 7, { 4, 2, 1, 2 })
add_to_2d_table(this_geometry, 69, 0, { 0, 1, 6, 7 })
add_to_2d_table(this_obj, 20, 7, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 28, 2, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 31, 4, { id_bhvSmbFireBarBase, 1, 0x00000001 })
add_to_2d_table(this_obj, 40, 8, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 51, 3, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 53, 7, { id_bhvSmbBlooper, 1 })
add_to_2d_table(this_obj, 56, 6, { id_bhvSmbFireBarBase, 1 })
add_to_2d_table(this_obj, 64, 7, { id_bhvSmbFireBarBase, 1, 0x00000001 })